VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "odbc"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private g_sErrInfo As String, _
        g_bCancel As Boolean

Private g_nConnTimeout As Integer, g_nCmdTimeout As Integer

Public Event Status(sStatusInfo As String, ByRef bCancel As Boolean)

Public Property Get ErrInfo() As String
    ErrInfo = g_sErrInfo
End Property

Public Function AddDsn(sDsn As String, sDriver As String, _
                       sPathOrServer As String, Optional sAddAttrib As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
    
    If (sDsn = "" Or sDriver = "" Or sPathOrServer = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        AddDsn = 1
        Exit Function
    End If
       
    Dim sAttributes As String, bRet As Boolean
    
    If (sDriver = ACCESS_DRIVER Or sDriver = TEXT_DRIVER) Then
        sAttributes = "DSN=" & sDsn & vbNullChar & _
                      "DBQ=" & sPathOrServer & vbNullChar & sAddAttrib & _
                      vbNullChar & vbNullChar '// terminate with two null chars
    Else
        sAttributes = "DSN=" & sDsn & vbNullChar & _
                      "Server=" & sPathOrServer & vbNullChar & sAddAttrib & _
                      vbNullChar & vbNullChar '// terminate with two null chars
    End If
    
    bRet = SQLConfigDataSource(0&, ODBC_ADD_SYS_DSN, sDriver, sAttributes)
    
    If (bRet) Then
        AddDsn = 0
    Else
        AddDsn = 1
    End If
    
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    AddDsn = 1
End Function

Public Function ModifyDsn(sDsn As String, sDriver As String, _
                       sPathOrServer As String, Optional sAddAttrib As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
    
    If (sDsn = "" Or sDriver = "" Or sPathOrServer = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        ModifyDsn = 1
        Exit Function
    End If
       
    Dim sAttributes As String, bRet As Boolean
    
    If (sDriver = ACCESS_DRIVER Or sDriver = TEXT_DRIVER) Then
        sAttributes = "DSN=" & sDsn & vbNullChar & _
                      "DBQ=" & sPathOrServer & vbNullChar & sAddAttrib & _
                      vbNullChar & vbNullChar '// terminate with two null chars
    Else
        sAttributes = "DSN=" & sDsn & vbNullChar & _
                      "Server=" & sPathOrServer & vbNullChar & sAddAttrib & _
                      vbNullChar & vbNullChar '// terminate with two null chars

    End If
    
    bRet = SQLConfigDataSource(0&, ODBC_CONFIG_SYS_DSN, sDriver, sAttributes)
    
    If (bRet) Then
        ModifyDsn = 0
    Else
        ModifyDsn = 1
    End If
    
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    ModifyDsn = 1
End Function

Public Function RemoveDsn(sDsn As String, sDriver As String, sPathOrServer As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
    
    If (sDsn = "" Or sDriver = "" Or sPathOrServer = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        RemoveDsn = 1
        Exit Function
    End If
       
    Dim sAttributes As String, bRet As Boolean
    
    If (sDriver = ACCESS_DRIVER Or sDriver = TEXT_DRIVER) Then
        sAttributes = "DSN=" & sDsn & vbNullChar & _
                      vbNullChar '// terminate with two null chars
    Else
        sAttributes = "DSN=" & sDsn & vbNullChar & _
                      vbNullChar '// terminate with two null chars
    End If
    
    bRet = SQLConfigDataSource(0&, ODBC_REMOVE_SYS_DSN, sDriver, sAttributes)
    
    If (bRet) Then
        RemoveDsn = 0
    Else
        RemoveDsn = 1
    End If
    
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    RemoveDsn = 1
End Function

