VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "sqlCmd"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private g_sErrInfo As String, _
        g_bCancel As Boolean

Private g_nConnTimeout As Integer, g_nCmdTimeout As Integer

Public Event Status(sStatusInfo As String, ByRef bCancel As Boolean)

Public Property Get ErrInfo() As String
    ErrInfo = g_sErrInfo
End Property

Public Property Get ConnTimeout() As Integer
    ConnTimeout = g_nConnTimeout
End Property

Public Property Let ConnTimeout(ByVal nNewValue As Integer)
    g_nConnTimeout = nNewValue
End Property

Public Property Get CmdTimeout() As Integer
    CmdTimeout = g_nCmdTimeout
End Property

Public Property Let CmdTimeout(ByVal nNewValue As Integer)
    g_nCmdTimeout = nNewValue
End Property

Public Function ExecWoRs(sDsn As String, sDboId As String, sDboPwd As String, sDatabase As String, sSqlCmd As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
    
    If (sDsn = "" Or sDboId = "" Or sDboPwd = "" Or sDatabase = "" Or sSqlCmd = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        ExecWoRs = 1
        Exit Function
    End If
    
    Dim oDbConn As Object, oDbCmd As Object, oDbRs As Object, _
        sApp As String, sWsid As String, sConnectionString As String, _
        nConnectionTimeout As Integer, nCommandTimeout As Integer
    
    Set oDbConn = CreateObject("ADODB.Connection")
    Set oDbCmd = CreateObject("ADODB.Command")
    Set oDbRs = CreateObject("ADODB.Recordset")
    
    sApp = "adoApp"
    sWsid = "adoWsid"
    
    sConnectionString = "DSN=" & sDsn & ";" & _
                        "UID=" & sDboId & ";" & _
                        "APP=" & sApp & ";" & _
                        "WSID=" & sWsid & ";" & _
                        "DATABASE=" & sDatabase
    
    oDbConn.ConnectionTimeout = g_nConnTimeout
    oDbConn.CommandTimeout = g_nCmdTimeout
    Call oDbConn.Open(sConnectionString, sDboId, sDboPwd)
    oDbCmd.ActiveConnection = oDbConn
    oDbCmd.CommandText = sSqlCmd
    Set oDbRs = oDbCmd.Execute
    
    ExecWoRs = 0 '// no way to tell if this failed looking at oDbRs
    
    '// oDbRs.Close - this will always fail since oDbRs doesn't get set on ExecWoRs calls
    oDbConn.Close
    Set oDbRs = Nothing
    Set oDbCmd = Nothing
    Set oDbConn = Nothing
    
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    ExecWoRs = 1
End Function

Public Function ExecWRs(sDsn As String, sDboId As String, sDboPwd As String, _
                sDatabase As String, sSqlCmd As String, oDbRs As Variant, _
                Optional iCursorType As Integer, Optional iLockType As Integer) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
    
    If (sDsn = "" Or sDboId = "" Or sDboPwd = "" Or sDatabase = "" Or sSqlCmd = "" Or oDbRs.State) Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        ExecWRs = 1
        Exit Function
    End If

    Dim oDbConn As Object, _
        sApp As String, sWsid As String, sConnectionString As String, _
        nConnectionTimeout As Integer, nCommandTimeout As Integer
    
    Set oDbConn = CreateObject("ADODB.Connection")
    '// no need to create oDbRs since it should already be setup when passed to method
    '// Set oDbRs = CreateObject("ADODB.Recordset")

    sApp = "adoApp"
    sWsid = "adoWsid"
    
    If (iCursorType = 0) Then iCursorType = adOpenForwardOnly
    If (iLockType = 0) Then iLockType = adLockReadOnly
    
    sConnectionString = "DSN=" & sDsn & ";" & _
                        "UID=" & sDboId & ";" & _
                        "APP=" & sApp & ";" & _
                        "WSID=" & sWsid & ";" & _
                        "DATABASE=" & sDatabase
    
    oDbConn.ConnectionTimeout = g_nConnTimeout
    oDbConn.CommandTimeout = g_nCmdTimeout
    Call oDbConn.Open(sConnectionString, sDboId, sDboPwd)
    '// oDbCmd.ActiveConnection = oDbConn
    '// oDbCmd.CommandText = sSqlCmd
    '// Set oDbRs = oDbCmd.Execute
    Call oDbRs.Open(sSqlCmd, oDbConn, iCursorType, iLockType)
    
    If (oDbRs.State) Then
        ExecWRs = 0
    Else
        ExecWRs = 1
    End If
    
    '// oDbRs.Close - don't do this since we are returning the oDbRs
    '// oDbConn.Close - don't do this since it intrisically closes oDbRs
    '// Set oDbRs = Nothing - don't do this since we are returning the oDbRs
    Set oDbConn = Nothing
    
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    ExecWRs = 1
End Function
