VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "group"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Dim g_sErrInfo As String
Dim g_bCancel As Boolean

Public Event Status(sStatusInfo As String, ByRef bCancel As Boolean)

Public Property Get ErrInfo() As String
    ErrInfo = g_sErrInfo
End Property
   
Function Create(sGroup As String, sDescription As String, _
                Optional sNameSpace As String, Optional sDomain As String, Optional sMachineName As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
    
    If (sGroup = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        Create = 1
        Exit Function
    End If
    
    If (sNameSpace = "") Then
        sNameSpace = NS_WNT
    End If
       
    Dim oSecurityList As IADs, oGroup As IADs
    
    If Not (sDomain = "") Then
        Set oSecurityList = GetObject(sNameSpace & "://" & sDomain)
    Else
        If (sMachineName = "") Then
            sMachineName = Environ("COMPUTERNAME")
        End If
        Set oSecurityList = GetObject(sNameSpace & "://" & sMachineName)
    End If
        
    Set oGroup = oSecurityList.Create("Group", sGroup)
    oGroup.Description = sDescription
    Call oGroup.SetInfo  '// commit create
    
    Set oGroup = Nothing
    Set oSecurityList = Nothing
    Create = 0
    
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    Set oGroup = Nothing
    Set oSecurityList = Nothing
    Create = 1
End Function

Function Delete(sGroup As String, _
                Optional sNameSpace As String, Optional sDomain As String, Optional sMachineName As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
    
    If (sGroup = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        Delete = 1
        Exit Function
    End If
       
    If (sNameSpace = "") Then
        sNameSpace = NS_WNT
    End If
       
    Dim oSecurityList As IADs, oGroup As IADs
    
    If Not (sDomain = "") Then
        Set oSecurityList = GetObject(sNameSpace & "://" & sDomain)
    Else
        If (sMachineName = "") Then
            sMachineName = Environ("COMPUTERNAME")
        End If
        Set oSecurityList = GetObject(sNameSpace & "://" & sMachineName)
    End If
        
    Call oSecurityList.Delete("Group", sGroup)
    
    Set oGroup = Nothing
    Set oSecurityList = Nothing
    Delete = 0
    
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    Set oGroup = Nothing
    Set oSecurityList = Nothing
    Delete = 1
End Function

Function Exists(sGroup As String, _
                Optional sNameSpace As String, Optional sDomain As String, Optional sMachineName As String) As Boolean
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
    
    If (sGroup = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        Exists = 0
        Exit Function
    End If
    
    If (sNameSpace = "") Then
        sNameSpace = NS_WNT
    End If
       
    Dim oSecurityList As IADs, oGroup As IADs, bExists As Boolean
    
    If Not (sDomain = "") Then
        Set oSecurityList = GetObject(sNameSpace & "://" & sDomain)
    Else
        If (sMachineName = "") Then
            sMachineName = Environ("COMPUTERNAME")
        End If
        Set oSecurityList = GetObject(sNameSpace & "://" & sMachineName)
    End If

    bExists = False
    For Each oGroup In oSecurityList
        If (oGroup.Class = "Group") Then
            If (oGroup.Name = sGroup) Then
                bExists = True
            End If
        End If
    Next '// oSecurityList item
    
    Set oGroup = Nothing
    Set oSecurityList = Nothing
    
    If (bExists) Then
        Exists = 1
    Else
        Exists = 0
    End If
    
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    Set oGroup = Nothing
    Set oSecurityList = Nothing
    Exists = 0
End Function

Function Modify(sGroup As String, sDescription As String, _
                Optional sNameSpace As String, Optional sDomain As String, Optional sMachineName As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
    
    If (sGroup = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        Modify = 1
        Exit Function
    End If
    
    If (sNameSpace = "") Then
        sNameSpace = NS_WNT
    End If
       
    Dim oSecurityList As IADs, oGroup As IADs
    
    If Not (sDomain = "") Then
        Set oSecurityList = GetObject(sNameSpace & "://" & sDomain)
    Else
        If (sMachineName = "") Then
            sMachineName = Environ("COMPUTERNAME")
        End If
        Set oSecurityList = GetObject(sNameSpace & "://" & sMachineName)
    End If
    
    Set oGroup = GetObject(oSecurityList.AdsPath & "/" & sGroup)
    If Not (sDescription = "") Then
        oGroup.Description = sDescription
    End If
    Call oGroup.SetInfo  '// commit new description setting
    
    Set oGroup = Nothing
    Set oSecurityList = Nothing
    Modify = 0
    
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    Set oGroup = Nothing
    Set oSecurityList = Nothing
    Modify = 1
End Function

Function GroupUser(sGroup As String, sUserId As String, bAddOrRemove As Boolean, _
                   Optional sNameSpace As String, Optional sDomain As String, Optional sMachineName As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
    
    If (sUserId = "" Or sGroup = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        GroupUser = 1
        Exit Function
    End If
    
    If (sNameSpace = "") Then
        sNameSpace = NS_WNT
    End If
       
    Dim oSecurityList As IADs, oUser As IADs, oGroup As IADs
    
    If Not (sDomain = "") Then
        Set oSecurityList = GetObject(sNameSpace & "://" & sDomain)
    Else
        If (sMachineName = "") Then
            sMachineName = Environ("COMPUTERNAME")
        End If
        Set oSecurityList = GetObject(sNameSpace & "://" & sMachineName)
    End If
    
    Set oUser = GetObject(oSecurityList.AdsPath & "/" & sUserId)
    Set oGroup = GetObject(oSecurityList.AdsPath & "/" & sGroup)
    
    If (bAddOrRemove) Then
        Call oGroup.Add(oUser.AdsPath) '// add the user
    Else
        Call oGroup.Remove(oUser.AdsPath)  '// remove the user
    End If
    
    Set oUser = Nothing
    Set oGroup = Nothing
    Set oSecurityList = Nothing
    GroupUser = 0
    
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    Set oUser = Nothing
    Set oGroup = Nothing
    Set oSecurityList = Nothing
    GroupUser = 1
End Function
