Attribute VB_Name = "include"
Option Explicit

'// ActiveDs NameSpace options
Public Const NS_WNT = "WinNT"   '// Wnt40 Registry or Wnt50 Directory provider
Public Const NS_MBS = "Mbs"     '// SiteServer Membership20 provider
Public Const NS_LDAP = "Ldap"   '// Ldap security provider
Public Const NS_NDS = "Nds"     '// Netware NDS provider
Public Const NS_UNIX = "Unix"   '// Solaris or Linux /etc/passwd, shadow provider
Public Const NS_IIS = "IIS"     '// NtOptPack10 - IIS provider

'// CreateFile-lpFileName and LookupAccountName-avSid/achRefDomainName sizes
Public Const MAX_PATH = 260
Public Const MAX_BUFF = 256
Public Const SVCSTAT_PAUSE_TIME = 3 '// seconds

'// CreateFile dwDesiredAccess values
'// note: be careful if these values need to be Or'd since they will exceed max Long value
Public Const GENERIC_READ = &H80000000
Public Const GENERIC_WRITE = &H40000000
Public Const GENERIC_EXECUTE = &H20000000
Public Const GENERIC_ALL = &H10000000

'// CreateFile dwShareMode values
Public Const FILE_SHARE_NO = &H0
Public Const FILE_SHARE_READ = &H1
Public Const FILE_SHARE_WRITE = &H2
Public Const FILE_SHARE_DELETE = &H4

'// CreateFile lpSecurityAttribtutes structure
Public Type stSecurityAttributes
        nLength As Long '// 4 bytes
        lpSecurityDescriptor As Long '// 4 bytes
        bInheritHandle As Boolean '// 2 bytes
End Type
Public Const CB_SECURITY_ATTRIBUTES = 10 '// 4 + 4 + 2

'// CreateFile dwCreationDisposition values
Public Const CREATE_NEW = 1
Public Const CREATE_ALWAYS = 2
Public Const OPEN_EXISTING = 3
Public Const OPEN_ALWAYS = 4
Public Const TRUNCATE_EXISTING = 5

'// CreateFile dwFileDisposition values
Public Const FILE_ATTRIBUTE_READONLY = &H1
Public Const FILE_ATTRIBUTE_HIDDEN = &H2
Public Const FILE_ATTRIBUTE_SYSTEM = &H4
Public Const FILE_ATTRIBUTE_DIRECTORY = &H10
Public Const FILE_ATTRIBUTE_ARCHIVE = &H20
Public Const FILE_ATTRIBUTE_NORMAL = &H80
Public Const FILE_ATTRIBUTE_TEMPORARY = &H100
Public Const FILE_ATTRIBUTE_COMPRESSED = &H800
Public Const FILE_ATTRIBUTE_OFFLINE = &H1000

'// CreateFile return codes
Public Const INVALID_HANDLE_VALUE = -1

'// GetLastError return codes
Public Const ERROR_SUCCESS = 0
Public Const ERROR_FILE_NOT_FOUND = 2&
Public Const ERROR_ALREADY_EXISTS = 183&

'// icuAds.acls.Modify dwAccessMask values
Public Const ACCESS_READ = &H1
Public Const ACCESS_WRITE = &H2
Public Const ACCESS_EXECUTE = &H4
Public Const ACCESS_DELETE = &H8
Public Const ACCESS_ALL = &H10

'// icuAds.acls.Modify dwAccessMode values
Public Enum enAccessMode
    NOT_USED_ACCESS = 0
    GRANT_ACCESS '// combines the specified rights with any existing allowed or denied rights of the trustee
    SET_ACCESS '// this flag sets the value discarding all existing access-control information for the trustee
    DENY_ACCESS '// this flag denies the specified rights in addition to any currently denied rights of the trustee
    REVOKE_ACCESS '// this flag sets the value removing all existing access-control information for the trustee
End Enum

Public Declare Function _
    CreateFile Lib "kernel32" Alias "CreateFileA" _
    (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, _
    lpSecurityAttributes As stSecurityAttributes, _
    ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, _
    ByVal hTemplateFile As Long) _
    As Long
        
Public Declare Function _
    CloseHandle Lib "kernel32" _
    (ByVal hObject As Long) _
    As Boolean

Public Declare Function _
    GetLastError Lib "kernel32" _
    () _
    As Long

Public Declare Function _
    LoadLibrary Lib "kernel32" Alias "LoadLibraryA" _
    (ByVal pszFileName As String) _
    As Long
    
Public Declare Function _
    AclModify Lib "icuUtils.dll" Alias "_AclModify@20" _
    (ByVal lpszFileOrFolder As String, ByVal lpszUserIdOrGroup As String, _
    ByVal dwAccessMask As Long, ByVal dwAccessMode As Long, ByVal bFile As Boolean) _
    As Long

Public Declare Function _
    FreeLibrary Lib "kernel32" (ByVal hModule As Long) As Long


    
