VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "service"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Dim g_sErrInfo As String
Dim g_bCancel As Boolean

Public Event Status(sStatusInfo As String, ByRef bCancel As Boolean)

Public Property Get ErrInfo() As String
    ErrInfo = g_sErrInfo
End Property
   
Function SvcStart(sService As String, _
                  Optional sNameSpace As String, Optional sDomain As String, Optional sMachineName As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
    
    If (sService = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        SvcStart = 1
        Exit Function
    End If
    
    If (sNameSpace = "") Then
        sNameSpace = NS_WNT
    End If
       
    Dim oMachine As IADs, oService As IADs, lRet As Long, _
        lStart As Long, lFinish As Long, lPauseTime As Long
    
    If (sMachineName = "") Then
        sMachineName = Environ("COMPUTERNAME")
    End If
    
    If Not (sDomain = "") Then
        Set oMachine = GetObject(sNameSpace & "://" & sDomain & "/" & sMachineName)
    Else
        Set oMachine = GetObject(sNameSpace & "://" & sMachineName)
    End If
        
    Set oService = GetObject(oMachine.AdsPath & "/" & sService)
    oService.Start
    
    lStart = Timer
    While Timer < lStart + SVCSTAT_PAUSE_TIME
        DoEvents '// Yield to other processes.
    Wend
    lFinish = Timer '// Set end time.
    lPauseTime = lFinish - lStart  '// Calculate total time paused, just for fun

    lRet = oService.Status
    Set oService = Nothing
    Set oMachine = Nothing
    
    SvcStart = lRet
    
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    Set oService = Nothing
    Set oMachine = Nothing
    SvcStart = 1
End Function

Function SvcStop(sService As String, _
                 Optional sNameSpace As String, Optional sDomain As String, Optional sMachineName As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
    
    If (sService = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        SvcStop = 1
        Exit Function
    End If
    
    If (sNameSpace = "") Then
        sNameSpace = NS_WNT
    End If
       
    Dim oMachine As IADs, oService As IADs, lRet As Long, _
        lStart As Long, lFinish As Long, lPauseTime As Long
    
    If (sMachineName = "") Then
        sMachineName = Environ("COMPUTERNAME")
    End If
    
    If Not (sDomain = "") Then
        Set oMachine = GetObject(sNameSpace & "://" & sDomain & "/" & sMachineName)
    Else
        Set oMachine = GetObject(sNameSpace & "://" & sMachineName)
    End If
        
    Set oService = GetObject(oMachine.AdsPath & "/" & sService)
    oService.Stop
    
    lStart = Timer
    While Timer < lStart + SVCSTAT_PAUSE_TIME
        DoEvents '// Yield to other processes.
    Wend
    lFinish = Timer '// Set end time.
    lPauseTime = lFinish - lStart  '// Calculate total time paused, just for fun

    lRet = oService.Status
    Set oService = Nothing
    Set oMachine = Nothing
    
    SvcStop = lRet
    
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    Set oService = Nothing
    Set oMachine = Nothing
    SvcStop = 1
End Function

Function SvcStatus(sService As String, _
                   Optional sNameSpace As String, Optional sDomain As String, Optional sMachineName As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
    
    If (sService = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        SvcStatus = 1
        Exit Function
    End If
    
    If (sNameSpace = "") Then
        sNameSpace = NS_WNT
    End If
       
    Dim oMachine As IADs, oService As IADs, lRet As Long, _
        lStart As Long, lFinish As Long, lPauseTime As Long
    
    If (sMachineName = "") Then
        sMachineName = Environ("COMPUTERNAME")
    End If
    
    If Not (sDomain = "") Then
        Set oMachine = GetObject(sNameSpace & "://" & sDomain & "/" & sMachineName)
    Else
        Set oMachine = GetObject(sNameSpace & "://" & sMachineName)
    End If
        
    Set oService = GetObject(oMachine.AdsPath & "/" & sService)
    lRet = oService.Status
    Set oService = Nothing
    Set oMachine = Nothing
    
    SvcStatus = lRet
    
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    Set oService = Nothing
    Set oMachine = Nothing
    SvcStatus = 1
End Function


