VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "user"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Dim g_sErrInfo As String
Dim g_bCancel As Boolean

Public Event Status(sStatusInfo As String, ByRef bCancel As Boolean)

Public Property Get ErrInfo() As String
    ErrInfo = g_sErrInfo
End Property
   
Function Create(sUserId As String, sPassword As String, sFullName As String, sDescription As String, _
                Optional sNameSpace As String, Optional sDomain As String, Optional sMachineName As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
    
    If (sUserId = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        Create = 1
        Exit Function
    End If
    
    If (sNameSpace = "") Then
        sNameSpace = NS_WNT
    End If
       
    Dim oSecurityList As IADs, oUser As IADs
    
    If Not (sDomain = "") Then
        Set oSecurityList = GetObject(sNameSpace & "://" & sDomain)
    Else
        If (sMachineName = "") Then
            sMachineName = Environ("COMPUTERNAME")
        End If
        Set oSecurityList = GetObject(sNameSpace & "://" & sMachineName)
    End If
        
    Set oUser = oSecurityList.Create("User", sUserId)
    oUser.FullName = sFullName
    oUser.Description = sDescription
    Call oUser.SetInfo  '// commit create
    Call oUser.SetPassword(sPassword)
    
    Set oUser = Nothing
    Set oSecurityList = Nothing
    Create = 0
    
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    Set oUser = Nothing
    Set oSecurityList = Nothing
    Create = 1
End Function

Function Delete(sUserId As String, _
                Optional sNameSpace As String, Optional sDomain As String, Optional sMachineName As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
    
    If (sUserId = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        Delete = 1
        Exit Function
    End If
       
    If (sNameSpace = "") Then
        sNameSpace = NS_WNT
    End If
       
    Dim oSecurityList As IADs, oUser As IADs
    
    If Not (sDomain = "") Then
        Set oSecurityList = GetObject(sNameSpace & "://" & sDomain)
    Else
        If (sMachineName = "") Then
            sMachineName = Environ("COMPUTERNAME")
        End If
        Set oSecurityList = GetObject(sNameSpace & "://" & sMachineName)
    End If
        
    Call oSecurityList.Delete("User", sUserId)
    
    Set oUser = Nothing
    Set oSecurityList = Nothing
    Delete = 0
    
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    Set oUser = Nothing
    Set oSecurityList = Nothing
    Delete = 1
End Function

Function Exists(sUserId As String, _
                Optional sNameSpace As String, Optional sDomain As String, Optional sMachineName As String) As Boolean
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
    
    If (sUserId = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        Exists = 0
        Exit Function
    End If
    
    If (sNameSpace = "") Then
        sNameSpace = NS_WNT
    End If
       
    Dim oSecurityList As IADs, oUser As IADs, bExists As Boolean
    
    If Not (sDomain = "") Then
        Set oSecurityList = GetObject(sNameSpace & "://" & sDomain)
    Else
        If (sMachineName = "") Then
            sMachineName = Environ("COMPUTERNAME")
        End If
        Set oSecurityList = GetObject(sNameSpace & "://" & sMachineName)
    End If

    bExists = False
    For Each oUser In oSecurityList
        If (oUser.Class = "User") Then
            If (oUser.Name = sUserId) Then
                bExists = True
            End If
        End If
    Next '// oSecurityList item
    
    Set oUser = Nothing
    Set oSecurityList = Nothing
    
    If (bExists) Then
        Exists = 1
    Else
        Exists = 0
    End If
    
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    Set oUser = Nothing
    Set oSecurityList = Nothing
    Exists = 0
End Function

Function Modify(sUserId As String, sPassword As String, sFullName As String, sDescription As String, _
                Optional sNameSpace As String, Optional sDomain As String, Optional sMachineName As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
    
    If (sUserId = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        Modify = 1
        Exit Function
    End If
    
    If (sNameSpace = "") Then
        sNameSpace = NS_WNT
    End If
       
    Dim oSecurityList As IADs, oUser As IADs
    
    If Not (sDomain = "") Then
        Set oSecurityList = GetObject(sNameSpace & "://" & sDomain)
    Else
        If (sMachineName = "") Then
            sMachineName = Environ("COMPUTERNAME")
        End If
        Set oSecurityList = GetObject(sNameSpace & "://" & sMachineName)
    End If
    
    Set oUser = GetObject(oSecurityList.AdsPath & "/" & sUserId)
    If Not (sFullName = "") Then
        oUser.FullName = sFullName
    End If
    If Not (sDescription = "") Then
        oUser.Description = sDescription
    End If
    Call oUser.SetInfo  '// commit new password setting
    If Not (sPassword = "") Then
        Call oUser.SetPassword(sPassword)
    End If
    
    Set oUser = Nothing
    Set oSecurityList = Nothing
    Modify = 0
    
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    Set oUser = Nothing
    Set oSecurityList = Nothing
    Modify = 1
End Function
