VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "mailCmd"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Dim g_sErrInfo As String
Dim g_bCancel As Boolean

Public Event Status(sStatusInfo As String, ByRef bCancel As Boolean)

Public Property Get ErrInfo() As String
    ErrInfo = g_sErrInfo
End Property

Function NewMailWoAttach(sFrom As String, sTo As String, sSubject As String, sBody As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
    
    If (sFrom = "" Or sTo = "" Or sSubject = "" Or sBody = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        NewMailWoAttach = 1
        Exit Function
    End If
    
    Dim oNewMail As Object
    Set oNewMail = CreateObject("CDONTS.NewMail")
        
    oNewMail.From = sFrom
    oNewMail.To = sTo
    oNewMail.Subject = sSubject
    oNewMail.Body = sBody
    Call oNewMail.Send
        
    Set oNewMail = Nothing
    
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    NewMailWoAttach = 1
End Function

Public Function NewMailWAttach(sFrom As String, sTo As String, sSubject As String, sBody As String, sFileOrFolder As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
    
    If (sFrom = "" Or sTo = "" Or sSubject = "" Or sBody = "" Or sFileOrFolder = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        NewMailWAttach = 1
        Exit Function
    End If
                        
    Dim oFs As Object, oFolder As Object, oFile As Object, _
        sFolder As String, sWildCard As String, _
        iStart As Integer, iEnd As Integer, bDone As Boolean, _
        bFound As Boolean, bAllFiles As Boolean, bWildCardMatch As Boolean, _
        lRet As Long
            
    Dim oNewMail As Object
    
    Set oNewMail = CreateObject("CDONTS.NewMail")
    oNewMail.From = sFrom
    oNewMail.To = sTo
    oNewMail.Subject = sSubject
    oNewMail.Body = sBody
    
    Set oFs = CreateObject("Scripting.FileSystemObject")
    bFound = True
    bAllFiles = False
    bWildCardMatch = False
    
    If (oFs.FileExists(sFileOrFolder)) Then '// user provided a single file name
        bFound = True
        '// Attach File to email
        Call oNewMail.AttachFile(sFileOrFolder)
                                
    ElseIf (oFs.FolderExists(sFileOrFolder)) Then '// user provided a folder name
        bFound = True
        Set oFolder = oFs.GetFolder(sFileOrFolder)
        For Each oFile In oFolder.Files
            '// Attach File to email
            Call oNewMail.AttachFile(oFile.Path)
        Next '// oFile
        
    Else '// user may have provided a wildcard specification or bad file[path] name
        iStart = 0
        bDone = False
        While Not (bDone)
            iEnd = 0
            iEnd = InStr(iStart + 1, sFileOrFolder, "\", vbBinaryCompare)
            If (iEnd = 0) Then
                bDone = True
                sFolder = Left(sFileOrFolder, iStart - 1)
                sWildCard = Mid(sFileOrFolder, iStart + 1)
                If (Not oFs.FolderExists(sFolder)) Then
                    g_sErrInfo = "ERROR_FILE[PATH]_NOT_FOUND or unsupported pre*.ext wildcard passed for sFileOrFolder = " & sFileOrFolder
                    Set oFile = Nothing
                    Set oFolder = Nothing
                    Set oFs = Nothing
                    NewMailWAttach = -1
                    Exit Function
                End If
                iStart = InStr(1, sWildCard, "*", vbBinaryCompare)
                If (iStart = 1) Then
                    iEnd = InStr(iStart + 1, sWildCard, ".*", vbBinaryCompare)
                    If (iEnd) Then
                        bAllFiles = True '// i.e. *.* passed
                    Else
                        iEnd = InStr(iStart + 1, sWildCard, ".", vbBinaryCompare)
                        sWildCard = Mid(sWildCard, iEnd) '// i.e. *.ext passed
                    End If
                Else
                    iStart = InStr(1, sWildCard, "*.*", vbBinaryCompare)
                    If (iStart) Then
                        sWildCard = Mid(sWildCard, 1, (iStart - 1)) '// i.e. pre*.* passed
                    Else
                        '// user likely passed pre*.ext which we currently do not support
                        g_sErrInfo = "ERROR_FILE[PATH]_NOT_FOUND or unsupported pre*.ext wildcard passed for sFileOrFolder = " & sFileOrFolder
                        Set oFile = Nothing
                        Set oFolder = Nothing
                        Set oFs = Nothing
                        NewMailWAttach = -1
                        Exit Function
                    End If
                End If
            Else
                iStart = iEnd
            End If
        Wend
        
        Set oFolder = oFs.GetFolder(sFolder)
        For Each oFile In oFolder.Files
            If (bAllFiles) Then
                '// Attach File to email
                Call oNewMail.AttachFile(oFile.Path)
        
            Else
                iStart = InStr(1, oFile.Name, sWildCard)
                If (iStart) Then
                    bWildCardMatch = True
                    '// Attach File to email
                    Call oNewMail.AttachFile(oFile.Path)
                End If
            End If
        Next '// oFile
    End If
    
    Set oFile = Nothing
    Set oFolder = Nothing
    Set oFs = Nothing
    If (Not bFound) And (Not bAllFiles) And (Not bWildCardMatch) Then
        g_sErrInfo = sFolder & "\" & sWildCard & "produced ERROR_FILE_NOT_FOUND."
        NewMailWAttach = -1  '// return error_file[path]_not_found status
    Else
        NewMailWAttach = 0
    End If
    
    Call oNewMail.Send
    Set oFile = Nothing
    Set oFolder = Nothing
    Set oFs = Nothing
    Set oNewMail = Nothing
    
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    Set oFile = Nothing
    Set oFolder = Nothing
    Set oFs = Nothing
    Set oNewMail = Nothing
    NewMailWAttach = -1
End Function

Function GetInboxMail(sEmailId As String, oMail As Object) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
    
    If (sEmailId = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        GetInboxMail = 1
        Exit Function
    End If
    
    Dim oCdo As Object
    
    Set oCdo = Nothing
    
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    GetInboxMail = 1
End Function
