// Customers.cpp : Implementation of CCustomers
#include "stdafx.h"
#include "IcuHost.h"
#include "Customers.h"

#include <lmerr.h>  // used by GetLastErrorData method
#include <activeds.h>  // used for access to ads
#import	 <scrrun.dll> no_namespace rename("FreeSpace", "FreeSpaceX") rename("Folder", "FolderX")
#include <aclapi.h>  // used by aclmodify method
#include <iadmw.h>  // COM Interface header for MetaData work
#include <iiscnfg.h>  // MD_ & IIS_MD_ #defines for MetaData work
#include <odbcinst.h>  // used by dsn[create/delete] methods

/////////////////////////////////////////////////////////////////////////////
// CCustomers

/*  Commented this out because we are using the ISupportErrorInfoImpl
    declaration to create standard Error Info Implementation routines
	for us. Documentation implies that this declaration can be used
	against only one class vs. in ever class in a given COMponent.  Need
	to test if this is true by attempting to enalbe tcpip class with
	same default implementation.
STDMETHODIMP CCustomers::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_ICustomers
	};
	for (int i=0; i < sizeof(arr) / sizeof(arr[0]); i++)
	{
		if (InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}
*/

STDMETHODIMP CCustomers::get_LastErrorNum(LONG *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())
	if (pVal)
		*pVal = m_lLastErrorNum;

	return S_OK;
}


STDMETHODIMP CCustomers::get_LastErrorDesc(BSTR *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	if (pVal)
		*pVal = m_sLastErrorDesc;

	return S_OK;
}


STDMETHODIMP CCustomers::get_DbHost(BSTR *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	*pVal = m_sDbHost;

	return S_OK;
}


STDMETHODIMP CCustomers::put_DbHost(BSTR newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	m_sDbHost = newVal;

	return S_OK;
}


STDMETHODIMP CCustomers::get_FtpSrvNumNext(UINT *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	HRESULT hr = E_FAIL; 
	CComPtr<IMSAdminBase> pIMeta;  
	METADATA_HANDLE hMd;
	CComBSTR sSubKeyName;
	_TCHAR aBuffer[METADATA_MAX_NAME_LEN] = {_T("\0")};
	int nIndex = 0;
	METADATA_RECORD tMdRec;
	DWORD dwMdReqDataLen = 0;
	_TCHAR szMDData[MAX_CB_BUFFER] = {_T("\0")};

	try
	{
		hr = pIMeta.CoCreateInstance(__uuidof(IMSAdminBase), NULL, CLSCTX_ALL);
		if (FAILED(hr)) throw(hr);
		
		// get a handle to the local machine ftp service
		sSubKeyName = _T("/LM/MSFTPSVC");
		hr = pIMeta->OpenKey(METADATA_MASTER_ROOT_HANDLE, sSubKeyName, 
							 METADATA_PERMISSION_READ,
							 METADATA_TIMEOUT, &hMd); 
		if (FAILED(hr)) throw(hr);

		m_unFtpSrvNumNext = 1; // start out counter a 1 assuming there are zero servers defined
		while (SUCCEEDED(hr))  // loop until there are no more subkeys 
		{  
			// enumerate the subkeys of the localmachine ftp service
			// hr = pIMeta->EnumKeys(hMd, NULL, aBuffer, nIndex);
			hr = pIMeta->EnumKeys(hMd, NULL, aBuffer, nIndex);
			sSubKeyName = aBuffer;
			if (SUCCEEDED(hr))
			{ 
				tMdRec.dwMDIdentifier = MD_KEY_TYPE;
				tMdRec.dwMDAttributes = (METADATA_INHERIT | METADATA_INSERT_PATH |
				 						 METADATA_ISINHERITED | METADATA_PARTIAL_PATH);
				tMdRec.dwMDUserType = IIS_MD_UT_SERVER;		  
				tMdRec.dwMDDataType = STRING_METADATA;	  
				tMdRec.pbMDData	= reinterpret_cast<unsigned char *>(szMDData);
				tMdRec.dwMDDataLen = sizeof(_TCHAR) * MAX_CB_BUFFER;
				hr = pIMeta->GetData(hMd, sSubKeyName, &tMdRec, &dwMdReqDataLen);
				if (FAILED(hr)) throw(hr);
				if (!_tcscmp(_T("IIsFtpServer"), (LPCTSTR)tMdRec.pbMDData))  // only increment counter when IIsFtpServer key found
				{
					if (m_unFtpSrvNumNext <= _tcstoul(sSubKeyName, NULL, 10))  // this logic ensures that the we always are 1 > than the highest key number found
						m_unFtpSrvNumNext = _tcstoul(sSubKeyName, NULL, 10) + 1;
				}
				nIndex++; // increment the index so next EnumKeys call can be made
			}
			else
			{
				if (ERROR_NO_MORE_ITEMS != hr)
					hr = E_FAIL; // throw(hr);
			}
		}

		// close down metabase handle before departing
		if (pIMeta && hMd)
			pIMeta->CloseKey(hMd);

		if (pVal)
			*pVal = m_unFtpSrvNumNext;

		return S_OK;
	}

	catch(HRESULT hrLastError)
    {
		GetLastErrorData(hrLastError);  // sets m_lLastErrorNum and m_sLastErrorDesc

		// close down metabase handle before departing
		if (pIMeta && hMd)
            pIMeta->CloseKey(hMd);

		/* don't bother to set pVal because we failed.
		if (pVal)
			*pVal = 0;  
		*/

		return E_FAIL;
    }
}


STDMETHODIMP CCustomers::get_Host(BSTR *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	*pVal = m_sHost;
	return S_OK;
}


STDMETHODIMP CCustomers::put_Host(BSTR newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here
	m_sHost = newVal;
	if (m_sHost.Length() && _tcscmp(_T("localhost"), m_sHost))
		m_bRemoteHost = TRUE;
	else
	{
		m_bRemoteHost = FALSE;
		_TCHAR aValue[MAX_CB_NBHOSTNAME] = {_T("\0")};
		DWORD dwRet = GetEnvironmentVariable(_T("COMPUTERNAME"), aValue, MAX_CB_NBHOSTNAME);
		if (dwRet) 
			m_sHost = _tcslwr(aValue);
	}
	
	return S_OK;
}


STDMETHODIMP CCustomers::get_HostingFolder(BSTR *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here
	*pVal = m_sHostingFolder;
	return S_OK;
}


STDMETHODIMP CCustomers::put_HostingFolder(BSTR newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here
	m_sHostingFolder = newVal;
	return S_OK;
}


STDMETHODIMP CCustomers::get_HostingPrefix(BSTR *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here
	*pVal = m_sHostingPrefix;
	return S_OK;
}


STDMETHODIMP CCustomers::put_HostingPrefix(BSTR newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here
	m_sHostingPrefix = newVal;
	return S_OK;
}


STDMETHODIMP CCustomers::get_IpAddressStart(BSTR *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	DWORD dwIpAddress = m_dwIpAddressStart, dwIpAddressByte = 0;
	CComBSTR sIpAddress;
	_TCHAR aByte[sizeof(_TCHAR) * MAX_BYTES_PER_OCTET] = {_T("\0")};

	for (int nByte = 4; nByte > 0; nByte--)
	{
		dwIpAddressByte = (dwIpAddress & ((1<<8*nByte) - (1<<8*(nByte-1)))) >> 8*(nByte-1);
		wsprintf(aByte, _T("%d"), dwIpAddressByte);
		sIpAddress.Append(aByte);
		if (1 != nByte)
			sIpAddress.Append(_T("."));
	}

	*pVal = sIpAddress;
	return S_OK;
}


STDMETHODIMP CCustomers::put_IpAddressStart(BSTR newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	CString sIpAddress = newVal;
	DWORD dwIpAddressByte = 0;
	int nShift = 24;
	m_dwIpAddressStart = 0;

	for (int nByte = 4; nByte > 0; nByte--)
	{
		if (1 != nByte)
		{
			dwIpAddressByte = _tcstoul(sIpAddress.Left(sIpAddress.FindOneOf(_T("."))), NULL, 10) << nShift;
			m_dwIpAddressStart += dwIpAddressByte;
			sIpAddress = sIpAddress.Mid(sIpAddress.FindOneOf(_T(".")) + 1);
			nShift -= 8;
		}
		else
		{
			dwIpAddressByte = _tcstoul(sIpAddress, NULL, 10);
			m_dwIpAddressStart += dwIpAddressByte;
		}
	}

	return S_OK;
}


STDMETHODIMP CCustomers::get_IpAddressRange(DWORD *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	*pVal = m_dwIpAddressRange;
	return S_OK;
}


STDMETHODIMP CCustomers::put_IpAddressRange(DWORD newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	m_dwIpAddressRange = newVal;
	return S_OK;
}


STDMETHODIMP CCustomers::get_NameSpace(BSTR *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	*pVal = m_sNameSpace;
	return S_OK;
}


STDMETHODIMP CCustomers::put_NameSpace(BSTR newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	m_sNameSpace = newVal;
	return S_OK;
}


STDMETHODIMP CCustomers::get_SubnetMask(BSTR *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	DWORD dwSubnetMask = m_dwSubnetMask, dwSubnetMaskByte = 0;
	CComBSTR sSubnetMask;
	_TCHAR aByte[sizeof(_TCHAR) * MAX_BYTES_PER_OCTET] = {_T("\0")};

	for (int nByte = 4; nByte > 0; nByte--)
	{
		dwSubnetMaskByte = (dwSubnetMask & ((1<<8*nByte) - (1<<8*(nByte-1)))) >> 8*(nByte-1);
		wsprintf(aByte, _T("%d"), dwSubnetMaskByte);
		sSubnetMask.Append(aByte);
		if (1 != nByte)
			sSubnetMask.Append(_T("."));
	}

	*pVal = sSubnetMask;
	return S_OK;
}


STDMETHODIMP CCustomers::put_SubnetMask(BSTR newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())
	
	CString sSubnetMask = newVal;
	DWORD dwSubnetMaskByte = 0;
	int nShift = 24;
	m_dwSubnetMask = 0;

	for (int nByte = 4; nByte > 0; nByte--)
	{
		if (1 != nByte)
		{
			dwSubnetMaskByte = _tcstoul(sSubnetMask.Left(sSubnetMask.FindOneOf(_T("."))), NULL, 10) << nShift;
			m_dwSubnetMask += dwSubnetMaskByte;
			sSubnetMask = sSubnetMask.Mid(sSubnetMask.FindOneOf(_T(".")) + 1);
			nShift -= 8;
		}
		else
		{
			dwSubnetMaskByte = _tcstoul(sSubnetMask, NULL, 10);
			m_dwSubnetMask += dwSubnetMaskByte;
		}
	}

	return S_OK;
}


STDMETHODIMP CCustomers::get_WebSrvNumNext(UINT *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	HRESULT hr = E_FAIL; 
	CComPtr<IMSAdminBase> pIMeta;  
	METADATA_HANDLE hMd;
	CComBSTR sSubKeyName;
	_TCHAR aBuffer[METADATA_MAX_NAME_LEN] = {_T("\0")};
	int nIndex = 0;
	METADATA_RECORD tMdRec;
	DWORD dwMdReqDataLen = 0;
	_TCHAR szMDData[MAX_CB_BUFFER] = {_T("\0")};

	try
	{
		hr = pIMeta.CoCreateInstance(__uuidof(IMSAdminBase), NULL, CLSCTX_ALL);
		if (FAILED(hr)) throw(hr);
		
		// get a handle to the local machine ftp service
		sSubKeyName = _T("/LM/W3SVC");
		hr = pIMeta->OpenKey(METADATA_MASTER_ROOT_HANDLE, sSubKeyName, 
							 METADATA_PERMISSION_READ,
							 METADATA_TIMEOUT, &hMd); 
		if (FAILED(hr)) throw(hr);

		m_unWebSrvNumNext = 1; // start out counter a 1 assuming there are zero servers defined
		while (SUCCEEDED(hr))  // loop until there are no more subkeys 
		{  
			// enumerate the subkeys of the localmachine web service
			hr = pIMeta->EnumKeys(hMd, NULL, aBuffer, nIndex);
			sSubKeyName = aBuffer;
			if (SUCCEEDED(hr))
			{ 
				tMdRec.dwMDIdentifier = MD_KEY_TYPE;
				tMdRec.dwMDAttributes = (METADATA_INHERIT | METADATA_INSERT_PATH |
				 						 METADATA_ISINHERITED | METADATA_PARTIAL_PATH);
				tMdRec.dwMDUserType = IIS_MD_UT_SERVER;		  
				tMdRec.dwMDDataType = STRING_METADATA;	  
				tMdRec.pbMDData	= reinterpret_cast<unsigned char *>(szMDData);
				tMdRec.dwMDDataLen = sizeof(_TCHAR) * MAX_CB_BUFFER;
				hr = pIMeta->GetData(hMd, sSubKeyName, &tMdRec, &dwMdReqDataLen);
				if (FAILED(hr)) throw(hr);
				if (!_tcscmp(_T("IIsWebServer"), (LPCTSTR)tMdRec.pbMDData))  // only increment counter when IIsWebServer key found
				{
					if (m_unWebSrvNumNext <= _tcstoul(sSubKeyName,NULL, 10))  // this logic ensures that the we always are 1 > than the highest key number found
						m_unWebSrvNumNext = _tcstoul(sSubKeyName,NULL, 10) + 1;
				}
				nIndex++; // increment the index so next EnumKeys call can be made
			}
			else
			{
				if (ERROR_NO_MORE_ITEMS != hr)
					hr = E_FAIL; // throw(hr);
			}
		}

		// close down metabase handle before departing
		if (pIMeta && hMd)
			pIMeta->CloseKey(hMd);

		if (pVal)
			*pVal = m_unWebSrvNumNext;

		return S_OK;
	}

	catch(HRESULT hrLastError)
    {
		GetLastErrorData(hrLastError);  // sets m_lLastErrorNum and m_sLastErrorDesc

		// close down metabase handle before departing
		if (pIMeta && hMd)
            pIMeta->CloseKey(hMd);

		/* don't bother to set pVal because we failed.
		if (pVal)
			*pVal = 0;  
		*/

		return E_FAIL;
    }
}


STDMETHODIMP CCustomers::get_WntDomain(BSTR *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	*pVal = m_sWntDomain;
	return S_OK;
}


STDMETHODIMP CCustomers::put_WntDomain(BSTR newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	m_sWntDomain = newVal;
	return S_OK;
}


STDMETHODIMP CCustomers::AclModify(BSTR sFileOrFolder, BSTR sUserOrGroup, DWORD dwFileMask, DWORD dwFolderMask, DWORD dwAccessMode)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())
	
	// dwFileMask options   = GENERIC_READ | GENERIC_WRITE | GENEREIC_EXECUTE | DELETE | GENERIC_ALL
	// dwFolderMask options = FILE_GENERIC_READ | FILE_GENERIC_WRITE | FILE_GENEREIC_EXECUTE |
	//  				      DELETE | FILE_ALL_ACCESS

	// using low level acl api's

	BOOL br = FALSE;
	// SECURITY_DESCRIPTOR sd;

	// SID variables
	_TCHAR psnuType[2048] = {_T("\0")};
	_TCHAR lpszDomain[2048] = {_T("\0")};
	DWORD dwDomainLength = 250;
	_TCHAR UserSID[1024] = {_T("\0")};
	DWORD dwSIDBufSize = 1024;
	int	sidlen = 0;

	// user name variables
	DWORD dwUserNameLength = 250;

	// file SD variables
	_TCHAR ucSDbuf[SD_SIZE] = {_T("\0")};
	PSECURITY_DESCRIPTOR pFileSD=(PSECURITY_DESCRIPTOR)ucSDbuf;
	DWORD dwSDLengthNeeded = 0;

	// ACL variables
	ACCESS_ALLOWED_ACE *paaa = (ACCESS_ALLOWED_ACE *) malloc (1024);
	PACL pACL = NULL;
	BOOL bDaclPresent = FALSE;
	BOOL bDaclDefaulted = FALSE;
	ACL_SIZE_INFORMATION AclInfo;

	// new ACL variables
	PACL pNewACL = NULL;
	DWORD dwNewACLSize = 0;

	// new SD variables
	UCHAR NewSD[SECURITY_DESCRIPTOR_MIN_LENGTH];
	PSECURITY_DESCRIPTOR psdNewSD=(PSECURITY_DESCRIPTOR)NewSD;

	// temporary ACE
	PVOID pTempAce = NULL;
	UINT CurrentAceIndex = 0;

	try
	{
		// get SID for the user
		br = LookupAccountName(NULL, sUserOrGroup, UserSID, &dwSIDBufSize,
							   lpszDomain, &dwDomainLength, (PSID_NAME_USE)psnuType);
		if (!br) throw (br);
		
		// get security descriptor (SD) for file
		br = GetFileSecurity(sFileOrFolder, (SECURITY_INFORMATION)(DACL_SECURITY_INFORMATION),
							 pFileSD, SD_SIZE, (LPDWORD)&dwSDLengthNeeded);
		if (!br) throw (br);

		// initialize new SD
		br = InitializeSecurityDescriptor(psdNewSD,SECURITY_DESCRIPTOR_REVISION);
		if (!br) throw (br);

		// get DACL from SD
		br = GetSecurityDescriptorDacl(pFileSD,	&bDaclPresent, &pACL, &bDaclDefaulted);
		if (!br) throw (br);

		// get file ACL size information
		br = GetAclInformation(pACL, &AclInfo, sizeof(ACL_SIZE_INFORMATION), AclSizeInformation);
		if (!br) throw (br);

		// compute size needed for the new ACL  (make room for 2 additional ace's
		// one for the container inheritance and one for the file inheritance.
		dwNewACLSize = AclInfo.AclBytesInUse + 2 * (sizeof(ACCESS_ALLOWED_ACE) + 
					   GetLengthSid(UserSID) -  sizeof(DWORD));
		sidlen = GetLengthSid(UserSID);

		// allocate memory for new ACL
		pNewACL = (PACL)LocalAlloc(LPTR, dwNewACLSize);

		// initialize the new ACL
		br = InitializeAcl(pNewACL, dwNewACLSize, ACL_REVISION);
		if (!br) throw (br);

		// if DACL is present, copy it to a new DACL
		if(bDaclPresent)  // only copy if DACL was present
		{
			// copy the file's ACEs to our new ACL
			if(AclInfo.AceCount)
			{
				for(CurrentAceIndex = 0; CurrentAceIndex < AclInfo.AceCount;
					CurrentAceIndex++)
				{
					// get an ACE
					br = GetAce(pACL,CurrentAceIndex,&pTempAce);
					if (!br) throw (br);

					// add the ACE to the new ACL
					br = AddAce(pNewACL, ACL_REVISION, MAXDWORD, pTempAce, ((PACE_HEADER)pTempAce)->AceSize);
					if (!br) throw (br);
				}
			}
		}

		// fill in the first new ACE  
		memcpy(&paaa->SidStart, UserSID, GetLengthSid(UserSID)); 
		paaa->Mask = dwFolderMask; // before = dwFileMask;
		paaa->Header.AceType = ACCESS_ALLOWED_ACE_TYPE; 
		paaa->Header.AceFlags = INHERIT_ONLY_ACE | OBJECT_INHERIT_ACE | CONTAINER_INHERIT_ACE;  // before = INHERIT_ONLY_ACE | OBJECT_INHERIT_ACE;
		paaa->Header.AceSize =  sizeof(ACCESS_ALLOWED_ACE) + sidlen - sizeof(DWORD);

		br = AddAce(pNewACL, ACL_REVISION, MAXDWORD, paaa, paaa->Header.AceSize);
		if (!br) throw (br);
		
		/*
		paaa->Mask = dwFolderMask;  // before = dwFileMask;
		paaa->Header.AceType = ACCESS_ALLOWED_ACE_TYPE; 
		paaa->Header.AceFlags = 0;  // before = CONTAINER_INHERIT_ACE; 
		paaa->Header.AceSize =  sizeof(ACCESS_ALLOWED_ACE) + sidlen - sizeof(DWORD);

		// before br = AddAce(pNewACL, ACL_REVISION, MAXDWORD, paaa, paaa->Header.AceSize);
		*/
		br = AddAccessAllowedAce(pNewACL, ACL_REVISION, dwFolderMask, UserSID);
		if (!br) throw (br);

		// set our new DACL to the file SD
		br = SetSecurityDescriptorDacl(psdNewSD, TRUE, pNewACL, FALSE);
		if (!br) throw (br);

		// set the SD to the File
		br = SetFileSecurity(sFileOrFolder, DACL_SECURITY_INFORMATION,psdNewSD);
		if (!br) throw (br);

		// free the memory allocated for the new ACL before departing
		LocalFree((HLOCAL)pNewACL);
		return S_OK;
	}

	catch(BOOL brLastError)
    {
		brLastError = FALSE; // for no reason other than to get rid of compiler warning
		// brLastError isn't really the LastError information so send the 0x0 value as the
		// argument for GetLastErrorData() call so that GetLastError() within that 
		// method will be used to derive the actual LastError Number and Description
		GetLastErrorData(0x0);  // sets m_lLastErrorNum and m_sLastErrorDesc
		
		// free the memory allocated for the new ACL before departing
		if (pNewACL)
            LocalFree((HLOCAL)pNewACL);

		return E_FAIL;
    }

	catch(...)  // any type including C, system and application generated exceptions
    {
		GetLastErrorData(0x0);  // sets m_lLastErrorNum and m_sLastErrorDesc

		// free the memory allocated for the new ACL before departing
		if (pNewACL)
            LocalFree((HLOCAL)pNewACL);

		return E_FAIL;
	}
}


STDMETHODIMP CCustomers::CopyFile(BSTR sSource, BSTR sDestination, BOOL bOverWriteFiles)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	HRESULT hr = E_FAIL;
	CComPtr<IFileSystem> pFileSystem;
	CComPtr<IFolder> pFolder;
	
	hr = pFileSystem.CoCreateInstance(_T("Scripting.FileSystemObject"), NULL, CLSCTX_ALL);
	if(FAILED(hr)) return hr;

	if (pFileSystem->FileExists(sSource) && !pFileSystem->FileExists(sDestination))
		pFileSystem->CopyFile(sSource, sDestination, bOverWriteFiles);

	return S_OK;
}


STDMETHODIMP CCustomers::CopyFolder(BSTR sSource, BSTR sDestination, BOOL bOverWriteFiles)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	HRESULT hr = E_FAIL;
	CComPtr<IFileSystem> pFileSystem;
	CComPtr<IFolder> pFolder;

	hr = pFileSystem.CoCreateInstance(_T("Scripting.FileSystemObject"), NULL, CLSCTX_ALL);
	if(FAILED(hr)) return hr;

	if (pFileSystem->FolderExists(sSource) && !pFileSystem->FolderExists(sDestination))
		pFileSystem->CopyFolder(sSource, sDestination, bOverWriteFiles);

	return S_OK;
}


STDMETHODIMP CCustomers::CustomersCreate()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	HRESULT hr = E_FAIL;
	int nStageIndex = 0;
	DWORD dwIpAddress = 0;
	__int64 dwIpAddressByte = 0, dwSubnetMaskByte = 0;
	CComBSTR sIpAddress, sSubnetMask, sCustomerId, sADsPath, 
			 sFolder, sSubFolder, sSource, sDestination;
	_TCHAR aByte[sizeof(_TCHAR) * MAX_BYTES_PER_OCTET] = {_T("\0")};

	try
	{
		dwIpAddress = m_dwIpAddressStart;
		for (int nIndex = 0; nIndex < (int)m_dwIpAddressRange; nIndex++, dwIpAddress++)
		{
			sIpAddress.Empty(); sSubnetMask.Empty();
			for (int nByte = 4; nByte > 0; nByte--)
			{
				dwIpAddressByte = (dwIpAddress & ((1<<8*nByte) - (1<<8*(nByte-1)))) >> 8*(nByte-1);
				dwSubnetMaskByte = (m_dwSubnetMask & ((1<<8*nByte) - (1<<8*(nByte-1)))) >> 8*(nByte-1);
				wsprintf(aByte, _T("%d"), dwIpAddressByte);
				sIpAddress.Append(aByte);
				if (1 == nByte)
				{
					sCustomerId = m_sHostingPrefix; 
					sCustomerId.Append(aByte);
				}
				wsprintf(aByte, _T("%d"), dwSubnetMaskByte);
				sSubnetMask.Append(aByte);
				if (1 != nByte)
				{
					sIpAddress.Append(_T("."));
					sSubnetMask.Append(_T("."));
				}
				else
				{
					sIpAddress.Append(_T(" "));
					sSubnetMask.Append(_T(" "));
				}
			}

			// now that we have the current IpAddress, SubnetMask, CustomerId in string format lets
			// proceed to create the customer specific userid, folders, acls, ftpRoot, webRoot, db and dsn

			// prepare the customer folder name
			sFolder.Empty(); sFolder = m_sHostingFolder;
			sFolder.Append(_T("\\")); sFolder.Append(sCustomerId);
			
			// stage 1 - create customer master user
			nStageIndex = 1;
			hr = UserCreate(sCustomerId, sCustomerId, sCustomerId);
			if (FAILED(hr)) throw(hr);

			// stage 2 - create customer folder
			nStageIndex = 2;
			hr = FolderCreate(sFolder);
			if (FAILED(hr)) throw(hr);
			
			// stage 3 - set acls now so any new subFolders created will inherit acls from parent
			nStageIndex = 3;
			hr = AclModify(sFolder, sCustomerId, 
						  (GENERIC_READ | GENERIC_WRITE | GENERIC_EXECUTE | DELETE),
						  (FILE_GENERIC_READ | FILE_GENERIC_WRITE | FILE_GENERIC_EXECUTE | DELETE),
						   GRANT_ACCESS);
			if (FAILED(hr)) throw(hr);

			// stage 4 - create customer default content folders
			nStageIndex = 4;
			sSubFolder.Empty(); sSubFolder = sFolder; sSubFolder.Append(_T("\\index"));
			hr = FolderCreate(sSubFolder);
			if (FAILED(hr)) throw(hr);

			sSubFolder.Empty(); sSubFolder = sFolder; sSubFolder.Append(_T("\\web"));
			hr = FolderCreate(sSubFolder);
			if (FAILED(hr)) throw(hr);

			// stage 5 - copy default content to new customer folder [if it exists]
			nStageIndex = 5;
			sSource.Empty(); sSource = m_sHostingFolder; sSource.Append(_T("\\defaultContent\\banner.txt"));
			sDestination.Empty(); sDestination = sFolder; sDestination.Append(_T("\\banner.txt"));
			CopyFile(sSource, sDestination, FALSE);

			sSource.Empty(); sSource = m_sHostingFolder; sSource.Append(_T("\\defaultContent\\web\\default.htm"));
			sDestination.Empty(); sDestination = sFolder; sDestination.Append(_T("\\web\\default.htm"));
			CopyFile(sSource, sDestination, FALSE);

			// stage 6 - create the ftp root
			nStageIndex = 6;
			hr = FtpSrvCreate(sIpAddress, sCustomerId, sFolder, FALSE, (MD_ACCESS_READ | MD_ACCESS_WRITE));
			if (FAILED(hr)) throw(hr);

			// stage 7 - create the web root
			nStageIndex = 7;
			hr = WebSrvCreate(sIpAddress, sCustomerId, sSubFolder, (MD_AUTH_ANONYMOUS | MD_AUTH_BASIC),
							  (MD_ACCESS_READ | MD_ACCESS_WRITE | MD_ACCESS_SCRIPT | MD_DIRBROW_ENABLED));
			if (FAILED(hr)) throw(hr);

			// stage 8 - create the db [method processes only if m_sDbHost value set)
			nStageIndex = 8;
			sDestination.Empty(); sDestination = sFolder; sDestination.Append(_T("\\db"));
			// OR sDestination.Empty(); sDestination = _T("\0");  // to use sql default device path
			hr = DbCreate(sCustomerId, sDestination);
			if (FAILED(hr)) throw(hr);

			// stage 9 - create the dsn [method processes only if m_sDbHost value set)
			nStageIndex = 9;
			hr = DsnCreate(sCustomerId, sDestination);
			if (FAILED(hr)) throw(hr);
		}

		return S_OK;
	}

	catch(HRESULT hrLastError)
	{
		GetLastErrorData(hrLastError);  // sets m_lLastErrorNum and m_sLastErrorDesc
		// now rollback so we only have atomically complete customers left created
		switch (nStageIndex)
		{
			case 1:
				hr = UserDelete(sCustomerId);
				if (FAILED(hr)) throw;
				break;
			case 2:
			case 3:
			case 4:
			case 5:
				hr = FolderDelete(sFolder);
				hr = UserDelete(sCustomerId);
				if (FAILED(hr)) throw;
				break;
			case 6:
				hr = FtpSrvDelete(sIpAddress, sCustomerId);
				hr = FolderDelete(sFolder);
				hr = UserDelete(sCustomerId);
				if (FAILED(hr)) throw;
				break;
			case 7:
				hr = WebSrvDelete(sIpAddress, sCustomerId);
				hr = FtpSrvDelete(sIpAddress, sCustomerId);
				hr = FolderDelete(sFolder);
				hr = UserDelete(sCustomerId);
				if (FAILED(hr)) throw;
				break;
			case 8:
				sDestination.Empty(); sDestination = sFolder; sDestination.Append(_T("\\db"));
				// OR sDestination.Empty(); sDestination = _T("\0");  // to use sql default device path
				hr = DbDelete(sCustomerId, sDestination);
				hr = WebSrvDelete(sIpAddress, sCustomerId);
				hr = FtpSrvDelete(sIpAddress, sCustomerId);
				hr = FolderDelete(sFolder);
				hr = UserDelete(sCustomerId);
				if (FAILED(hr)) throw;
				break;
			case 9:
				sDestination.Empty(); sDestination = sFolder; sDestination.Append(_T("\\db"));
				// OR sDestination.Empty(); sDestination = _T("\0");  // to use sql default device path
				hr = DsnDelete(sCustomerId, sDestination);
				hr = DbDelete(sCustomerId, sDestination);
				hr = WebSrvDelete(sIpAddress, sCustomerId);
				hr = FtpSrvDelete(sIpAddress, sCustomerId);
				hr = FolderDelete(sFolder);
				hr = UserDelete(sCustomerId);
				if (FAILED(hr)) throw;
				break;
			default:
				break;
		}

		_TCHAR szText[MAX_CB_BUFFER] = {_T("\0")}, szCaption[MAX_CB_BUFFER] = {_T("\0")};
		wsprintf(szText, _T("Due to Stage %s errors we stopped provisioning at IpAddress = %s and CusomterId = %s."), nStageIndex, sIpAddress, sCustomerId);
		wsprintf(szCaption, _T("CustomerCreate Error"));

		// if we are in debug mode then output error message to stderr
		#ifdef _DEBUG
			DWORD dwBytesWritten = 0;
			WriteFile(GetStdHandle(STD_ERROR_HANDLE), szText, 
					 (sizeof(_TCHAR) * _tcslen(szText)), &dwBytesWritten, NULL);
		#endif

		// if this is a console application then output the error description to stdout
		// printf("%s\n", lLastErrorNum, szText);

		// if this is a windows application then output the error description to a MessageBox
		MessageBox(NULL, szText, szCaption,  MB_OK | MB_ICONINFORMATION);
		return E_FAIL;
	}

	catch(...)  // any type including C, system and application generated exceptions
    {
		GetLastErrorData(0x0);  // sets m_lLastErrorNum and m_sLastErrorDesc

		_TCHAR szText[MAX_CB_BUFFER] = {_T("\0")}, szCaption[MAX_CB_BUFFER] = {_T("\0")};
		wsprintf(szText, _T("Due to Stage %s errors we stopped creating at IpAddress = %s and CusomterId = %s."), nStageIndex, sIpAddress, sCustomerId);
		wsprintf(szCaption, _T("CustomerCreate Error"));

		// if we are in debug mode then output error message to stderr
		#ifdef _DEBUG
			DWORD dwBytesWritten = 0;
			WriteFile(GetStdHandle(STD_ERROR_HANDLE), szText, 
					 (sizeof(_TCHAR) * _tcslen(szText)), &dwBytesWritten, NULL);
		#endif

		// if this is a console application then output the error description to stdout
		// printf("%s\n", lLastErrorNum, szText);

		// if this is a windows application then output the error description to a MessageBox
		MessageBox(NULL, szText, szCaption,  MB_OK | MB_ICONINFORMATION);

		return E_FAIL;
	}	
}


STDMETHODIMP CCustomers::CustomersDelete()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	HRESULT hr = E_FAIL;
	int nStageIndex = 0;
	DWORD dwIpAddress = 0;
	__int64 dwIpAddressByte = 0, dwSubnetMaskByte = 0;
	CComBSTR sIpAddress, sSubnetMask, sCustomerId, sADsPath, 
			sFolder, sSubFolder, sSource, sDestination;
	_TCHAR aByte[sizeof(_TCHAR) * MAX_BYTES_PER_OCTET] = {_T("\0")};

	try
	{
		dwIpAddress = m_dwIpAddressStart + m_dwIpAddressRange - 1;
		for (int nIndex = (int)m_dwIpAddressRange; nIndex > 0 ; nIndex--, dwIpAddress--)
		{
			sIpAddress.Empty(); sSubnetMask.Empty();
			for (int nByte = 4; nByte > 0; nByte--)
			{
				dwIpAddressByte = (dwIpAddress & ((1<<8*nByte) - (1<<8*(nByte-1)))) >> 8*(nByte-1);
				dwSubnetMaskByte = (m_dwSubnetMask & ((1<<8*nByte) - (1<<8*(nByte-1)))) >> 8*(nByte-1);
				wsprintf(aByte, _T("%d"), dwIpAddressByte);
				sIpAddress.Append(aByte);
				if (1 == nByte)
				{
					sCustomerId = m_sHostingPrefix; 
					sCustomerId.Append(aByte);
				}
				wsprintf(aByte, _T("%d"), dwSubnetMaskByte);
				sSubnetMask.Append(aByte);
				if (1 != nByte)
				{
					sIpAddress.Append(_T("."));
					sSubnetMask.Append(_T("."));
				}
				else
				{
					sIpAddress.Append(_T(" "));
					sSubnetMask.Append(_T(" "));
				}
			}

			// now that we have the current IpAddress, SubnetMask, CustomerId in string format lets
			// proceed to delete the customer specific userid, folders, acls, ftpRoot, webRoot, db and dsn

			// prepare the customer folder name
			sFolder.Empty(); sFolder = m_sHostingFolder; 
			sFolder.Append(_T("\\")); sFolder.Append(sCustomerId);

			// stage 9 - delete the dsn (method processes only if m_sDbHost value set)
			nStageIndex = 9;
			sDestination.Empty(); sDestination = sFolder; sDestination.Append(_T("\\db"));
			// OR sDestination = _T("\0");  // to use sql default device path
			hr = DsnDelete(sCustomerId, sDestination);
			if (FAILED(hr)) throw(hr);

			// stage 8 - delete the db (method processes only if m_sDbHost value set)
			nStageIndex = 8;
			hr = DbDelete(sCustomerId, sDestination);
			if (FAILED(hr)) throw(hr);

			// stage 7 - delete the web root
			nStageIndex = 7;
			hr = WebSrvDelete(sIpAddress, sCustomerId);
			if (FAILED(hr)) throw(hr);

			// stage 6 - delete the ftp root
			nStageIndex = 6;
			hr = FtpSrvDelete(sIpAddress, sCustomerId);
			if (FAILED(hr)) throw(hr);

			// stage 5,4,3,2 - delete customer folder (subFolders and acls go with it)
			nStageIndex = 2;
			hr = FolderDelete(sFolder);
			if (FAILED(hr)) throw(hr);

			// stage 1 - delete customer master userid
			nStageIndex = 1;
			hr = UserDelete(sCustomerId);
			if (FAILED(hr)) throw(hr);
		}
		return S_OK;
	}

	catch(HRESULT hrLastError)
	{
		GetLastErrorData(hrLastError);  // sets m_lLastErrorNum and m_sLastErrorDesc		
		// now rollback so we only have atomically complete customers left created
		switch (nStageIndex)
		{
			case 9:
				sDestination.Empty(); sDestination = sFolder; sDestination.Append(_T("\\db"));
				hr = DsnCreate(sCustomerId, sDestination);
				if (FAILED(hr)) throw;
				break;

			case 8:
				sDestination.Empty(); sDestination = sFolder; sDestination.Append(_T("\\db"));
				hr = DsnCreate(sCustomerId, sDestination);
				hr = DbCreate(sCustomerId, sDestination);
				if (FAILED(hr)) throw;
				break;

			case 7:
				sSubFolder.Empty(); sSubFolder = sFolder; sSubFolder.Append(_T("\\web"));
				hr = WebSrvCreate(sIpAddress, sCustomerId, sSubFolder, (MD_AUTH_ANONYMOUS | MD_AUTH_BASIC),
								  (MD_ACCESS_READ | MD_ACCESS_WRITE | MD_ACCESS_SCRIPT | MD_DIRBROW_ENABLED));
				sDestination.Empty(); sDestination = sFolder; sDestination.Append(_T("\\db"));
				hr = DsnCreate(sCustomerId, sDestination);
				hr = DbCreate(sCustomerId, sDestination);
				if (FAILED(hr)) throw;
				break;

			case 6:
				hr = FtpSrvCreate(sIpAddress, sCustomerId, sFolder, FALSE, (MD_ACCESS_READ | MD_ACCESS_WRITE));
				sSubFolder.Empty(); sSubFolder = sFolder; sSubFolder.Append(_T("\\web"));
				hr = WebSrvCreate(sIpAddress, sCustomerId, sSubFolder, (MD_AUTH_ANONYMOUS | MD_AUTH_BASIC),
								  (MD_ACCESS_READ | MD_ACCESS_WRITE | MD_ACCESS_SCRIPT | MD_DIRBROW_ENABLED));
				sDestination.Empty(); sDestination = sFolder; sDestination.Append(_T("\\db"));
				hr = DsnCreate(sCustomerId, sDestination);
				hr = DbCreate(sCustomerId, sDestination);
				if (FAILED(hr)) throw;
				break;

			case 5:
				sSource.Empty(); sSource = m_sHostingFolder; sSource.Append(_T("\\defaultContent\\banner.txt"));
				sDestination.Empty(); sDestination = sFolder; sDestination.Append(_T("\\banner.txt"));
				CopyFile(sSource, sDestination, FALSE);
				sSource.Empty(); sSource = m_sHostingFolder; sSource.Append(_T("\\defaultContent\\web\\default.htm"));
				sDestination.Empty(); sDestination = sFolder; sDestination.Append(_T("\\web\\default.htm"));
				CopyFile(sSource, sDestination, FALSE);
				hr = FtpSrvCreate(sIpAddress, sCustomerId, sFolder, FALSE, (MD_ACCESS_READ | MD_ACCESS_WRITE));
				sSubFolder.Empty(); sSubFolder = sFolder; sSubFolder.Append(_T("\\web"));
				hr = WebSrvCreate(sIpAddress, sCustomerId, sSubFolder, (MD_AUTH_ANONYMOUS | MD_AUTH_BASIC),
								  (MD_ACCESS_READ | MD_ACCESS_WRITE | MD_ACCESS_SCRIPT | MD_DIRBROW_ENABLED));
				sDestination.Empty(); sDestination = sFolder; sDestination.Append(_T("\\db"));
				hr = DsnCreate(sCustomerId, sDestination);
				hr = DbCreate(sCustomerId, sDestination);
				if (FAILED(hr)) throw;
				break;

			case 4:
				sSubFolder.Empty(); sSubFolder = sFolder; sSubFolder.Append(_T("\\index"));
				hr = FolderCreate(sSubFolder);
				sSubFolder.Empty(); sSubFolder = sFolder; sSubFolder.Append(_T("\\web"));
				hr = FolderCreate(sSubFolder);
				sSource.Empty(); sSource = m_sHostingFolder; sSource.Append(_T("\\defaultContent\\banner.txt"));
				sDestination.Empty(); sDestination = sFolder; sDestination.Append(_T("\\banner.txt"));
				CopyFile(sSource, sDestination, FALSE);
				sSource.Empty(); sSource = m_sHostingFolder; sSource.Append(_T("\\defaultContent\\web\\default.htm"));
				sDestination.Empty(); sDestination = sFolder; sDestination.Append(_T("\\web\\default.htm"));
				CopyFile(sSource, sDestination, FALSE);
				hr = FtpSrvCreate(sIpAddress, sCustomerId, sFolder, FALSE, (MD_ACCESS_READ | MD_ACCESS_WRITE));
				sSubFolder.Empty(); sSubFolder = sFolder; sSubFolder.Append(_T("\\web"));
				hr = WebSrvCreate(sIpAddress, sCustomerId, sSubFolder, (MD_AUTH_ANONYMOUS | MD_AUTH_BASIC),
								  (MD_ACCESS_READ | MD_ACCESS_WRITE | MD_ACCESS_SCRIPT | MD_DIRBROW_ENABLED));
				sDestination.Empty(); sDestination = sFolder; sDestination.Append(_T("\\db"));
				hr = DsnCreate(sCustomerId, sDestination);
				hr = DbCreate(sCustomerId, sDestination);
				if (FAILED(hr)) throw;
				break;

			case 3:
				hr = AclModify(sFolder, sCustomerId, 
							(GENERIC_READ | GENERIC_WRITE | GENERIC_EXECUTE | DELETE),
							(FILE_GENERIC_READ | FILE_GENERIC_WRITE | FILE_GENERIC_EXECUTE | DELETE),
							GRANT_ACCESS);
				sSubFolder.Empty(); sSubFolder = sFolder; sSubFolder.Append(_T("\\index"));
				hr = FolderCreate(sSubFolder);
				sSubFolder.Empty(); sSubFolder = sFolder; sSubFolder.Append(_T("\\web"));
				hr = FolderCreate(sSubFolder);
				sSource.Empty(); sSource = m_sHostingFolder; sSource.Append(_T("\\defaultContent\\banner.txt"));
				sDestination.Empty(); sDestination = sFolder; sDestination.Append(_T("\\banner.txt"));
				CopyFile(sSource, sDestination, FALSE);
				sSource.Empty(); sSource = m_sHostingFolder; sSource.Append(_T("\\defaultContent\\web\\default.htm"));
				sDestination.Empty(); sDestination = sFolder; sDestination.Append(_T("\\web\\default.htm"));
				CopyFile(sSource, sDestination, FALSE);
				hr = FtpSrvCreate(sIpAddress, sCustomerId, sFolder, FALSE, (MD_ACCESS_READ | MD_ACCESS_WRITE));
				sSubFolder.Empty(); sSubFolder = sFolder; sSubFolder.Append(_T("\\web"));
				hr = WebSrvCreate(sIpAddress, sCustomerId, sSubFolder, (MD_AUTH_ANONYMOUS | MD_AUTH_BASIC),
								  (MD_ACCESS_READ | MD_ACCESS_WRITE | MD_ACCESS_SCRIPT | MD_DIRBROW_ENABLED));
				sDestination.Empty(); sDestination = sFolder; sDestination.Append(_T("\\db"));
				hr = DsnCreate(sCustomerId, sDestination);
				hr = DbCreate(sCustomerId, sDestination);
				if (FAILED(hr)) throw;
				break;

			case 2:
				hr = FolderCreate(sFolder);
				hr = AclModify(sFolder, sCustomerId, 
							(GENERIC_READ | GENERIC_WRITE | GENERIC_EXECUTE | DELETE),
							(FILE_GENERIC_READ | FILE_GENERIC_WRITE | FILE_GENERIC_EXECUTE | DELETE),
							GRANT_ACCESS);
				sSubFolder.Empty(); sSubFolder = sFolder; sSubFolder.Append(_T("\\index"));
				hr = FolderCreate(sSubFolder);
				sSubFolder.Empty(); sSubFolder = sFolder; sSubFolder.Append(_T("\\web"));
				hr = FolderCreate(sSubFolder);
				sSource.Empty(); sSource = m_sHostingFolder; sSource.Append(_T("\\defaultContent\\banner.txt"));
				sDestination.Empty(); sDestination = sFolder; sDestination.Append(_T("\\banner.txt"));
				CopyFile(sSource, sDestination, FALSE);
				sSource.Empty(); sSource = m_sHostingFolder; sSource.Append(_T("\\defaultContent\\web\\default.htm"));
				sDestination.Empty(); sDestination = sFolder; sDestination.Append(_T("\\web\\default.htm"));
				CopyFile(sSource, sDestination, FALSE);
				hr = FtpSrvCreate(sIpAddress, sCustomerId, sFolder, FALSE, (MD_ACCESS_READ | MD_ACCESS_WRITE));
				sSubFolder.Empty(); sSubFolder = sFolder; sSubFolder.Append(_T("\\web"));
				hr = WebSrvCreate(sIpAddress, sCustomerId, sSubFolder, (MD_AUTH_ANONYMOUS | MD_AUTH_BASIC),
								  (MD_ACCESS_READ | MD_ACCESS_WRITE | MD_ACCESS_SCRIPT | MD_DIRBROW_ENABLED));
				sDestination.Empty(); sDestination = sFolder; sDestination.Append(_T("\\db"));
				hr = DsnCreate(sCustomerId, sDestination);
				hr = DbCreate(sCustomerId, sDestination);
				if (FAILED(hr)) throw;
				break;

			case 1:
				hr = UserCreate(sCustomerId, sCustomerId, sCustomerId);
				hr = FolderCreate(sFolder);
				hr = AclModify(sFolder, sCustomerId, 
							(GENERIC_READ | GENERIC_WRITE | GENERIC_EXECUTE | DELETE),
							(FILE_GENERIC_READ | FILE_GENERIC_WRITE | FILE_GENERIC_EXECUTE | DELETE),
							GRANT_ACCESS);
				sSubFolder.Empty(); sSubFolder = sFolder; sSubFolder.Append(_T("\\index"));
				hr = FolderCreate(sSubFolder);
				sSubFolder.Empty(); sSubFolder = sFolder; sSubFolder.Append(_T("\\web"));
				hr = FolderCreate(sSubFolder);
				sSource.Empty(); sSource = m_sHostingFolder; sSource.Append(_T("\\defaultContent\\banner.txt"));
				sDestination.Empty(); sDestination = sFolder; sDestination.Append(_T("\\banner.txt"));
				CopyFile(sSource, sDestination, FALSE);
				sSource.Empty(); sSource = m_sHostingFolder; sSource.Append(_T("\\defaultContent\\web\\default.htm"));
				sDestination.Empty(); sDestination = sFolder; sDestination.Append(_T("\\web\\default.htm"));
				CopyFile(sSource, sDestination, FALSE);
				hr = FtpSrvCreate(sIpAddress, sCustomerId, sFolder, FALSE, (MD_ACCESS_READ | MD_ACCESS_WRITE));
				sSubFolder.Empty(); sSubFolder = sFolder; sSubFolder.Append(_T("\\web"));
				hr = WebSrvCreate(sIpAddress, sCustomerId, sSubFolder, (MD_AUTH_ANONYMOUS | MD_AUTH_BASIC),
								  (MD_ACCESS_READ | MD_ACCESS_WRITE | MD_ACCESS_SCRIPT | MD_DIRBROW_ENABLED));
				sDestination.Empty(); sDestination = sFolder; sDestination.Append(_T("\\db"));
				hr = DsnCreate(sCustomerId, sDestination);
				hr = DbCreate(sCustomerId, sDestination);
				if (FAILED(hr)) throw;
				break;

			default:
				break;
		}

		_TCHAR szText[MAX_CB_BUFFER] = {_T("\0")}, szCaption[MAX_CB_BUFFER] = {_T("\0")};
		wsprintf(szText, _T("Due to Stage %s errors we stopped deleting at IpAddress = %s and CusomterId = %s."), nStageIndex, sIpAddress, sCustomerId);
		wsprintf(szCaption, _T("CustomerDelete Error"));

		// if we are in debug mode then output error message to stderr
		#ifdef _DEBUG
			DWORD dwBytesWritten = 0;
			WriteFile(GetStdHandle(STD_ERROR_HANDLE), szText, 
					 (sizeof(_TCHAR) * _tcslen(szText)), &dwBytesWritten, NULL);
		#endif

		// if this is a console application then output the error description to stdout
		// printf("%s\n", lLastErrorNum, szText);

		// if this is a windows application then output the error description to a MessageBox
		MessageBox(NULL, szText, szCaption,  MB_OK | MB_ICONINFORMATION);

		return E_FAIL;
	}

	catch(...)  // any type including C, system and application generated exceptions
    {
		GetLastErrorData(0x0);  // sets m_lLastErrorNum and m_sLastErrorDesc

		return E_FAIL;
	}
}


STDMETHODIMP CCustomers::DbCreate(BSTR sDbName, BSTR sDbPath)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())
	
	HRESULT hr = E_FAIL;

	if (m_sDbHost.Length())  // ensure we only process if m_sDbHost member value provided
	{
		if (_tcsstr(m_sDbHost, _T(".mdb")))
		{
			// create access db
			CComBSTR sDestination = sDbPath;
			hr = FolderCreate(sDestination);  // ensure db folder exists
			if (FAILED(hr)) return(hr);
			CComBSTR sSource = m_sDbHost;  // template .mdb file to be used for new db
			sDestination.Append(_T("\\")); sDestination.Append(sDbName); sDestination.Append(_T(".mdb"));
			hr = CopyFile(m_sDbHost, sDestination, FALSE);  // copy template .mdb
			if (FAILED(hr)) return hr;
		}
		else
		{
			// create sql 65 db
			// TODO: create sql 65 db using sqlole65.dll mgmt interfaces 
			//		 see ssc30dbs.js for example of interfaces to use for this process
			//		 data and log devices will be placed in path provided by sDbPath
			//		 if sDbPath = null then we will use sql default device path.
			// UINT unDataSize = 1;  // size in MB for customer sql65 db data devices, goes away with sql70
			// UINT unLogSize = 1;  // size in MB for customer sql65 db log devices, goes away with sql70
			// if (FAILED(hr)) return hr;
		}
	}

	return S_OK;
}


STDMETHODIMP CCustomers::DbDelete(BSTR sDbName, BSTR sDbPath)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	HRESULT hr = E_FAIL;

	if (m_sDbHost.Length())  // ensure we only process if m_sDbHost member value provided
	{
		if (_tcsstr(m_sDbHost, _T(".mdb")))
		{
			// delete access db
			CComPtr<IFileSystem> pFileSystem;
			CComBSTR sDestination = sDbPath;
			sDestination.Append(_T("\\")); sDestination.Append(sDbName); sDestination.Append(_T(".mdb"));
			
			hr = pFileSystem.CoCreateInstance(_T("Scripting.FileSystemObject"), NULL, CLSCTX_ALL);
			if(FAILED(hr)) return hr;

			if (pFileSystem->FileExists(sDestination.m_str))
			{
				hr = pFileSystem->DeleteFile(sDestination.m_str, FALSE);
				if (FAILED(hr)) return hr;
			}
		}
		else
		{
			// create sql 65 db
			// TODO: create sql 65 db using sqlole65.dll mgmt interfaces 
			//		 see ssc30dbs.js for example of interfaces to use for this process
			//		 data and log devices will be placed in path provided by sDbPath
			//		 if sDbPath = null then we will use sql default device path.
			// UINT unDataSize = 1;  // size in MB for customer sql65 db data devices, goes away with sql70
			// UINT unLogSize = 1;  // size in MB for customer sql65 db log devices, goes away with sql70
			// if (FAILED(hr)) return hr;
		}
	}

	return S_OK;
}


STDMETHODIMP CCustomers::DsnCreate(BSTR sDsn, BSTR sPathOrServer)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	if (m_sDbHost.Length())  // ensure we only process if m_sDbHost member value provided
	{
		CComBSTR sDriver; // , sAttributes;
		_TCHAR aAttributes[MAX_CB_BUFFER] = {_T("\0")};

		if (_tcsstr(m_sDbHost, _T(".mdb")))
		{
			sDriver = ACCESS_DRIVER; 
			wsprintf(aAttributes, _T("DSN=%s%cDESCRIPTION=created by IcuHost provisioning service%cDBQ=%s\\%s.mdb%c"), sDsn, _T('\0'), _T('\0'), sPathOrServer, sDsn, _T('\0'));
			/*
			sAttributes = _T("DSN="); sAttributes.Append(sDsn); sAttributes.Append(_T("\0"));
			sAttributes.Append(_T("DESCRIPTION=created by IcuHost provisioning service")); sAttributes.Append(_T("\0"));
			sAttributes.Append(_T("DBQ=")); sAttributes.Append(sPathOrServer); sAttributes.Append(_T("\\"));
			sAttributes.Append(sDsn); sAttributes.Append(_T(".mdb")); sAttributes.Append(_T("\0"));
			*/
		}
		else
		{
			sDriver = SQL_DRIVER;
			wsprintf(aAttributes, _T("DSN=%s%cDESCRIPTION=created by IcuHost provisioning service%cSERVER=%s%cDATABASE=%s%c"), sDsn, _T('\0'), _T('\0'), sPathOrServer, _T('\0'), sDsn, _T('\0'));
			/*
			sAttributes = _T("DSN="); sAttributes.Append(sDsn); sAttributes.Append(_T("\0"));
			sAttributes.Append(_T("DESCRIPTION=created by IcuHost provisioning service")); sAttributes.Append(_T("\0"));
			sAttributes.Append(_T("SERVER=")); sAttributes.Append(sPathOrServer); sAttributes.Append(_T("\0"));
			sAttributes.Append(_T("DATABASE=")); sAttributes.Append(sDsn); sAttributes.Append(_T("\0"));
			*/
		}
				
		BOOL br = SQLConfigDataSource(NULL, ODBC_ADD_SYS_DSN, sDriver, aAttributes);
		if (!br) 
		{
			WORD nError = 0, cbErrorMsgMax = MAX_CB_ERRORINFO, cbErrorMsg = 0;
			DWORD dwErrorCode = 0;
			_TCHAR szErrorMsg[MAX_CB_ERRORINFO] = {_T("\0")};
			RETCODE rc = SQLInstallerError(nError, &dwErrorCode, szErrorMsg, cbErrorMsgMax, &cbErrorMsg);
			if (SQL_ERROR == rc)
			{
				if (dwErrorCode)  // 0 == dwErrorCode is allowable
					return E_FAIL;
			}
		}
	}

	return S_OK;
}


STDMETHODIMP CCustomers::DsnDelete(BSTR sDsn, BSTR sPathOrServer)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	if (m_sDbHost.Length())  // ensure we only process if m_sDbHost member value provided
	{
		CComBSTR sDriver; // , sAttributes;
		_TCHAR aAttributes[MAX_CB_BUFFER] = {_T("\0")};

		if (_tcsstr(m_sDbHost, _T(".mdb")))
		{
			sDriver = ACCESS_DRIVER; 
			wsprintf(aAttributes, _T("DSN=%s%cDESCRIPTION=created by IcuHost provisioning service%cDBQ=%s\\%s.mdb%c"), sDsn, _T('\0'), _T('\0'), sPathOrServer, sDsn, _T('\0'));
			/*
			sAttributes = _T("DSN="); sAttributes.Append(sDsn); sAttributes.Append(_T("\0"));
			sAttributes.Append(_T("DESCRIPTION=created by IcuHost provisioning service")); sAttributes.Append(_T("\0"));
			sAttributes.Append(_T("DBQ=")); sAttributes.Append(sPathOrServer); sAttributes.Append(_T("\\"));
			sAttributes.Append(sDsn); sAttributes.Append(_T(".mdb")); sAttributes.Append(_T("\0"));
			*/
		}
		else
		{
			sDriver = SQL_DRIVER;
			wsprintf(aAttributes, _T("DSN=%s%cDESCRIPTION=created by IcuHost provisioning service%cSERVER=%s%cDATABASE=%s%c"), sDsn, _T('\0'), _T('\0'), sPathOrServer, _T('\0'), sDsn, _T('\0'));
			/*
			sAttributes = _T("DSN="); sAttributes.Append(sDsn); sAttributes.Append(_T("\0"));
			sAttributes.Append(_T("DESCRIPTION=created by IcuHost provisioning service")); sAttributes.Append(_T("\0"));
			sAttributes.Append(_T("SERVER=")); sAttributes.Append(sPathOrServer); sAttributes.Append(_T("\0"));
			sAttributes.Append(_T("DATABASE=")); sAttributes.Append(sDsn); sAttributes.Append(_T("\0"));
			*/
		}
		
		BOOL br = SQLConfigDataSource(NULL, ODBC_REMOVE_SYS_DSN, sDriver, aAttributes);
		if (!br) 
		{
			WORD nError = 0, cbErrorMsgMax = MAX_CB_ERRORINFO, cbErrorMsg = 0;
			DWORD dwErrorCode = 0;
			_TCHAR szErrorMsg[MAX_CB_ERRORINFO] = {_T("\0")};
			RETCODE rc = SQLInstallerError(nError, &dwErrorCode, szErrorMsg, cbErrorMsgMax, &cbErrorMsg);
			if (SQL_ERROR == rc)
			{
				if (dwErrorCode)  // 0 == dwErrorCode is allowable
					return E_FAIL;
			}
		}	
	}

	return S_OK;
}


STDMETHODIMP CCustomers::FolderCreate(BSTR sFolder)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	HRESULT hr = E_FAIL;
	CComPtr<IFileSystem> pFileSystem;
	CComPtr<IFolder> pFolder;

	hr = pFileSystem.CoCreateInstance(_T("Scripting.FileSystemObject"), NULL, CLSCTX_ALL);
	if(FAILED(hr)) return hr;

	if (!pFileSystem->FolderExists(sFolder))
		pFolder = pFileSystem->CreateFolder(sFolder);

	return S_OK;	
}


STDMETHODIMP CCustomers::FolderDelete(BSTR sFolder)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	HRESULT hr = E_FAIL;
	CComPtr<IFileSystem> pFileSystem;
	
	hr = pFileSystem.CoCreateInstance(_T("Scripting.FileSystemObject"), NULL, CLSCTX_ALL);
	if(FAILED(hr)) return hr;

	if (pFileSystem->FolderExists(sFolder))
		hr = pFileSystem->DeleteFolder(sFolder, FALSE);

	return S_OK;
}


STDMETHODIMP CCustomers::FtpSrvCreate(BSTR sIpAddress, BSTR sFtpSrvName, BSTR sPath, BOOL bAllowAnonymous, DWORD dwAccessFlags)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	HRESULT hr = E_FAIL;
	CComPtr<IMSAdminBase> pIMeta;  
	METADATA_HANDLE hMd = NULL;
	CComBSTR sSubKeyName;
	_TCHAR aBuffer[MAX_CB_BUFFER] = {_T("\0")};
	DWORD dwBuffer = 0;
	
	try
	{
		if (0 == m_unFtpSrvNumNext)  // we haven't yet resolved what the next FtpSrv number should be
		{
			hr = get_FtpSrvNumNext(NULL);
			if (FAILED(hr)) throw(hr);
		}
		
		hr = pIMeta.CoCreateInstance(__uuidof(IMSAdminBase), NULL, CLSCTX_ALL);
		if (FAILED(hr)) throw(hr);  

		// get a handle to the local machine MsFtpSvc
		sSubKeyName = _T("/LM/MSFTPSVC");  // localmachine path
		hr = pIMeta->OpenKey(METADATA_MASTER_ROOT_HANDLE, sSubKeyName, 
							(METADATA_PERMISSION_READ | METADATA_PERMISSION_WRITE),
							 METADATA_TIMEOUT, &hMd); 
		if (FAILED(hr)) throw(hr);
				
		_ultot((ULONG)m_unFtpSrvNumNext, aBuffer, 10);
		sSubKeyName.Empty(); sSubKeyName = aBuffer;
		hr = pIMeta->AddKey(hMd, sSubKeyName);
		if (FAILED(hr)) throw(hr); 

		// now that we have successfully added the FtpSrvNumNext key we need
		// to increment the member counter so that future uses will be accurate
		m_unFtpSrvNumNext++;
		
		METADATA_RECORD tMdRec;
		tMdRec.dwMDIdentifier = MD_KEY_TYPE;
		tMdRec.dwMDAttributes =  METADATA_NO_ATTRIBUTES;
		tMdRec.dwMDUserType = IIS_MD_UT_SERVER;		  
		tMdRec.dwMDDataType = STRING_METADATA;	  
		tMdRec.pbMDData = reinterpret_cast<unsigned char *>(_T("IIsFtpServer"));
		tMdRec.dwMDDataLen = sizeof(_TCHAR) * (_tcslen(_T("IIsFtpServer")) + 1);
		hr = pIMeta->SetData(hMd, sSubKeyName, &tMdRec);
		if (FAILED(hr)) throw(hr);

		tMdRec.dwMDIdentifier = MD_SERVER_COMMENT;
		tMdRec.dwMDAttributes =  METADATA_INHERIT;
		tMdRec.dwMDUserType = IIS_MD_UT_SERVER;		  
		tMdRec.dwMDDataType = STRING_METADATA;	  
		tMdRec.pbMDData = reinterpret_cast<unsigned char *>(sFtpSrvName);
		tMdRec.dwMDDataLen = sizeof(_TCHAR) * (_tcslen(sFtpSrvName) + 1);
		hr = pIMeta->SetData(hMd, sSubKeyName, &tMdRec);
		if (FAILED(hr)) throw(hr);

		tMdRec.dwMDIdentifier = MD_SERVER_STATE;
		tMdRec.dwMDAttributes =  METADATA_NO_ATTRIBUTES;
		tMdRec.dwMDUserType = IIS_MD_UT_SERVER;		  
		tMdRec.dwMDDataType = DWORD_METADATA;
		dwBuffer = MD_SERVER_STATE_STOPPED;
		tMdRec.pbMDData = reinterpret_cast<unsigned char *>(&dwBuffer);
		tMdRec.dwMDDataLen = sizeof(DWORD);
		hr = pIMeta->SetData(hMd, sSubKeyName, &tMdRec);
		if (FAILED(hr)) throw(hr);

		tMdRec.dwMDIdentifier = MD_SERVER_BINDINGS;
		tMdRec.dwMDAttributes =  METADATA_NO_ATTRIBUTES;
		tMdRec.dwMDUserType = IIS_MD_UT_SERVER;		  
		tMdRec.dwMDDataType = MULTISZ_METADATA;
		wsprintf(aBuffer, _T("%s:21:\0\0"), sIpAddress); 
		tMdRec.pbMDData = reinterpret_cast<unsigned char *>(aBuffer);
		tMdRec.dwMDDataLen = sizeof(_TCHAR) * (_tcslen(aBuffer) + 2); // + 2 so that we terminate multisz with two NULL chars
		hr = pIMeta->SetData(hMd, sSubKeyName, &tMdRec);
		if (FAILED(hr)) throw(hr);

		tMdRec.dwMDIdentifier = MD_WIN32_ERROR;
		tMdRec.dwMDAttributes =  METADATA_NO_ATTRIBUTES;
		tMdRec.dwMDUserType = IIS_MD_UT_SERVER;		  
		tMdRec.dwMDDataType = DWORD_METADATA;
		dwBuffer = 0x0;
		tMdRec.pbMDData = reinterpret_cast<unsigned char *>(&dwBuffer);
		tMdRec.dwMDDataLen = sizeof(DWORD);
		hr = pIMeta->SetData(hMd, sSubKeyName, &tMdRec);
		if (FAILED(hr)) throw(hr);

		tMdRec.dwMDIdentifier = MD_ALLOW_ANONYMOUS;
		tMdRec.dwMDAttributes =  METADATA_INHERIT;
		tMdRec.dwMDUserType = IIS_MD_UT_SERVER;		  
		tMdRec.dwMDDataType = DWORD_METADATA;
		dwBuffer = bAllowAnonymous;
		tMdRec.pbMDData = reinterpret_cast<unsigned char *>(&dwBuffer);
		tMdRec.dwMDDataLen = sizeof(DWORD);
		hr = pIMeta->SetData(hMd, sSubKeyName, &tMdRec);
		if (FAILED(hr)) throw(hr);

		sSubKeyName.Append(_T("/Root"));
		hr = pIMeta->AddKey(hMd, sSubKeyName);
		if (FAILED(hr)) throw(hr); 

		tMdRec.dwMDIdentifier = MD_KEY_TYPE;
		tMdRec.dwMDAttributes =  METADATA_NO_ATTRIBUTES;
		tMdRec.dwMDUserType = IIS_MD_UT_SERVER;		  
		tMdRec.dwMDDataType = STRING_METADATA;	  
		tMdRec.pbMDData = reinterpret_cast<unsigned char *>(_T("IIsFtpVirtualDir"));
		tMdRec.dwMDDataLen = sizeof(_TCHAR) * (_tcslen(_T("IIsFtpVirtualDir")) + 1);
		hr = pIMeta->SetData(hMd, sSubKeyName, &tMdRec);
		if (FAILED(hr)) throw(hr);

		tMdRec.dwMDIdentifier = MD_WIN32_ERROR;
		tMdRec.dwMDAttributes =  METADATA_INHERIT;
		tMdRec.dwMDUserType = IIS_MD_UT_SERVER;		  
		tMdRec.dwMDDataType = DWORD_METADATA;
		dwBuffer = 0x0;
		tMdRec.pbMDData = reinterpret_cast<unsigned char *>(&dwBuffer);
		tMdRec.dwMDDataLen = sizeof(DWORD);
		hr = pIMeta->SetData(hMd, sSubKeyName, &tMdRec);
		if (FAILED(hr)) throw(hr);

		tMdRec.dwMDIdentifier = MD_VR_PATH;
		tMdRec.dwMDAttributes =  METADATA_INHERIT;
		tMdRec.dwMDUserType = IIS_MD_UT_FILE;		  
		tMdRec.dwMDDataType = STRING_METADATA;
		tMdRec.pbMDData = reinterpret_cast<unsigned char *>(sPath);
		tMdRec.dwMDDataLen = sizeof(_TCHAR) * (_tcslen(sPath) + 1);
		hr = pIMeta->SetData(hMd, sSubKeyName, &tMdRec);
		if (FAILED(hr)) throw(hr);

		tMdRec.dwMDIdentifier = MD_ACCESS_PERM;
		tMdRec.dwMDAttributes =  METADATA_INHERIT;
		tMdRec.dwMDUserType = IIS_MD_UT_FILE;		  
		tMdRec.dwMDDataType = DWORD_METADATA;
		dwBuffer = dwAccessFlags;
		tMdRec.pbMDData = reinterpret_cast<unsigned char *>(&dwBuffer);
		tMdRec.dwMDDataLen = sizeof(DWORD);
		hr = pIMeta->SetData(hMd, sSubKeyName, &tMdRec);
		if (FAILED(hr)) throw(hr);

		// optionally save the data to disk otherwise handled 
		// by iisadmin service automatically
		// hr = pIMeta->SaveData();
		// if (FAILED(hr)) throw(hr);

		hr = pIMeta->CloseKey(hMd);
		if (FAILED(hr)) throw(hr); 
		
		// close down metabase handle before departing
		if (pIMeta && hMd)
          pIMeta->CloseKey(hMd);

		return S_OK;
	}

	catch(HRESULT hrLastError)
    {
		GetLastErrorData(hrLastError);  // sets m_lLastErrorNum and m_sLastErrorDesc

		// close down metabase handle before departing
		if (pIMeta && hMd)
            pIMeta->CloseKey(hMd);

		return E_FAIL;
    }

	catch(...)  // any type including C, system and application generated exceptions
    {
		GetLastErrorData(0x0);  // sets m_lLastErrorNum and m_sLastErrorDesc

		// close down metabase handle before departing
		if (pIMeta && hMd)
            pIMeta->CloseKey(hMd);

		return E_FAIL;
	}
}


STDMETHODIMP CCustomers::FtpSrvDelete(BSTR sIpAddress, BSTR sFtpSrvName)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	HRESULT hr = E_FAIL; 
	CComPtr<IMSAdminBase> pIMeta;  
	METADATA_HANDLE hMd;
	CComBSTR sSubKeyName;
	_TCHAR aBuffer[METADATA_MAX_NAME_LEN] = {_T("\0")};
	int nIndex = 0;
	METADATA_RECORD tMdRec;
	DWORD dwMdReqDataLen = 0;
	_TCHAR szMDData[MAX_CB_BUFFER] = {_T("\0")};

	try
	{
		hr = pIMeta.CoCreateInstance(__uuidof(IMSAdminBase), NULL, CLSCTX_ALL);
		if (FAILED(hr)) throw(hr);
		
		// get a handle to the local machine ftp service
		sSubKeyName = _T("/LM/MSFTPSVC");
		hr = pIMeta->OpenKey(METADATA_MASTER_ROOT_HANDLE, sSubKeyName,
							(METADATA_PERMISSION_READ | METADATA_PERMISSION_WRITE),
							 METADATA_TIMEOUT, &hMd); 
		if (FAILED(hr)) throw(hr);

		while (SUCCEEDED(hr))  // loop until there are no more subkeys 
		{  
			// enumerate the subkeys of the localmachine ftp service
			// hr = pIMeta->EnumKeys(hMd, NULL, aBuffer, nIndex);
			hr = pIMeta->EnumKeys(hMd, NULL, aBuffer, nIndex);
			sSubKeyName.Empty(); sSubKeyName = aBuffer;
			if (SUCCEEDED(hr))
			{ 
				tMdRec.dwMDIdentifier = MD_KEY_TYPE;
				tMdRec.dwMDAttributes = (METADATA_INHERIT | METADATA_INSERT_PATH |
				 						 METADATA_ISINHERITED | METADATA_PARTIAL_PATH);
				tMdRec.dwMDUserType = IIS_MD_UT_SERVER;		  
				tMdRec.dwMDDataType = STRING_METADATA;
				tMdRec.pbMDData	= reinterpret_cast<unsigned char *>(szMDData);
				tMdRec.dwMDDataLen = sizeof(_TCHAR) * MAX_CB_BUFFER;
				hr = pIMeta->GetData(hMd, sSubKeyName, &tMdRec, &dwMdReqDataLen);
				if (FAILED(hr)) throw(hr);
				if (!_tcscmp(_T("IIsFtpServer"), (LPCTSTR)tMdRec.pbMDData))
				{
					tMdRec.dwMDIdentifier = MD_SERVER_COMMENT;
					tMdRec.dwMDDataLen = sizeof(_TCHAR) * MAX_CB_BUFFER;
					hr = pIMeta->GetData(hMd, sSubKeyName, &tMdRec, &dwMdReqDataLen);
					if (!_tcscmp(sFtpSrvName, (LPCTSTR)tMdRec.pbMDData))
					{
						// found the FtpSrv in question so lets delete it and return
						hr = pIMeta->DeleteKey(hMd, sSubKeyName);
						if (FAILED(hr)) throw(hr); 
						return S_OK;
					}
				}
				nIndex++; // increment the index so next EnumKeys call can be made
			}
			else
			{
				if (ERROR_NO_MORE_ITEMS != hr)
					hr = E_FAIL; // throw(hr);
			}
		}

		// close down metabase handle before departing
		if (pIMeta && hMd)
			pIMeta->CloseKey(hMd);

		return S_OK;
	}

	catch(HRESULT hrLastError)
    {
		GetLastErrorData(hrLastError);  // sets m_lLastErrorNum and m_sLastErrorDesc
		
		// close down metabase handle before departing
		if (pIMeta && hMd)
            pIMeta->CloseKey(hMd);

		return E_FAIL;
	}

	catch(...)  // any type including C, system and application generated exceptions
    {
		GetLastErrorData(0x0);  // sets m_lLastErrorNum and m_sLastErrorDesc
		
		// close down metabase handle before departing
		if (pIMeta && hMd)
            pIMeta->CloseKey(hMd);

		return E_FAIL;
	}
}


STDMETHODIMP CCustomers::GetLastErrorData(LONG lLastErrorNum)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    HMODULE hModule = NULL;  // default to standard system dlls as source for api returned errors
    LPTSTR pszLastErrorDesc = NULL;
    UINT cbLastErrorDesc = 0;
	_TCHAR szText[MAX_CB_BUFFER] = {_T("\0")}, szCaption[MAX_CB_BUFFER] = {_T("\0")};

	if (lLastErrorNum)  // check if caller passed a lLastErrorNum using a HRESULT value
		m_lLastErrorNum = lLastErrorNum;  // assign value also to the member variable 										 
	else    // caller did not pass a lLastErrorNum using a HRESULT value
	{
		lLastErrorNum = GetLastError();  // acquire the lLastErrorNum value from GetLastError() api
		m_lLastErrorNum = lLastErrorNum;  // assign value also to the member variable
	}

    DWORD dwFormatFlags = FORMAT_MESSAGE_ALLOCATE_BUFFER |
						  FORMAT_MESSAGE_IGNORE_INSERTS |
						  FORMAT_MESSAGE_FROM_SYSTEM ;

    // if lLastErrorNum is in the network range, load the message source
    if (lLastErrorNum >= NERR_BASE && lLastErrorNum <= MAX_NERR) 
	{
        hModule = LoadLibraryEx(_T("netmsg.dll"), NULL, LOAD_LIBRARY_AS_DATAFILE);
        if (hModule)
			dwFormatFlags |= FORMAT_MESSAGE_FROM_HMODULE;
    }

    // use FormatMessage() to acquire the text information for a given error number
	cbLastErrorDesc = FormatMessage(dwFormatFlags, hModule, lLastErrorNum,
									MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // use default language
								   (LPTSTR)&pszLastErrorDesc, 0, NULL);
    if (cbLastErrorDesc)
    {
        // if we are in debug mode then output error message to stderr
		#ifdef _DEBUG
			DWORD dwBytesWritten = 0;
			WriteFile(GetStdHandle(STD_ERROR_HANDLE), pszLastErrorDesc, 
					  (sizeof(_TCHAR) * cbLastErrorDesc), &dwBytesWritten, NULL);
		#endif

		// if this is a console application then output the error description to stdout
		// printf("errNum=%lu, errDesc=\"%s\"\n", lLastErrorNum, pszLastErrorDesc);

		// if this is a windows application then output the error description to a MessageBox
		// wsprintf(szText, _T("Api or COM interface call produced error %lu,\n%s."), lLastErrorNum, pszLastErrorDesc);
		// wsprintf(szCaption, _T("GetLastErrorData"));
		// MessageBox(NULL, szText, szCaption,  MB_OK | MB_ICONINFORMATION);
       
        // assign error values to member variable and free the buffer allocated by the api call
		m_sLastErrorDesc.Append(_ltot(lLastErrorNum, szText, 10));
		m_sLastErrorDesc.Append(_T(", ")); m_sLastErrorDesc.Append(pszLastErrorDesc);
        LocalFree(pszLastErrorDesc);
    }

    // if we loaded a message source, unload it
    if (hModule != NULL)
		FreeLibrary(hModule);

	return S_OK;
}


STDMETHODIMP CCustomers::UserCreate(BSTR sUserId, BSTR sPassword, BSTR sFullName)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	HRESULT hr = E_FAIL; 
	CComPtr<IADsContainer> pContainer;
	CComPtr<IADs> pNewObject, pExistingObject;
	CComPtr<IADsUser> pUser;
	CComPtr<IADsGroup> pGroup;
	CComBSTR sADsPath;

	sADsPath = m_sNameSpace;
	sADsPath.Append(_T("://"));
	if (m_sWntDomain.Length())
		sADsPath.Append(m_sWntDomain);
	else
		sADsPath.Append(m_sHost);

	// bind to the known container
	hr = ADsGetObject(sADsPath, IID_IADsContainer, (void**)&pContainer);
	if (FAILED(hr)) return hr;

	// create the new user object wrapper
	hr = pContainer->Create(_T("User"), sUserId, (LPDISPATCH *)&pNewObject);
	if (FAILED(hr)) return hr;

	// get the IADsUser interface from the wrapper
	hr = pNewObject->QueryInterface(IID_IADsUser, (void **)&pUser);
	if (FAILED(hr)) return hr;

	// need to add some way to first check if the user already exists so 
	// that we can just return S_OK based on the fact that the desired 
	// user is now in place regardless of whether or not we created it or
	// it was already there.  Perhaps adjust all it's settings if it already exists.

	// write new object to the DS
	hr = pUser->put_FullName(sUserId);
	hr = pUser->put_Description(_T("created by IcuHost provisioning service"));
	
	COleDateTime tExpireDate = COleDateTime::GetCurrentTime();
	int nYear = tExpireDate.GetYear(), 
		nMonth = tExpireDate.GetMonth(), 
		nDay = tExpireDate.GetDay();

	// set expire date for one year from today
	tExpireDate.SetDate((nYear + 1), nMonth, nDay);
	nYear = tExpireDate.GetYear();
	int nTest = tExpireDate.valid;
	if (tExpireDate.valid != tExpireDate.GetStatus())
	{
		hr = E_FAIL;
		return hr;
	}

	hr = pUser->put_AccountExpirationDate(tExpireDate);
	hr = pUser->put_PasswordExpirationDate(tExpireDate);
	hr = pUser->SetInfo();
	if (FAILED(hr) & (0x800708b0 != hr))
		return hr;  // hr = 0x800708b0 when user already exists
	
	if (0x800708b0 != hr) // don't reset pwd when user already exists
	{
		// set the password
		hr = pUser->SetPassword(sUserId);
		if (FAILED(hr) & (0x800708c5 != hr))
			return hr;  // hr = 0x800708c5 when setting pwd too short for current account policy
						//      setting therefore allow routine to complete but note that pwd 
						//		will need to be reset before account can be used.
						// hr = 0xb8fdd9af when ???
	}

	// get the existing group object wrapper 
	hr = pContainer->GetObject(_T("Group"), _T("Users"), (LPDISPATCH *)&pExistingObject);
	
	// get the IADsGroup interface from the wrapper
	hr = pExistingObject->QueryInterface(IID_IADsGroup, (void **)&pGroup);
	if (FAILED(hr)) return hr;
  
	// obtain the new user's ADsPath
	CComBSTR sNewUserADsPath;
	hr = pUser->get_ADsPath(&sNewUserADsPath.m_str);
	if (FAILED(hr)) return hr;
	/* OR
	sNewUserADsPath = sADsPath; sNewUserADsPath.Append(_T("/")); sNewUserADsPath.Append(sUserId);
	*/

	// add the new user to the default group "Users"
	hr = pGroup->Add(sNewUserADsPath);
	if (FAILED(hr) & (0x80070562 != hr))
		return hr;  // hr = 0x80070562 when user already a member of group

	// cleanup not required because we are using smart pointers
	// pGroup.Release();
	// pExistingObject.Release();
	// pUser.Release();
	// pNewObject.Release();
	// pContainer.Release();

	return S_OK;
}


STDMETHODIMP CCustomers::UserDelete(BSTR sUserId)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())
	
	HRESULT hr = E_FAIL; 
	CComPtr<IADsContainer> pContainer;
	CComBSTR sADsPath = NULL;

	sADsPath = m_sNameSpace; 
	sADsPath.Append(_T("://"));
	if (m_sWntDomain.Length())
		sADsPath.Append(m_sWntDomain);
	else
		sADsPath.Append(m_sHost);

	// Bind to the known container.
	hr = ADsGetObject(sADsPath, IID_IADsContainer, (void**)&pContainer);
	if (FAILED(hr)) return hr;

	// Delete the userid
	hr = pContainer->Delete(_T("User"), sUserId);
	if (FAILED(hr) & (0x800708ad != hr)) 
		return hr;  // hr = 0x800708ad when user did not exist
	
	// cleanup not required because we are using smart pointers
	// pContainer.Release();
	
	return S_OK;
}


STDMETHODIMP CCustomers::WebSrvCreate(BSTR sIpAddress, BSTR sWebSrvName, BSTR sPath, DWORD dwAuthFlags, DWORD dwAccessFlags)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	HRESULT hr = E_FAIL;
	CComPtr<IMSAdminBase> pIMeta;  
	METADATA_HANDLE hMd = NULL;
	CComBSTR sSubKeyName;
	_TCHAR aBuffer[MAX_CB_BUFFER] = {_T("\0")};
	DWORD dwBuffer = 0;
	
	try
	{
		if (0 == m_unWebSrvNumNext)
		{
			hr = get_WebSrvNumNext(NULL);
			if (FAILED(hr)) throw(hr);
		}
		
		hr = pIMeta.CoCreateInstance(__uuidof(IMSAdminBase), NULL, CLSCTX_ALL);
		if (FAILED(hr)) throw(hr);  

		// get a handle to the local machine MsWebSvc
		sSubKeyName = _T("/LM/W3SVC");  // localmachine path
		hr = pIMeta->OpenKey(METADATA_MASTER_ROOT_HANDLE, sSubKeyName, 
							(METADATA_PERMISSION_READ | METADATA_PERMISSION_WRITE),
							 METADATA_TIMEOUT, &hMd); 
		if (FAILED(hr)) throw(hr);
				
		_ultot((ULONG)m_unWebSrvNumNext, aBuffer, 10);
		sSubKeyName.Empty(); sSubKeyName = aBuffer;
		hr = pIMeta->AddKey(hMd, sSubKeyName);
		if (FAILED(hr)) throw(hr); 

		// now that we have successfully added the WebSrvNumNext key we need
		// to increment the member counter so that future uses will be accurate
		m_unWebSrvNumNext++;

		METADATA_RECORD tMdRec;
		tMdRec.dwMDIdentifier = MD_MAX_BANDWIDTH;
		tMdRec.dwMDAttributes =  METADATA_NO_ATTRIBUTES;
		tMdRec.dwMDUserType = IIS_MD_UT_SERVER;		  
		tMdRec.dwMDDataType = DWORD_METADATA;
		dwBuffer = 0x100000; // = 1048576Kbs -> 1Mbs
		tMdRec.pbMDData = reinterpret_cast<unsigned char *>(&dwBuffer);
		tMdRec.dwMDDataLen = sizeof(DWORD);
		hr = pIMeta->SetData(hMd, sSubKeyName, &tMdRec);
		if (FAILED(hr)) throw(hr);

		tMdRec.dwMDIdentifier = MD_KEY_TYPE;
		tMdRec.dwMDAttributes =  METADATA_NO_ATTRIBUTES;
		tMdRec.dwMDUserType = IIS_MD_UT_SERVER;		  
		tMdRec.dwMDDataType = STRING_METADATA;	  
		tMdRec.pbMDData = reinterpret_cast<unsigned char *>(_T("IIsWebServer"));
		tMdRec.dwMDDataLen = sizeof(_TCHAR) * (_tcslen(_T("IIsWebServer")) + 1);
		hr = pIMeta->SetData(hMd, sSubKeyName, &tMdRec);
		if (FAILED(hr)) throw(hr);

		tMdRec.dwMDIdentifier = MD_MAX_CONNECTIONS;
		tMdRec.dwMDAttributes =  METADATA_NO_ATTRIBUTES;
		tMdRec.dwMDUserType = IIS_MD_UT_SERVER;		  
		tMdRec.dwMDDataType = DWORD_METADATA;
		dwBuffer = 0x3e8; // = 1000 Connections
		tMdRec.pbMDData = reinterpret_cast<unsigned char *>(&dwBuffer);
		tMdRec.dwMDDataLen = sizeof(DWORD);
		hr = pIMeta->SetData(hMd, sSubKeyName, &tMdRec);
		if (FAILED(hr)) throw(hr);

		tMdRec.dwMDIdentifier = MD_SERVER_COMMENT;
		tMdRec.dwMDAttributes =  METADATA_INHERIT;
		tMdRec.dwMDUserType = IIS_MD_UT_SERVER;		  
		tMdRec.dwMDDataType = STRING_METADATA;	  
		tMdRec.pbMDData = reinterpret_cast<unsigned char *>(sWebSrvName);
		tMdRec.dwMDDataLen = sizeof(_TCHAR) * (_tcslen(sWebSrvName) + 1);
		hr = pIMeta->SetData(hMd, sSubKeyName, &tMdRec);
		if (FAILED(hr)) throw(hr);

		tMdRec.dwMDIdentifier = MD_SERVER_STATE;
		tMdRec.dwMDAttributes =  METADATA_NO_ATTRIBUTES;
		tMdRec.dwMDUserType = IIS_MD_UT_SERVER;		  
		tMdRec.dwMDDataType = DWORD_METADATA;
		dwBuffer = MD_SERVER_STATE_STOPPED;
		tMdRec.pbMDData = reinterpret_cast<unsigned char *>(&dwBuffer);
		tMdRec.dwMDDataLen = sizeof(DWORD);
		hr = pIMeta->SetData(hMd, sSubKeyName, &tMdRec);
		if (FAILED(hr)) throw(hr);

		tMdRec.dwMDIdentifier = MD_SERVER_BINDINGS;
		tMdRec.dwMDAttributes =  METADATA_NO_ATTRIBUTES;
		tMdRec.dwMDUserType = IIS_MD_UT_SERVER;		  
		tMdRec.dwMDDataType = MULTISZ_METADATA;
		wsprintf(aBuffer, _T("%s:80:\0\0"), sIpAddress); 
		tMdRec.pbMDData = reinterpret_cast<unsigned char *>(aBuffer);
		tMdRec.dwMDDataLen = sizeof(_TCHAR) * (_tcslen(aBuffer) + 2); // + 2 so that we terminate multisz with two NULL chars
		hr = pIMeta->SetData(hMd, sSubKeyName, &tMdRec);
		if (FAILED(hr)) throw(hr);

		tMdRec.dwMDIdentifier = MD_WIN32_ERROR;
		tMdRec.dwMDAttributes =  METADATA_NO_ATTRIBUTES;
		tMdRec.dwMDUserType = IIS_MD_UT_SERVER;		  
		tMdRec.dwMDDataType = DWORD_METADATA;
		dwBuffer = 0x0;
		tMdRec.pbMDData = reinterpret_cast<unsigned char *>(&dwBuffer);
		tMdRec.dwMDDataLen = sizeof(DWORD);
		hr = pIMeta->SetData(hMd, sSubKeyName, &tMdRec);
		if (FAILED(hr)) throw(hr);

		tMdRec.dwMDIdentifier = MD_FRONTPAGE_WEB;
		tMdRec.dwMDAttributes =  METADATA_NO_ATTRIBUTES;
		tMdRec.dwMDUserType = IIS_MD_UT_FILE;		  
		tMdRec.dwMDDataType = DWORD_METADATA;
		dwBuffer = TRUE;
		tMdRec.pbMDData = reinterpret_cast<unsigned char *>(&dwBuffer);
		tMdRec.dwMDDataLen = sizeof(DWORD);
		hr = pIMeta->SetData(hMd, sSubKeyName, &tMdRec);
		if (FAILED(hr)) throw(hr);

		sSubKeyName.Append(_T("/Root"));
		hr = pIMeta->AddKey(hMd, sSubKeyName);
		if (FAILED(hr)) throw(hr); 

		tMdRec.dwMDIdentifier = MD_KEY_TYPE;
		tMdRec.dwMDAttributes =  METADATA_NO_ATTRIBUTES;
		tMdRec.dwMDUserType = IIS_MD_UT_SERVER;		  
		tMdRec.dwMDDataType = STRING_METADATA;	  
		tMdRec.pbMDData = reinterpret_cast<unsigned char *>(_T("IIsWebVirtualDir"));
		tMdRec.dwMDDataLen = sizeof(_TCHAR) * (_tcslen(_T("IIsWebVirtualDir")) + 1);
		hr = pIMeta->SetData(hMd, sSubKeyName, &tMdRec);
		if (FAILED(hr)) throw(hr);

		tMdRec.dwMDIdentifier = MD_WIN32_ERROR;
		tMdRec.dwMDAttributes =  METADATA_INHERIT;
		tMdRec.dwMDUserType = IIS_MD_UT_SERVER;		  
		tMdRec.dwMDDataType = DWORD_METADATA;
		dwBuffer = 0x0;
		tMdRec.pbMDData = reinterpret_cast<unsigned char *>(&dwBuffer);
		tMdRec.dwMDDataLen = sizeof(DWORD);
		hr = pIMeta->SetData(hMd, sSubKeyName, &tMdRec);
		if (FAILED(hr)) throw(hr);

		tMdRec.dwMDIdentifier = MD_APP_FRIENDLY_NAME;
		tMdRec.dwMDAttributes =  METADATA_INHERIT;
		tMdRec.dwMDUserType = IIS_MD_UT_WAM;		  
		tMdRec.dwMDDataType = STRING_METADATA;	  
		tMdRec.pbMDData = reinterpret_cast<unsigned char *>(_T("Default Application"));
		tMdRec.dwMDDataLen = sizeof(_TCHAR) * (_tcslen(_T("Default Application")) + 1);
		hr = pIMeta->SetData(hMd, sSubKeyName, &tMdRec);
		if (FAILED(hr)) throw(hr);

		tMdRec.dwMDIdentifier = MD_APP_ROOT;
		tMdRec.dwMDAttributes =  METADATA_INHERIT;
		tMdRec.dwMDUserType = IIS_MD_UT_FILE;		  
		tMdRec.dwMDDataType = STRING_METADATA;
		wsprintf(aBuffer, _T("/LM/W3SVC/%s"), sSubKeyName);
		tMdRec.pbMDData = reinterpret_cast<unsigned char *>(aBuffer);
		tMdRec.dwMDDataLen = sizeof(_TCHAR) * (_tcslen(aBuffer) + 1);
		hr = pIMeta->SetData(hMd, sSubKeyName, &tMdRec);
		if (FAILED(hr)) throw(hr);

		tMdRec.dwMDIdentifier = MD_APP_ISOLATED;
		tMdRec.dwMDAttributes =  METADATA_INHERIT;
		tMdRec.dwMDUserType = IIS_MD_UT_WAM;		  
		tMdRec.dwMDDataType = DWORD_METADATA;
		dwBuffer = FALSE;
		tMdRec.pbMDData = reinterpret_cast<unsigned char *>(&dwBuffer);
		tMdRec.dwMDDataLen = sizeof(DWORD);
		hr = pIMeta->SetData(hMd, sSubKeyName, &tMdRec);
		if (FAILED(hr)) throw(hr);

		tMdRec.dwMDIdentifier = MD_VR_PATH;
		tMdRec.dwMDAttributes =  METADATA_INHERIT;
		tMdRec.dwMDUserType = IIS_MD_UT_FILE;		  
		tMdRec.dwMDDataType = STRING_METADATA;
		tMdRec.pbMDData = reinterpret_cast<unsigned char *>(sPath);
		tMdRec.dwMDDataLen = sizeof(_TCHAR) * (_tcslen(sPath) + 1);
		hr = pIMeta->SetData(hMd, sSubKeyName, &tMdRec);
		if (FAILED(hr)) throw(hr);

		tMdRec.dwMDIdentifier = MD_AUTHORIZATION;
		tMdRec.dwMDAttributes =  METADATA_INHERIT;
		tMdRec.dwMDUserType = IIS_MD_UT_FILE;		  
		tMdRec.dwMDDataType = DWORD_METADATA;
		dwBuffer = dwAuthFlags;
		tMdRec.pbMDData = reinterpret_cast<unsigned char *>(&dwBuffer);
		tMdRec.dwMDDataLen = sizeof(DWORD);
		hr = pIMeta->SetData(hMd, sSubKeyName, &tMdRec);
		if (FAILED(hr)) throw(hr);

		tMdRec.dwMDIdentifier = MD_DIRECTORY_BROWSING;
		tMdRec.dwMDAttributes =  METADATA_INHERIT;
		tMdRec.dwMDUserType = IIS_MD_UT_FILE;		  
		tMdRec.dwMDDataType = DWORD_METADATA;
		dwBuffer = MD_DIRBROW_MASK;
		tMdRec.pbMDData = reinterpret_cast<unsigned char *>(&dwBuffer);
		tMdRec.dwMDDataLen = sizeof(DWORD);
		hr = pIMeta->SetData(hMd, sSubKeyName, &tMdRec);
		if (FAILED(hr)) throw(hr);

		tMdRec.dwMDIdentifier = MD_ACCESS_PERM;
		tMdRec.dwMDAttributes =  METADATA_INHERIT;
		tMdRec.dwMDUserType = IIS_MD_UT_FILE;		  
		tMdRec.dwMDDataType = DWORD_METADATA;
		dwBuffer = dwAccessFlags;
		tMdRec.pbMDData = reinterpret_cast<unsigned char *>(&dwBuffer);
		tMdRec.dwMDDataLen = sizeof(DWORD);
		hr = pIMeta->SetData(hMd, sSubKeyName, &tMdRec);
		if (FAILED(hr)) throw(hr);

		tMdRec.dwMDIdentifier = MD_IS_CONTENT_INDEXED;
		tMdRec.dwMDAttributes =  METADATA_INHERIT;
		tMdRec.dwMDUserType = IIS_MD_UT_FILE;		  
		tMdRec.dwMDDataType = DWORD_METADATA;
		dwBuffer = TRUE;
		tMdRec.pbMDData = reinterpret_cast<unsigned char *>(&dwBuffer);
		tMdRec.dwMDDataLen = sizeof(DWORD);
		hr = pIMeta->SetData(hMd, sSubKeyName, &tMdRec);
		if (FAILED(hr)) throw(hr);

		// optionally save the data to disk otherwise handled 
		// by iisadmin service automatically
		// hr = pIMeta->SaveData();
		// if (FAILED(hr)) throw(hr);

		hr = pIMeta->CloseKey(hMd);
		if (FAILED(hr)) throw(hr); 
		
		// close down metabase handle before departing
		if (pIMeta && hMd)
          pIMeta->CloseKey(hMd);

		return S_OK;
	}

	catch(HRESULT hrLastError)
    {
		GetLastErrorData(hrLastError);  // sets m_lLastErrorNum and m_sLastErrorDesc
		
		// close down metabase handle before departing
		if (pIMeta && hMd)
            pIMeta->CloseKey(hMd);

		return E_FAIL;
    }
	
	catch(...)  // any type including C, system and application generated exceptions
    {
		GetLastErrorData(0x0);  // sets m_lLastErrorNum and m_sLastErrorDesc
		
		// close down metabase handle before departing
		if (pIMeta && hMd)
            pIMeta->CloseKey(hMd);

		return E_FAIL;
	}
}


STDMETHODIMP CCustomers::WebSrvDelete(BSTR sIpAddress, BSTR sWebSrvName)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	HRESULT hr = E_FAIL; 
	CComPtr<IMSAdminBase> pIMeta;  
	METADATA_HANDLE hMd;
	CComBSTR sSubKeyName;
	_TCHAR aBuffer[METADATA_MAX_NAME_LEN] = {_T("\0")};
	int nIndex = 0;
	METADATA_RECORD tMdRec;
	DWORD dwMdReqDataLen = 0;
	_TCHAR szMDData[MAX_CB_BUFFER] = {_T("\0")};

	try
	{
		hr = pIMeta.CoCreateInstance(__uuidof(IMSAdminBase), NULL, CLSCTX_ALL);
		if (FAILED(hr)) throw(hr);
		
		// get a handle to the local machine Web service
		sSubKeyName = _T("/LM/W3SVC");
		hr = pIMeta->OpenKey(METADATA_MASTER_ROOT_HANDLE, sSubKeyName, 
							(METADATA_PERMISSION_READ | METADATA_PERMISSION_WRITE),
							 METADATA_TIMEOUT, &hMd); 
		if (FAILED(hr)) throw(hr);

		while (SUCCEEDED(hr))  // loop until there are no more subkeys 
		{  
			// enumerate the subkeys of the localmachine Web service
			// hr = pIMeta->EnumKeys(hMd, NULL, aBuffer, nIndex);
			hr = pIMeta->EnumKeys(hMd, NULL, aBuffer, nIndex);
			sSubKeyName.Empty(); sSubKeyName = aBuffer;
			if (SUCCEEDED(hr))
			{ 
				tMdRec.dwMDIdentifier = MD_KEY_TYPE;
				tMdRec.dwMDAttributes = (METADATA_INHERIT | METADATA_INSERT_PATH |
				 						 METADATA_ISINHERITED | METADATA_PARTIAL_PATH);
				tMdRec.dwMDUserType = IIS_MD_UT_SERVER;		  
				tMdRec.dwMDDataType = STRING_METADATA;
				tMdRec.pbMDData	= reinterpret_cast<unsigned char *>(szMDData);
				tMdRec.dwMDDataLen = sizeof(_TCHAR) * MAX_CB_BUFFER;
				hr = pIMeta->GetData(hMd, sSubKeyName, &tMdRec, &dwMdReqDataLen);
				if (FAILED(hr)) throw(hr);
				if (!_tcscmp(_T("IIsWebServer"), (LPCTSTR)tMdRec.pbMDData))
				{
					tMdRec.dwMDIdentifier = MD_SERVER_COMMENT;
					tMdRec.dwMDDataLen = sizeof(_TCHAR) * MAX_CB_BUFFER;
					hr = pIMeta->GetData(hMd, sSubKeyName, &tMdRec, &dwMdReqDataLen);
					if (!_tcscmp(sWebSrvName, (LPCTSTR)tMdRec.pbMDData))
					{
						// found the WebSrv in question so lets delete it and return
						hr = pIMeta->DeleteKey(hMd, sSubKeyName);
						if (FAILED(hr)) throw(hr); 
						return S_OK;
					}
				}
				nIndex++; // increment the index so next EnumKeys call can be made
			}
			else
			{
				if (ERROR_NO_MORE_ITEMS != hr)
					hr = E_FAIL; // throw(hr);
			}
		}

		// close down metabase handle before departing
		if (pIMeta && hMd)
			pIMeta->CloseKey(hMd);

		return S_OK;
	}

	catch(HRESULT hrLastError)
    {
		GetLastErrorData(hrLastError);  // sets m_lLastErrorNum and m_sLastErrorDesc
		
		// close down metabase handle before departing
		if (pIMeta && hMd)
            pIMeta->CloseKey(hMd);

		return E_FAIL;
	}

	catch(...)  // any type including C, system and application generated exceptions
    {
		GetLastErrorData(0x0);  // sets m_lLastErrorNum and m_sLastErrorDesc

		// close down metabase handle before departing
		if (pIMeta && hMd)
            pIMeta->CloseKey(hMd);

		return E_FAIL;
	}
}

