
// Customers.h : Declaration of the CCustomers

#ifndef __CUSTOMERS_H_
#define __CUSTOMERS_H_

#include "resource.h"       // main symbols
#include "define.h"			// globally used defines

/////////////////////////////////////////////////////////////////////////////
// CCustomers
class ATL_NO_VTABLE CCustomers : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CCustomers, &CLSID_Customers>,
	// public ISupportErrorInfo,
	public ISupportErrorInfoImpl<&IID_ICustomers>,
	public IConnectionPointContainerImpl<CCustomers>,
	public IDispatchImpl<ICustomers, &IID_ICustomers, &LIBID_ICUHOSTLib>
{
public:
	CCustomers()
	{
		m_pUnkMarshaler = NULL;
		m_sNameSpace = _T("WinNT");  // default the ADs name space
		m_unFtpSrvNumNext = 0;
		m_unWebSrvNumNext = 0;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_CUSTOMERS)
DECLARE_GET_CONTROLLING_UNKNOWN()

BEGIN_COM_MAP(CCustomers)
	COM_INTERFACE_ENTRY(ICustomers)
	COM_INTERFACE_ENTRY(IDispatch)
	// COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
END_COM_MAP()
BEGIN_CONNECTION_POINT_MAP(CCustomers)
END_CONNECTION_POINT_MAP()


	HRESULT FinalConstruct()
	{
		return CoCreateFreeThreadedMarshaler(
			GetControllingUnknown(), &m_pUnkMarshaler.p);
	}

	void FinalRelease()
	{
		m_pUnkMarshaler.Release();
	}

	CComPtr<IUnknown> m_pUnkMarshaler;

// ISupportsErrorInfo
   // STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// ICustomers
public:
	LONG m_lLastErrorNum;
	CComBSTR m_sLastErrorDesc;
	BOOL m_bRemoteHost;
	CComBSTR m_sDbHost;
	CComBSTR m_sHost;
	CComBSTR m_sNameSpace;
	CComBSTR m_sWntDomain;
	CComBSTR m_sHostingFolder;
	CComBSTR m_sHostingPrefix;
	DWORD m_dwIpAddressStart;
	DWORD m_dwIpAddressRange;
	DWORD m_dwSubnetMask;
	UINT m_unFtpSrvNumNext;
	UINT m_unWebSrvNumNext;
	STDMETHOD(get_DbHost)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_DbHost)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_LastErrorNum)(/*[out, retval]*/ LONG *pVal);
	STDMETHOD(get_LastErrorDesc)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(get_FtpSrvNumNext)(/*[out, retval]*/ UINT *pVal);
	STDMETHOD(get_Host)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_Host)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_HostingFolder)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_HostingFolder)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_HostingPrefix)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_HostingPrefix)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_IpAddressStart)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_IpAddressStart)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_IpAddressRange)(/*[out, retval]*/ DWORD *pVal);
	STDMETHOD(put_IpAddressRange)(/*[in]*/ DWORD newVal);
	STDMETHOD(get_NameSpace)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_NameSpace)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_SubnetMask)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_SubnetMask)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_WntDomain)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_WntDomain)(/*[in]*/ BSTR newVal);	
	STDMETHOD(get_WebSrvNumNext)(/*[out, retval]*/ UINT *pVal);
	STDMETHOD(AclModify)(BSTR sFileorFolder, BSTR sUserOrGroup, DWORD dwFileMask, DWORD dwFolderMask, DWORD dwAccessMode);
	STDMETHOD(CopyFile)(BSTR sSource, BSTR sDestination, BOOL bOverWriteFiles);
	STDMETHOD(CopyFolder)(BSTR sSource, BSTR sDestination, BOOL bOverWriteFiles);
	STDMETHOD(CustomersCreate)();
	STDMETHOD(CustomersDelete)();
	STDMETHOD(DbDelete)(BSTR sDbName, BSTR sDbPath);
	STDMETHOD(DbCreate)(BSTR sDbName, BSTR sDbPath);
	STDMETHOD(DsnCreate)(BSTR sDsn, BSTR sPathOrServer);
	STDMETHOD(DsnDelete)(BSTR sDsn, BSTR sPathOrServer);
	STDMETHOD(FtpSrvCreate)(BSTR sIpAddress, BSTR sFtpSrvName, BSTR sPath, BOOL bAllowAnonymous, DWORD dwAccessFlags);
	STDMETHOD(FtpSrvDelete)(BSTR sIpAddress, BSTR sFtpSrvName);
	STDMETHOD(FolderCreate)(BSTR sFolder);
	STDMETHOD(FolderDelete)(BSTR sFolder);
	STDMETHOD(GetLastErrorData)(LONG lLastErrorNum);
	STDMETHOD(UserCreate)(BSTR sUserId, BSTR sPassword, BSTR sFullName);
	STDMETHOD(UserDelete)(BSTR sUserId);
	STDMETHOD(WebSrvCreate)(BSTR sIpAddress, BSTR sFtpSrvName, BSTR sPath, DWORD dwAuthFlags, DWORD dwAccessFlags);
	STDMETHOD(WebSrvDelete)(BSTR sIpAddress, BSTR sFtpSrvName);
};

#endif //__CUSTOMERS_H_
