	
// Tcpip.h : Declaration of the CTcpip

#ifndef __TCPIP_H_
#define __TCPIP_H_

#include "resource.h"       // main symbols
#include "define.h"			// globally used defines

typedef DWORD (CALLBACK *LPFNWNCC2)(LPTSTR lpName, DWORD dwFlags, BOOL fForce);

/////////////////////////////////////////////////////////////////////////////
// CTcpip
class ATL_NO_VTABLE CTcpip : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CTcpip, &CLSID_Tcpip>,
	public ISupportErrorInfo,
	public IConnectionPointContainerImpl<CTcpip>,
	public IDispatchImpl<ITcpip, &IID_ITcpip, &LIBID_ICUHOSTLib>
{
public:
	CTcpip()
	{
		m_pUnkMarshaler = NULL;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_TCPIP)
DECLARE_GET_CONTROLLING_UNKNOWN()

BEGIN_COM_MAP(CTcpip)
	COM_INTERFACE_ENTRY(ITcpip)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
END_COM_MAP()
BEGIN_CONNECTION_POINT_MAP(CTcpip)
END_CONNECTION_POINT_MAP()


	HRESULT FinalConstruct()
	{
		return CoCreateFreeThreadedMarshaler(
			GetControllingUnknown(), &m_pUnkMarshaler.p);
	}

	void FinalRelease()
	{
		m_pUnkMarshaler.Release();
	}

	CComPtr<IUnknown> m_pUnkMarshaler;

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// ITcpip
public:
	STDMETHOD(get_bW2ksHost)(/*[out, retval]*/ BOOL *pVal);
	STDMETHOD(put_bW2ksHost)(/*[in]*/ BOOL newVal);
	BOOL m_bAddToExisting;
	CComBSTR m_sHost;
	DWORD m_dwIpAddressRange;
	CComBSTR m_sIpAddressRegString;
	DWORD m_dwIpAddressStart;
	CComBSTR m_sLastErrorDesc;
	LONG m_lLastErrorNum;
	CComBSTR m_sNicInstance;
	BOOL m_bRemoteHost;
	DWORD m_dwSubnetMask;
	CComBSTR m_sSubnetMaskRegString;
	STDMETHOD(get_AddToExisting)(/*[out, retval]*/ BOOL *pVal);
	STDMETHOD(put_AddToExisting)(/*[in]*/ BOOL newVal);
	STDMETHOD(get_Host)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_Host)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_IpAddressRange)(/*[out, retval]*/ DWORD *pVal);
	STDMETHOD(put_IpAddressRange)(/*[in]*/ DWORD newVal);	
	STDMETHOD(get_IpAddressRegString)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_IpAddressRegString)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_IpAddressStart)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_IpAddressStart)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_LastErrorDesc)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(get_LastErrorNum)(/*[out, retval]*/ LONG *pVal);
	STDMETHOD(get_NicInstance)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_NicInstance)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_SubnetMask)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_SubnetMask)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_SubnetMaskRegString)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_SubnetMaskRegString)(/*[in]*/ BSTR newVal);
	STDMETHOD(ApplyAddresses)();
	BOOL CloseKey(HKEY hKey, HKEY hSubKey);
	STDMETHOD(GetLastErrorData)(LONG lLastErrorNum);
};

#endif //__TCPIP_H_
