VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ftpSvc"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private g_sErrInfo As String, g_bCancel As Boolean

Public Event Status(sStatusInfo As String, ByRef bCancel As Boolean)

Public Property Get ErrInfo() As String
    ErrInfo = g_sErrInfo
End Property

Public Function ChangeFtpSrvState(sHost As String, sServerBinding As String, _
                                  lState As Long, Optional sFtpSrvName As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
  
    Dim oFtpSvc As Object, oFtpSrv As Object, iFtpSrvNum As Integer, _
        asServerBindings(0) As String
        
    asServerBindings(0) = sServerBinding
    If (sHost = "" Or asServerBindings(0) = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        ChangeFtpSrvState = 1
        Exit Function
    End If
        
    Set oFtpSvc = GetObject(NS_IIS & sHost & "/w3svc")
    RaiseEvent Status("Connected to " & sHost & ".", g_bCancel)

    If (sFtpSrvName = "") Then
        iFtpSrvNum = GetFtpSrvNum(sHost, sServerBinding)
    Else
        iFtpSrvNum = GetFtpSrvNum(sHost, sServerBinding, sFtpSrvName)
    End If
    If (iFtpSrvNum = 0) Then
        '// g_sErrInfo = already set by GetFtpSrvNum
        ChangeFtpSrvState = 1
        Exit Function
    End If
    
    Set oFtpSrv = oFtpSvc.GetObject("IIsFtpServer", CStr(iFtpSrvNum))
    
    Select Case (lState)
    Case IISSRV_START
        oFtpSrv.Start
    Case IISSRV_STOP
        oFtpSrv.Stop
    Case IISSRV_PAUSE
        oFtpSrv.Pause
    End Select
      
    Set oFtpSrv = Nothing
    Set oFtpSvc = Nothing
    
    ChangeFtpSrvState = 0
        
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    ChangeFtpSrvState = 1
End Function


Public Function CheckForFtpVirtDir(sHost As String, sServerBinding As String, _
                                   sFtpVirtDirName As String, Optional sFtpSrvName As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
  
    Dim oFtpSvc As Object, oFtpSrv As Object, oFtpRoot As Object, _
        oFtpVirtDir As Object, iFtpSrvNum As Integer, _
        asServerBindings(0) As String
        
    asServerBindings(0) = sServerBinding
    If (sHost = "" Or asServerBindings(0) = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        CheckForFtpVirtDir = 0
        Exit Function
    End If
        
    Set oFtpSvc = GetObject(NS_IIS & sHost & "/msftpsvc")
    RaiseEvent Status("Connected to " & sHost & ".", g_bCancel)

    If (sFtpSrvName = "") Then
        iFtpSrvNum = GetFtpSrvNum(sHost, sServerBinding)
    Else
        iFtpSrvNum = GetFtpSrvNum(sHost, sServerBinding, sFtpSrvName)
    End If
    If (iFtpSrvNum = 0) Then
        '// g_sErrInfo = already set by GetFtpSrvNum
        CheckForFtpVirtDir = 0
        Exit Function
    End If
    
    Set oFtpSrv = oFtpSvc.GetObject("IIsFtpServer", CStr(iFtpSrvNum))
    Set oFtpRoot = oFtpSrv.GetObject("IIsFtpVirtualDir", "Root")
    
    RaiseEvent Status("Checking for requested Ftp Virtual Directory.", g_bCancel)
    If (g_bCancel) Then
        g_sErrInfo = "User cancelled processing."
        CheckForFtpVirtDir = 0
        Exit Function
    End If
    
    If (sFtpVirtDirName = "") Then
        Set oFtpVirtDir = oFtpRoot
    Else
        Set oFtpVirtDir = oFtpRoot.GetObject("IIsFtpVirtualDir", sFtpVirtDirName)
    End If
    
    Set oFtpVirtDir = Nothing
    Set oFtpRoot = Nothing
    Set oFtpSrv = Nothing
    Set oFtpSvc = Nothing
    g_sErrInfo = "FTP Virtual Site Already Exists"
   
    CheckForFtpVirtDir = 1
        
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    Set oFtpVirtDir = Nothing
    Set oFtpRoot = Nothing
    Set oFtpSrv = Nothing
    Set oFtpSvc = Nothing
    CheckForFtpVirtDir = 0
End Function


Public Function CreateFtpSrv(sHost As String, sServerBinding As String, sFtpSrvName As String, _
                             sPath As String, dwAuthFlags As Long, dwAccessFlags As Long) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
  
    Dim oFtpSvc As Object, oFtpSrv As Object, oFtpRoot As Object, oFs As Object, _
        iFtpSrvNum As Integer, asServerBindings(0) As String
        
    asServerBindings(0) = sServerBinding
    If (sHost = "" Or asServerBindings(0) = "" Or sFtpSrvName = "" Or sPath = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        CreateFtpSrv = 1
        Exit Function
    End If
    
    If (asServerBindings(0) = ":21:") Then
        g_sErrInfo = "You supplied the default [unassigned] asServerBindings value, " & _
                    "CreateFtpSrv cannot create a duplicate default Ftp server."
        CreateFtpSrv = 1
        Exit Function
    End If
    
    '// check we are not creating a Ftp server(asServerBindings) that already exits
    iFtpSrvNum = GetFtpSrvNum(sHost, sServerBinding)
    If Not (iFtpSrvNum = 0) Then
        g_sErrInfo = "You provided a asServerBindings of an existing Ftp server."
        CreateFtpSrv = 1
        Exit Function
    End If
    
    '// check we are not creating a Ftp server(sFtpSrvName) that already exits
    iFtpSrvNum = GetFtpSrvNum(sHost, sServerBinding, sFtpSrvName)
    If Not (iFtpSrvNum = 0) Then
        g_sErrInfo = "You provided a sFtpSrvname of an existing Ftp server."
        CreateFtpSrv = 1
        Exit Function
    End If
    
    Set oFtpSvc = GetObject(NS_IIS & sHost & "/msftpsvc")
    RaiseEvent Status("Connected to " & sHost & ".", g_bCancel)
    
    '// now get the next availalbe Ftp server name [number]
    iFtpSrvNum = GetNextFtpSrvNum(sHost)
    If (iFtpSrvNum = 1) Then
        '// g_sErrInfo = already set by GetNextFtpSrvNum
        g_sErrInfo = "You requested a recreate of the default [unassigned] Ftp server."
        CreateFtpSrv = 1
        Exit Function
    End If
    
    RaiseEvent Status("Creating requested Ftp server.", g_bCancel)
    If (g_bCancel) Then
        g_sErrInfo = "User cancelled processing."
        CreateFtpSrv = 1
        Exit Function
    End If
    
    Set oFtpSrv = oFtpSvc.Create("IIsFtpServer", CStr(iFtpSrvNum))
    oFtpSrv.ServerSize = 1 '// fewer than 100k Or medium sized server
    oFtpSrv.ServerBindings(0) = asServerBindings(0)
    oFtpSrv.ServerComment = sFtpSrvName
    
    '// Process dwAuthFlags
    If (dwAuthFlags And AUTH_INHERIT) Then
        '// do nothing just inherit parent settings
    Else
        If (dwAuthFlags And ALLOW_ANON) Then
            oFtpSrv.AllowAnonymous = True
        Else
            oFtpSrv.AllowAnonymous = False
        End If
        If (dwAuthFlags And ANON_ONLY) Then
            oFtpSrv.AnonymousOnly = True
        Else
            oFtpSrv.AnonymousOnly = False
        End If
    End If
    oFtpSrv.SetInfo

    RaiseEvent Status("Creating Root Ftp Virtual Directory.", g_bCancel)
    If (g_bCancel) Then
        g_sErrInfo = "User cancelled processing."
        CreateFtpSrv = 1
        Exit Function
    End If
    
    Set oFtpRoot = oFtpSrv.Create("IIsFtpVirtualDir", "Root")
    oFtpRoot.Path = sPath
    
    '// Ensure physical Path exists
    Set oFs = CreateObject("Scripting.FileSystemObject")
    If Not (oFs.FolderExists(sPath)) Then
        Call oFs.CreateFolder(sPath)
    End If
    Set oFs = Nothing
    
    '// Process dwAccessFlags
    If (dwAccessFlags And ACCESS_INHERIT) Then
        '// do nothing just inherit parent settings
    Else
        If (dwAccessFlags And ACCESS_READ) Then
            oFtpRoot.AccessRead = True
        Else
            oFtpRoot.AccessRead = False
        End If
        If (dwAccessFlags And ACCESS_WRITE) Then
            oFtpRoot.AccessWrite = True
        Else
            oFtpRoot.AccessWrite = False
        End If
        If (dwAccessFlags And LOG_ACCESS) Then
            oFtpRoot.DontLog = False
        Else
            oFtpRoot.DontLog = True
        End If
    End If
    oFtpRoot.SetInfo
    
    oFtpSrv.Start
    
    Set oFtpRoot = Nothing
    Set oFtpSrv = Nothing
    Set oFtpSvc = Nothing
    
    CreateFtpSrv = iFtpSrvNum
        
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    CreateFtpSrv = 1
End Function

Public Function CreateFtpVirtDir(sHost As String, sServerBinding As String, sFtpVirtDirName As String, _
                                 sPath As String, dwAccessFlags As Long, _
                                 Optional sFtpSrvName As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
  
    Dim oFtpSvc As Object, oFtpSrv As Object, oFtpRoot As Object, _
        oFtpVirtDir As Object, oFs As Object, iFtpSrvNum As Integer, _
        asServerBindings(0) As String
        
    asServerBindings(0) = sServerBinding
    If (sHost = "" Or asServerBindings(0) = "" Or sFtpVirtDirName = "" Or sPath = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        CreateFtpVirtDir = 1
        Exit Function
    End If
        
    Set oFtpSvc = GetObject(NS_IIS & sHost & "/msftpsvc")
    RaiseEvent Status("Connected to " & sHost & ".", g_bCancel)

    If (sFtpSrvName = "") Then
        iFtpSrvNum = GetFtpSrvNum(sHost, sServerBinding)
    Else
        iFtpSrvNum = GetFtpSrvNum(sHost, sServerBinding, sFtpSrvName)
    End If
    If (iFtpSrvNum = 0) Then
        '// g_sErrInfo = already set by GetFtpSrvNum
        CreateFtpVirtDir = 1
        Exit Function
    End If
    
    Set oFtpSrv = oFtpSvc.GetObject("IIsFtpServer", CStr(iFtpSrvNum))
    Set oFtpRoot = oFtpSrv.GetObject("IIsFtpVirtualDir", "Root")
    
    RaiseEvent Status("Creating requested Ftp Virtual Directory.", g_bCancel)
    If (g_bCancel) Then
        g_sErrInfo = "User cancelled processing."
        CreateFtpVirtDir = 1
        Exit Function
    End If
    
    Set oFtpVirtDir = oFtpRoot.Create("IIsFtpVirtualDir", sFtpVirtDirName)
    
    '// Ensure physical Path exists
    Set oFs = CreateObject("Scripting.FileSystemObject")
    If Not (oFs.FolderExists(sPath)) Then
        Call oFs.CreateFolder(sPath)
    End If
    Set oFs = Nothing
    oFtpVirtDir.Path = sPath
    
    '// Process dwAccessFlags
    If (dwAccessFlags And ACCESS_INHERIT) Then
        '// do nothing just inherit parent settings
    Else
        If (dwAccessFlags And ACCESS_READ) Then
            oFtpVirtDir.AccessRead = True
        Else
            oFtpVirtDir.AccessRead = False
        End If
        If (dwAccessFlags And ACCESS_WRITE) Then
            oFtpVirtDir.AccessWrite = True
        Else
            oFtpVirtDir.AccessWrite = False
        End If
        If (dwAccessFlags And LOG_ACCESS) Then
            oFtpVirtDir.DontLog = False
        Else
            oFtpVirtDir.DontLog = True
        End If
    End If
    oFtpVirtDir.SetInfo
    
    '// oFtpSrv.Start
    
    Set oFtpVirtDir = Nothing
    Set oFtpRoot = Nothing
    Set oFtpSrv = Nothing
    Set oFtpSvc = Nothing
    
    CreateFtpVirtDir = 0
        
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    CreateFtpVirtDir = 1
End Function

Public Function DeleteFtpSrv(sHost As String, sServerBinding As String, Optional sFtpSrvName As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
  
    Dim oFtpSvc As IADs, iFtpSrvNum As Integer, asServerBindings(0) As String
        
    asServerBindings(0) = sServerBinding
    If (sHost = "" Or asServerBindings(0) = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        DeleteFtpSrv = 1
        Exit Function
    End If
    
    If (asServerBindings(0) = ":21:") Then
        g_sErrInfo = "You supplied the default [unassigned] asServerBindings value, " & _
                    "DeleteFtpSrv cannot delete the default Ftp server."
        DeleteFtpSrv = 1
        Exit Function
    End If
    
    If (sFtpSrvName = "") Then
        iFtpSrvNum = GetFtpSrvNum(sHost, sServerBinding)
    Else '// use sFtpSrvName to find number
        iFtpSrvNum = GetFtpSrvNum(sHost, sServerBinding, sFtpSrvName)
    End If
    
    If (iFtpSrvNum = 0) Then
        '// g_sErrInfo = already set by GetFtpSrvNum
        DeleteFtpSrv = 1
        Exit Function
    End If
    If (iFtpSrvNum = 1) Then
        g_sErrInfo = "Error - you chose to delete the default [unassigned] Ftp server."
        DeleteFtpSrv = 1
        Exit Function
    End If
    
    Set oFtpSvc = GetObject(NS_IIS & sHost & "/msftpsvc")
    RaiseEvent Status("Connected to " & sHost & ".", g_bCancel)
    
    RaiseEvent Status("Deleting requested Ftp server.", g_bCancel)
    If (g_bCancel) Then
        g_sErrInfo = "User cancelled processing."
        DeleteFtpSrv = 1
        Exit Function
    End If
    
    Call oFtpSvc.Delete("IIsFtpServer", CStr(iFtpSrvNum))
    DeleteFtpSrv = 0
        
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    DeleteFtpSrv = 1
End Function

Public Function DeleteFtpVirtDir(sHost As String, sServerBinding As String, sFtpVirtDirName As String, Optional sFtpSrvName As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
  
    Dim oFtpSvc As Object, oFtpSrv As Object, oFtpRoot As Object, iFtpSrvNum As Integer, _
        asServerBindings(0) As String
        
    asServerBindings(0) = sServerBinding
    If (sHost = "" Or asServerBindings(0) = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        DeleteFtpVirtDir = 1
        Exit Function
    End If
    
    Set oFtpSvc = GetObject(NS_IIS & sHost & "/msftpsvc")
    RaiseEvent Status("Connected to " & sHost & ".", g_bCancel)

    If (sFtpSrvName = "") Then
        iFtpSrvNum = GetFtpSrvNum(sHost, sServerBinding)
    Else '// use sFtpSrvName to find number
        iFtpSrvNum = GetFtpSrvNum(sHost, sServerBinding, sFtpSrvName)
    End If
    
    If (iFtpSrvNum = 0) Then
        '// g_sErrInfo = already set by GetFtpSrvNum
        DeleteFtpVirtDir = 1
        Exit Function
    End If
    
    Set oFtpSrv = oFtpSvc.GetObject("IIsFtpServer", CStr(iFtpSrvNum))
    Set oFtpRoot = oFtpSrv.GetObject("IIsFtpVirtualDir", "Root")
    
    RaiseEvent Status("Deleting requested Ftp Virtual Directory.", g_bCancel)
    If (g_bCancel) Then
        g_sErrInfo = "User cancelled processing."
        DeleteFtpVirtDir = 1
        Exit Function
    End If
    
    Call oFtpRoot.Delete("IIsFtpVirtualDir", sFtpVirtDirName)
    DeleteFtpVirtDir = 0
        
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    DeleteFtpVirtDir = 1
End Function


Public Function GetNextFtpSrvNum(sHost As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
    
    Dim oFtpSvc As Object, oFtpSrv As Object, iLastFtpSrvNum As Integer
    
    If (sHost = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        GetNextFtpSrvNum = 1
        Exit Function
    End If
    
    Set oFtpSvc = GetObject(NS_IIS & sHost & "/msftpsvc")
    RaiseEvent Status("Connected to " & sHost & ".", g_bCancel)
    
    For Each oFtpSrv In oFtpSvc
        If (oFtpSrv.Class = "IIsFtpServer") Then
            If (iLastFtpSrvNum < CInt(oFtpSrv.Name)) Then
                iLastFtpSrvNum = CInt(oFtpSrv.Name)
            End If
            RaiseEvent Status("Found Ftp server " & iLastFtpSrvNum & " on " & sHost & ".", g_bCancel)
            If (g_bCancel) Then
                g_sErrInfo = "User cancelled processing."
                GetNextFtpSrvNum = 1
                Exit Function
            End If
        End If
    Next
    
    GetNextFtpSrvNum = iLastFtpSrvNum + 1
    
    Set oFtpSrv = Nothing
    Set oFtpSvc = Nothing

    Exit Function
ErrorHandler:
    g_sErrInfo = g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    GetNextFtpSrvNum = 1
End Function

Public Function GetFtpSrvNum(sHost As String, sServerBinding As String, Optional sFtpSrvName As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
    
    Dim oFtpSvc As Object, oFtpSrv As Object, iFtpSrvNum As Integer, vTemp As Variant, _
        asServerBindings(0) As String
        
    asServerBindings(0) = sServerBinding
    If (sHost = "" Or asServerBindings(0) = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        GetFtpSrvNum = 0
        Exit Function
    End If
    
    Set oFtpSvc = GetObject(NS_IIS & sHost & "/msftpsvc")
    RaiseEvent Status("Connected to " & sHost & ".", g_bCancel)
    
    If (sFtpSrvName = "") Then
        For Each oFtpSrv In oFtpSvc
            If (oFtpSrv.Class = "IIsFtpServer") Then '// catches error generated by "IIsFilters" and "IIsInfo"
                vTemp = oFtpSrv.ServerBindings(0)
                RaiseEvent Status("Checking Ftp server " & oFtpSrv.Name & ".", g_bCancel)
                If (g_bCancel) Then
                    g_sErrInfo = "User cancelled processing."
                    GetFtpSrvNum = 0
                    Exit Function
                End If
                If (InStr(1, vTemp(0), asServerBindings(0), vbTextCompare)) Then
                    GetFtpSrvNum = oFtpSrv.Name '// found desired Ftp server
                    RaiseEvent Status("Found match on Ftp server " & oFtpSrv.Name & ".", g_bCancel)
                    If (g_bCancel) Then
                        g_sErrInfo = "User cancelled processing."
                        GetFtpSrvNum = 0
                        Exit Function
                    End If
                    Exit Function
                End If
            End If
        Next '// oFtpSrv
    Else '// use sFtpSrvName to find number
        For Each oFtpSrv In oFtpSvc
            If (oFtpSrv.Class = "IIsFtpServer") Then '// catches error generated by "IIsFilters" and "IIsInfo"
                If (InStr(1, oFtpSrv.ServerComment, sFtpSrvName, vbTextCompare)) Then
                    GetFtpSrvNum = oFtpSrv.Name '// found desired Ftp server
                    Exit Function
                End If
            End If
        Next '// oFtpSrv
    End If
    
    '// if we made it to here then the Ftp server was not found
    g_sErrInfo = "The specified Ftp server was not found."
    GetFtpSrvNum = 0
    
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    GetFtpSrvNum = 0
End Function

Public Function GetFtpSrvState(sHost As String, sServerBinding As String, _
                               Optional sFtpSrvName As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
  
    Dim oFtpSvc As Object, oFtpSrv As Object, iFtpSrvNum As Integer, _
        asServerBindings(0) As String
        
    asServerBindings(0) = sServerBinding
    If (sHost = "" Or asServerBindings(0) = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        GetFtpSrvState = 0
        Exit Function
    End If
        
    Set oFtpSvc = GetObject(NS_IIS & sHost & "/w3svc")
    RaiseEvent Status("Connected to " & sHost & ".", g_bCancel)

    If (sFtpSrvName = "") Then
        iFtpSrvNum = GetFtpSrvNum(sHost, sServerBinding)
    Else
        iFtpSrvNum = GetFtpSrvNum(sHost, sServerBinding, sFtpSrvName)
    End If
    If (iFtpSrvNum = 0) Then
        '// g_sErrInfo = already set by GetFtpSrvNum
        GetFtpSrvState = 0
        Exit Function
    End If
    
    Set oFtpSrv = oFtpSvc.GetObject("IIsFtpServer", CStr(iFtpSrvNum))
    
    GetFtpSrvState = oFtpSrv.ServerState
      
    Set oFtpSrv = Nothing
    Set oFtpSvc = Nothing
        
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    GetFtpSrvState = 0
End Function

Public Function GetFtpVirtDirWPath(sHost As String, sPath As String, caFtpVDirsFound As Variant) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
    
    Dim oFtpSvc As Object, oFtpSrv As Object, oFtpRoot As Object, _
        oFtpVirtDir As Object, oAdsEntry As Object
        
    If (sHost = "" Or sPath = "" Or IsEmpty(caFtpVDirsFound)) Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        GetFtpVirtDirWPath = 1
        Exit Function
    End If
    
    Set oFtpSvc = GetObject(NS_IIS & sHost & "/msftpsvc")
    RaiseEvent Status("Connected to " & sHost & ".", g_bCancel)
    
    For Each oFtpSrv In oFtpSvc
        If (oFtpSrv.Class = "IIsFtpServer") Then '// catches error generated by "IIsFilters" and "IIsInfo"
            Set oFtpRoot = oFtpSrv.GetObject("IIsFtpVirtualDir", "Root")
            If (InStr(1, oFtpRoot.Path, sPath, vbTextCompare)) Then
                Set oAdsEntry = CreateObject("icuIis4.AdsEntry")
                oAdsEntry.AdsPath = oFtpRoot.AdsPath
                oAdsEntry.Name = oFtpSrv.ServerComment & "_" & oFtpRoot.Name
                oAdsEntry.Path = oFtpRoot.Path
                oAdsEntry.Comment = "FtpRoot with path containing " & sPath
                Call caFtpVDirsFound.Add(oAdsEntry)
                Set oAdsEntry = Nothing
                RaiseEvent Status("Found match number " & caFtpVDirsFound.Count & ".", g_bCancel)
                If (g_bCancel) Then
                    g_sErrInfo = "User cancelled processing."
                    GetFtpVirtDirWPath = 1
                    Exit Function
                End If
            End If
            For Each oFtpVirtDir In oFtpRoot
                If (oFtpVirtDir.Class = "IIsFtpVirtualDir") Then
                    If (InStr(1, oFtpVirtDir.Path, sPath, vbTextCompare)) Then
                        Set oAdsEntry = CreateObject("icuIis4.AdsEntry")
                        oAdsEntry.AdsPath = oFtpVirtDir.AdsPath
                        oAdsEntry.Name = oFtpVirtDir.Name
                        oAdsEntry.Path = oFtpVirtDir.Path
                        oAdsEntry.Comment = "FtpVirtDir with path containing " & sPath
                        Call caFtpVDirsFound.Add(oAdsEntry)
                        Set oAdsEntry = Nothing
                        RaiseEvent Status("Found match number " & caFtpVDirsFound.Count & ".", g_bCancel)
                        If (g_bCancel) Then
                            g_sErrInfo = "User cancelled processing."
                            GetFtpVirtDirWPath = 1
                            Exit Function
                        End If
                    End If
                End If
            Next '// oFtpVirtDir
        End If
    Next '// oFtpSrv
    
    Set oFtpVirtDir = Nothing
    Set oFtpSrv = Nothing
    Set oFtpSvc = Nothing
    
    GetFtpVirtDirWPath = 0
    
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    GetFtpVirtDirWPath = 1
End Function

Public Function ModifyFtpSrv(sHost As String, sServerBinding As String, sFtpVirtDirName As String, _
                             dwAuthFlags As Long, Optional sFtpSrvName As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
  
    Dim oFtpSvc As Object, oFtpSrv As Object, oFtpRoot As Object, _
        oFtpVirtDir As Object, iFtpSrvNum As Integer, _
        asServerBindings(0) As String
        
    asServerBindings(0) = sServerBinding
    If (sHost = "" Or asServerBindings(0) = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        ModifyFtpSrv = 1
        Exit Function
    End If
        
    Set oFtpSvc = GetObject(NS_IIS & sHost & "/w3svc")
    RaiseEvent Status("Connected to " & sHost & ".", g_bCancel)

    If (sFtpSrvName = "") Then
        iFtpSrvNum = GetFtpSrvNum(sHost, sServerBinding)
    Else
        iFtpSrvNum = GetFtpSrvNum(sHost, sServerBinding, sFtpSrvName)
    End If
    If (iFtpSrvNum = 0) Then
        '// g_sErrInfo = already set by GetFtpSrvNum
        ModifyFtpSrv = 1
        Exit Function
    End If
    
    Set oFtpSrv = oFtpSvc.GetObject("IIsFtpServer", CStr(iFtpSrvNum))
    
    RaiseEvent Status("Modifying requested Ftp Virtual Directory.", g_bCancel)
    If (g_bCancel) Then
        g_sErrInfo = "User cancelled processing."
        ModifyFtpSrv = 1
        Exit Function
    End If
        
    '// Process dwAuthFlags
    If (dwAuthFlags And AUTH_INHERIT) Then
        '// do nothing just inherit parent settings
    Else
        If (dwAuthFlags And ALLOW_ANON) Then
            oFtpSrv.AllowAnonymous = True
        Else
            oFtpSrv.AllowAnonymous = False
        End If
        If (dwAuthFlags And ANON_ONLY) Then
            oFtpSrv.AnonymousOnly = True
        Else
            oFtpSrv.AnonymousOnly = False
        End If
    End If
    oFtpSrv.SetInfo
    
    Set oFtpSrv = Nothing
    Set oFtpSvc = Nothing
    
    ModifyFtpSrv = 0
        
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    ModifyFtpSrv = 1
End Function

Public Function ModifyFtpVirtDir(sHost As String, sServerBinding As String, sFtpVirtDirName As String, _
                                 sPath As String, dwAccessFlags As Long, Optional sFtpSrvName As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
  
    Dim oFtpSvc As Object, oFtpSrv As Object, oFtpRoot As Object, _
        oFtpVirtDir As Object, oFs As Object, iFtpSrvNum As Integer, _
        asServerBindings(0) As String
        
    asServerBindings(0) = sServerBinding
    If (sHost = "" Or asServerBindings(0) = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        ModifyFtpVirtDir = 1
        Exit Function
    End If
        
    Set oFtpSvc = GetObject(NS_IIS & sHost & "/w3svc")
    RaiseEvent Status("Connected to " & sHost & ".", g_bCancel)

    If (sFtpSrvName = "") Then
        iFtpSrvNum = GetFtpSrvNum(sHost, sServerBinding)
    Else
        iFtpSrvNum = GetFtpSrvNum(sHost, sServerBinding, sFtpSrvName)
    End If
    If (iFtpSrvNum = 0) Then
        '// g_sErrInfo = already set by GetFtpSrvNum
        ModifyFtpVirtDir = 1
        Exit Function
    End If
    
    Set oFtpSrv = oFtpSvc.GetObject("IIsFtpServer", CStr(iFtpSrvNum))
    Set oFtpRoot = oFtpSrv.GetObject("IIsFtpVirtualDir", "Root")
    
    RaiseEvent Status("Modifying requested Ftp Virtual Directory.", g_bCancel)
    If (g_bCancel) Then
        g_sErrInfo = "User cancelled processing."
        ModifyFtpVirtDir = 1
        Exit Function
    End If
    
    If (sFtpVirtDirName = "") Then
        Set oFtpVirtDir = oFtpRoot
    Else
        Set oFtpVirtDir = oFtpRoot.GetObject("IIsFtpVirtualDir", sFtpVirtDirName)
    End If
            
    If Not (sPath = "") Then '// only if sPath > ""
        '// Ensure physical Path exists
        Set oFs = CreateObject("Scripting.FileSystemObject")
        If Not (oFs.FolderExists(sPath)) Then
            Call oFs.CreateFolder(sPath)
        End If
        Set oFs = Nothing
        oFtpVirtDir.Path = sPath
    End If
               
    '// Process dwAccessFlags
    If (dwAccessFlags And ACCESS_INHERIT) Then
        '// do nothing just inherit parent settings
    Else
        If (dwAccessFlags And ACCESS_READ) Then
            oFtpVirtDir.AccessRead = True
        Else
            oFtpVirtDir.AccessRead = False
        End If
        If (dwAccessFlags And ACCESS_WRITE) Then
            oFtpVirtDir.AccessWrite = True
        Else
            oFtpVirtDir.AccessWrite = False
        End If
        If (dwAccessFlags And LOG_ACCESS) Then
            oFtpVirtDir.DontLog = False
        Else
            oFtpVirtDir.DontLog = True
        End If
    End If
    oFtpVirtDir.SetInfo
    
    Set oFtpVirtDir = Nothing
    Set oFtpRoot = Nothing
    Set oFtpSrv = Nothing
    Set oFtpSvc = Nothing
    
    ModifyFtpVirtDir = 0
        
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    ModifyFtpVirtDir = 1
End Function


