VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "webSvc"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private g_sErrInfo As String, g_bCancel As Boolean

Public Event Status(sStatusInfo As String, ByRef bCancel As Boolean)

Public Property Get ErrInfo() As String
    ErrInfo = g_sErrInfo
End Property

Public Function ChangeWebSrvState(sHost As String, sServerBinding As String, _
                                  lState As Long, Optional sWebSrvName As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
  
    Dim oWebSvc As Object, oWebSrv As Object, iWebSrvNum As Integer, _
        asServerBindings(0) As String
        
    asServerBindings(0) = sServerBinding
    If (sHost = "" Or asServerBindings(0) = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        ChangeWebSrvState = 1
        Exit Function
    End If
        
    Set oWebSvc = GetObject(NS_IIS & sHost & "/w3svc")
    RaiseEvent Status("Connected to " & sHost & ".", g_bCancel)

    If (sWebSrvName = "") Then
        iWebSrvNum = GetWebSrvNum(sHost, sServerBinding)
    Else
        iWebSrvNum = GetWebSrvNum(sHost, sServerBinding, sWebSrvName)
    End If
    If (iWebSrvNum = 0) Then
        '// g_sErrInfo = already set by GetWebSrvNum
        ChangeWebSrvState = 1
        Exit Function
    End If
    
    Set oWebSrv = oWebSvc.GetObject("IIsWebServer", CStr(iWebSrvNum))
    
    Select Case (lState)
    Case IISSRV_START
        oWebSrv.Start
    Case IISSRV_STOP
        oWebSrv.Stop
    Case IISSRV_PAUSE
        oWebSrv.Pause
    End Select
      
    Set oWebSrv = Nothing
    Set oWebSvc = Nothing
    
    ChangeWebSrvState = 0
        
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    ChangeWebSrvState = 1
End Function

Public Function CheckForWebVirtDir(sHost As String, sServerBinding As String, _
                                   sWebVirtDirName As String, Optional sWebSrvName As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
  
    Dim oWebSvc As Object, oWebSrv As Object, oWebRoot As Object, _
        oWebVirtDir As Object, iWebSrvNum As Integer, _
        asServerBindings(0) As String
        
    asServerBindings(0) = sServerBinding
    If (sHost = "" Or asServerBindings(0) = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        CheckForWebVirtDir = 0
        Exit Function
    End If
        
    Set oWebSvc = GetObject(NS_IIS & sHost & "/w3svc")
    RaiseEvent Status("Connected to " & sHost & ".", g_bCancel)

    If (sWebSrvName = "") Then
        iWebSrvNum = GetWebSrvNum(sHost, sServerBinding)
    Else
        iWebSrvNum = GetWebSrvNum(sHost, sServerBinding, sWebSrvName)
    End If
    If (iWebSrvNum = 0) Then
        '// g_sErrInfo = already set by GetWebSrvNum
        CheckForWebVirtDir = 0
        Exit Function
    End If
    
    Set oWebSrv = oWebSvc.GetObject("IIsWebServer", CStr(iWebSrvNum))
    Set oWebRoot = oWebSrv.GetObject("IIsWebVirtualDir", "Root")
    
    RaiseEvent Status("Checking for requested Web Virtual Directory.", g_bCancel)
    If (g_bCancel) Then
        g_sErrInfo = "User cancelled processing."
        CheckForWebVirtDir = 0
        Exit Function
    End If
    
    If (sWebVirtDirName = "") Then
        Set oWebVirtDir = oWebRoot
    Else
        Set oWebVirtDir = oWebRoot.GetObject("IIsWebVirtualDir", sWebVirtDirName)
    End If
    
    Set oWebVirtDir = Nothing
    Set oWebRoot = Nothing
    Set oWebSrv = Nothing
    Set oWebSvc = Nothing
    CheckForWebVirtDir = 1
        
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    Set oWebVirtDir = Nothing
    Set oWebRoot = Nothing
    Set oWebSrv = Nothing
    Set oWebSvc = Nothing
    CheckForWebVirtDir = 0
End Function

Public Function CreateWebSrv(sHost As String, sServerBinding As String, sWebSrvName As String, _
                             sPath As String, dwAuthFlags As Long, dwAccessFlags As Long) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
  
    Dim oWebSvc As Object, oWebSrv As Object, oWebRoot As Object, oFs As Object, _
        iWebSrvNum As Integer, asServerBindings(0) As String
    
    asServerBindings(0) = sServerBinding
    If (sHost = "" Or asServerBindings(0) = "" Or sWebSrvName = "" Or sPath = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        CreateWebSrv = 1
        Exit Function
    End If
    
    If (asServerBindings(0) = ":80:") Then
        g_sErrInfo = "You supplied the default [unassigned] asServerBindings value, " & _
                    "CreateWebSrv cannot create a duplicate default Web server."
        CreateWebSrv = 1
        Exit Function
    End If
    
    '// check we are not creating a Web server(asServerBindings) that already exits
    iWebSrvNum = GetWebSrvNum(sHost, sServerBinding)
    If Not (iWebSrvNum = 0) Then
        g_sErrInfo = "You provided a asServerBindings of an existing Web server."
        CreateWebSrv = 1
        Exit Function
    End If
    
    '// check we are not creating a Web server(sWebSrvName) that already exits
    iWebSrvNum = GetWebSrvNum(sHost, sServerBinding, sWebSrvName)
    If Not (iWebSrvNum = 0) Then
        g_sErrInfo = "You provided a sWebSrvname of an existing Web server."
        CreateWebSrv = 1
        Exit Function
    End If
    
    Set oWebSvc = GetObject(NS_IIS & sHost & "/w3svc")
    RaiseEvent Status("Connected to " & sHost & ".", g_bCancel)
    
    '// now get the next availalbe Web server name [number]
    iWebSrvNum = GetNextWebSrvNum(sHost)
    If (iWebSrvNum = 1) Then
        '// g_sErrInfo = already set by GetNextWebSrvNum
        g_sErrInfo = "You requested a recreate of the default [unassigned] Web server."
        CreateWebSrv = 1
        Exit Function
    End If
    
    RaiseEvent Status("Creating requested Web server.", g_bCancel)
    If (g_bCancel) Then
        g_sErrInfo = "User cancelled processing."
        CreateWebSrv = 1
        Exit Function
    End If

    Set oWebSrv = oWebSvc.Create("IIsWebServer", CStr(iWebSrvNum))
    oWebSrv.ServerSize = 1 '// fewer than 100k Or medium sized server
    oWebSrv.ServerBindings(0) = asServerBindings(0)
    oWebSrv.ServerComment = sWebSrvName
    
    '// Process dwAuthFlags
    If (dwAuthFlags And AUTH_INHERIT) Then
        '// do nothing just inherit parent settings
    Else
        If (dwAuthFlags And AUTH_ANON) Then
            oWebSrv.AuthAnonymous = True
        Else
            oWebSrv.AuthAnonymous = False
        End If
        If (dwAuthFlags And AUTH_BASIC) Then
            oWebSrv.AuthBasic = True
        Else
            oWebSrv.AuthBasic = False
        End If
        If (dwAuthFlags And AUTH_SSPI) Then
            oWebSrv.AuthNtlm = True
        Else
            oWebSrv.AuthNtlm = False
        End If
    End If
    oWebSrv.SetInfo

    RaiseEvent Status("Creating Root Web Virtual Directory.", g_bCancel)
    If (g_bCancel) Then
        g_sErrInfo = "User cancelled processing."
        CreateWebSrv = 1
        Exit Function
    End If
    
    
    Set oWebRoot = oWebSrv.Create("IIsWebVirtualDir", "Root")
    oWebRoot.Path = sPath
    
    '// Ensure physical Path exists
    Set oFs = CreateObject("Scripting.FileSystemObject")
    If Not (oFs.FolderExists(sPath)) Then
        Call oFs.CreateFolder(sPath)
    End If
    Set oFs = Nothing
        
    '// Process dwAccessFlags
    If (dwAccessFlags And ACCESS_INHERIT) Then
        '// do nothing just inherit parent settings
    Else
        If (dwAccessFlags And ACCESS_READ) Then
            oWebRoot.AccessRead = True
        Else
            oWebRoot.AccessRead = False
        End If
        If (dwAccessFlags And ACCESS_WRITE) Then
            oWebRoot.AccessWrite = True
        Else
            oWebRoot.AccessWrite = False
        End If
        If (dwAccessFlags And ACCESS_EXECUTE) Then
            oWebRoot.AccessExecute = True
        Else
            oWebRoot.AccessExecute = False
        End If
        If (dwAccessFlags And ACCESS_SCRIPT) Then
            oWebRoot.AccessScript = True
        Else
            oWebRoot.AccessScript = False
        End If
        If (dwAccessFlags And APP_CREATE) Then
            If (dwAccessFlags And APP_INPROC) Then
                oWebRoot.AppCreate (True)
            Else '// APP_OUTPROC selected
                oWebRoot.AppCreate (False)
            End If
            oWebRoot.AppFriendlyName = "Default Application"
        End If
        If (dwAccessFlags And APP_DELETE) Then
            oWebRoot.AppDelete
        End If
        If (dwAccessFlags And DIR_BROWSE) Then
            oWebRoot.EnableDirBrowsing = True
        Else
            oWebRoot.EnableDirBrowsing = False
        End If
        If (dwAccessFlags And FRONTPAGE_WEB) Then
            oWebSrv.FrontPageWeb = True
            oWebSrv.SetInfo
        Else
            oWebSrv.FrontPageWeb = False
            oWebSrv.SetInfo
        End If
        If (dwAccessFlags And INDEX_DIR) Then
            oWebRoot.ContentIndexed = True
        Else
            oWebRoot.ContentIndexed = False
        End If
        If (dwAccessFlags And LOG_ACCESS) Then
            oWebRoot.DontLog = False
        Else
            oWebRoot.DontLog = True
        End If
    End If
    oWebRoot.SetInfo
    
    oWebSrv.Start
      
    Set oWebRoot = Nothing
    Set oWebSrv = Nothing
    Set oWebSvc = Nothing
    
    CreateWebSrv = iWebSrvNum
        
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    CreateWebSrv = 1
End Function

Public Function CreateWebVirtDir(sHost As String, sServerBinding As String, sWebVirtDirName As String, _
                                 sPath As String, dwAuthFlags As Long, dwAccessFlags As Long, _
                                 Optional sWebSrvName As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
  
    Dim oWebSvc As Object, oWebSrv As Object, oWebRoot As Object, _
        oWebVirtDir As Object, oFs As Object, iWebSrvNum As Integer, _
        asServerBindings(0) As String
        
    asServerBindings(0) = sServerBinding
    If (sHost = "" Or asServerBindings(0) = "" Or sWebVirtDirName = "" Or sPath = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        CreateWebVirtDir = 1
        Exit Function
    End If
        
    Set oWebSvc = GetObject(NS_IIS & sHost & "/w3svc")
    RaiseEvent Status("Connected to " & sHost & ".", g_bCancel)

    If (sWebSrvName = "") Then
        iWebSrvNum = GetWebSrvNum(sHost, sServerBinding)
    Else
        iWebSrvNum = GetWebSrvNum(sHost, sServerBinding, sWebSrvName)
    End If
    If (iWebSrvNum = 0) Then
        '// g_sErrInfo = already set by GetWebSrvNum
        CreateWebVirtDir = 1
        Exit Function
    End If
    
    Set oWebSrv = oWebSvc.GetObject("IIsWebServer", CStr(iWebSrvNum))
    Set oWebRoot = oWebSrv.GetObject("IIsWebVirtualDir", "Root")
    
    RaiseEvent Status("Creating requested Web Virtual Directory.", g_bCancel)
    If (g_bCancel) Then
        g_sErrInfo = "User cancelled processing."
        CreateWebVirtDir = 1
        Exit Function
    End If
    
    Set oWebVirtDir = oWebRoot.Create("IIsWebVirtualDir", sWebVirtDirName)
    oWebVirtDir.Path = sPath
    
    '// Ensure physical Path exists
    Set oFs = CreateObject("Scripting.FileSystemObject")
    If Not (oFs.FolderExists(sPath)) Then
        Call oFs.CreateFolder(sPath)
    End If
    Set oFs = Nothing
    
    '// Process dwAuthFlags
    If (dwAuthFlags And AUTH_INHERIT) Then
        '// do nothing just inherit parent settings
    Else
        If (dwAuthFlags And AUTH_ANON) Then
            oWebVirtDir.AuthAnonymous = True
        Else
            oWebVirtDir.AuthAnonymous = False
        End If
        If (dwAuthFlags And AUTH_BASIC) Then
            oWebVirtDir.AuthBasic = True
        Else
            oWebVirtDir.AuthBasic = False
        End If
        If (dwAuthFlags And AUTH_SSPI) Then
            oWebVirtDir.AuthNtlm = True
        Else
            oWebVirtDir.AuthNtlm = False
        End If
    End If
    
    '// Process dwAccessFlags
    If (dwAccessFlags And ACCESS_INHERIT) Then
        '// do nothing just inherit parent settings
    Else
        If (dwAccessFlags And ACCESS_READ) Then
            oWebVirtDir.AccessRead = True
        Else
            oWebVirtDir.AccessRead = False
        End If
        If (dwAccessFlags And ACCESS_WRITE) Then
            oWebVirtDir.AccessWrite = True
        Else
            oWebVirtDir.AccessWrite = False
        End If
        If (dwAccessFlags And ACCESS_EXECUTE) Then
            oWebVirtDir.AccessExecute = True
        Else
            oWebVirtDir.AccessExecute = False
        End If
        If (dwAccessFlags And ACCESS_SCRIPT) Then
            oWebVirtDir.AccessScript = True
        Else
            oWebVirtDir.AccessScript = False
        End If
        If (dwAccessFlags And APP_CREATE) Then
            If (dwAccessFlags And APP_INPROC) Then
                oWebVirtDir.AppCreate (True)
            Else '// APP_OUTPROC selected
                oWebVirtDir.AppCreate (False)
            End If
            oWebVirtDir.AppFriendlyName = "Default Application"
        End If
        If (dwAccessFlags And APP_DELETE) Then
            oWebVirtDir.AppDelete
        End If
        If (dwAccessFlags And DIR_BROWSE) Then
            oWebVirtDir.EnableDirBrowsing = True
        Else
            oWebVirtDir.EnableDirBrowsing = False
        End If
        If (dwAccessFlags And INDEX_DIR) Then
            oWebVirtDir.ContentIndexed = True
        Else
            oWebVirtDir.ContentIndexed = False
        End If
        If (dwAccessFlags And LOG_ACCESS) Then
            oWebVirtDir.DontLog = False
        Else
            oWebVirtDir.DontLog = True
        End If
    End If
    oWebVirtDir.SetInfo
      
    Set oWebVirtDir = Nothing
    Set oWebRoot = Nothing
    Set oWebSrv = Nothing
    Set oWebSvc = Nothing
    
    CreateWebVirtDir = 0
        
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    CreateWebVirtDir = 1
End Function

Public Function DeleteWebSrv(sHost As String, sServerBinding As String, Optional sWebSrvName As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
  
    Dim oWebSvc As IADs, iWebSrvNum As Integer, asServerBindings(0) As String
    
    asServerBindings(0) = sServerBinding
    If (sHost = "" Or asServerBindings(0) = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        DeleteWebSrv = 1
        Exit Function
    End If
    
    If (asServerBindings(0) = ":80:") Then
        g_sErrInfo = "You supplied the default [unassigned] asServerBindings value, " & _
                     "DeleteWebSrv cannot delete the default Web server."
        DeleteWebSrv = 1
        Exit Function
    End If
    
    If (sWebSrvName = "") Then
        iWebSrvNum = GetWebSrvNum(sHost, sServerBinding)
    Else '// use sWebSrvName to find number
        iWebSrvNum = GetWebSrvNum(sHost, sServerBinding, sWebSrvName)
    End If
    
    If (iWebSrvNum = 0) Then
        '// g_sErrInfo = already set by GetWebSrvNum
        DeleteWebSrv = 1
        Exit Function
    End If
    If (iWebSrvNum = 1) Then
        g_sErrInfo = "Error - you chose to delete the default [unassigned] Web server."
        DeleteWebSrv = 1
        Exit Function
    End If
    
    Set oWebSvc = GetObject(NS_IIS & sHost & "/w3svc")
    RaiseEvent Status("Connected to " & sHost & ".", g_bCancel)
    
    RaiseEvent Status("Deleting requested Web server.", g_bCancel)
    If (g_bCancel) Then
        g_sErrInfo = "User cancelled processing."
        DeleteWebSrv = 1
        Exit Function
    End If
    
    Call oWebSvc.Delete("IIsWebServer", CStr(iWebSrvNum))
    DeleteWebSrv = 0
        
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    DeleteWebSrv = 1
End Function

Public Function DeleteWebVirtDir(sHost As String, sServerBinding As String, sWebVirtDirName As String, Optional sWebSrvName As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
  
    Dim oWebSvc As Object, oWebSrv As Object, oWebRoot As Object, iWebSrvNum As Integer, _
        asServerBindings(0) As String
        
    asServerBindings(0) = sServerBinding
    If (sHost = "" Or asServerBindings(0) = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        DeleteWebVirtDir = 1
        Exit Function
    End If
    
    Set oWebSvc = GetObject(NS_IIS & sHost & "/w3svc")
    RaiseEvent Status("Connected to " & sHost & ".", g_bCancel)

    If (sWebSrvName = "") Then
        iWebSrvNum = GetWebSrvNum(sHost, sServerBinding)
    Else '// use sWebSrvName to find number
        iWebSrvNum = GetWebSrvNum(sHost, sServerBinding, sWebSrvName)
    End If
    
    If (iWebSrvNum = 0) Then
        '// g_sErrInfo = already set by GetWebSrvNum
        DeleteWebVirtDir = 1
        Exit Function
    End If
    
    Set oWebSrv = oWebSvc.GetObject("IIsWebServer", CStr(iWebSrvNum))
    Set oWebRoot = oWebSrv.GetObject("IIsWebVirtualDir", "Root")
    
    RaiseEvent Status("Deleting requested Web Virtual Directory.", g_bCancel)
    If (g_bCancel) Then
        g_sErrInfo = "User cancelled processing."
        DeleteWebVirtDir = 1
        Exit Function
    End If
    
    Call oWebRoot.Delete("IIsWebVirtualDir", sWebVirtDirName)
    DeleteWebVirtDir = 0
        
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    DeleteWebVirtDir = 1
End Function

Public Function GetNextWebSrvNum(sHost As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
    
    Dim oWebSvc As Object, oWebSrv As Object, iLastWebSrvNum As Integer
    
    If (sHost = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        GetNextWebSrvNum = 1
        Exit Function
    End If
    
    Set oWebSvc = GetObject(NS_IIS & sHost & "/w3svc")
    RaiseEvent Status("Connected to " & sHost & ".", g_bCancel)
    
    '//oWebSrv.Name is the instance number of the web.
    
    For Each oWebSrv In oWebSvc
        If (oWebSrv.Class = "IIsWebServer") Then
            If (iLastWebSrvNum < CInt(oWebSrv.Name)) Then '// this logic ensures that the
                iLastWebSrvNum = CInt(oWebSrv.Name)       '// iLastWebSrvNum will be set equal to the highest
            End If                                        '// web instance number so the then GetNextWebSrvNum
                                                          '// can be incremented correctly
            RaiseEvent Status("Found Web server " & iLastWebSrvNum & " on " & sHost & ".", g_bCancel)
            If (g_bCancel) Then
                g_sErrInfo = "User cancelled processing."
                GetNextWebSrvNum = 1
                Exit Function
            End If
        End If
    Next
    
    GetNextWebSrvNum = iLastWebSrvNum + 1
    
    Set oWebSrv = Nothing
    Set oWebSvc = Nothing

    Exit Function
ErrorHandler:
    g_sErrInfo = g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    GetNextWebSrvNum = 1
End Function

Public Function GetWebSrvNum(sHost As String, sServerBinding As String, Optional sWebSrvName As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
    
    Dim oWebSvc As Object, oWebSrv As Object, iWebSrvNum As Integer, vTemp As Variant, _
        asServerBindings(0) As String
    
    asServerBindings(0) = sServerBinding
    If (sHost = "" Or asServerBindings(0) = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        GetWebSrvNum = 0
        Exit Function
    End If
    
    Set oWebSvc = GetObject(NS_IIS & sHost & "/w3svc")
    RaiseEvent Status("Connected to " & sHost & ".", g_bCancel)
    
    If (sWebSrvName = "") Then
        For Each oWebSrv In oWebSvc
            If (oWebSrv.Class = "IIsWebServer") Then '// catches error generated by "IIsFilters" and "IIsInfo"
                vTemp = oWebSrv.ServerBindings(0)
                RaiseEvent Status("Checking Web server " & oWebSrv.Name & ".", g_bCancel)
                If (g_bCancel) Then
                    g_sErrInfo = "User cancelled processing."
                    GetWebSrvNum = 0
                    Exit Function
                End If
                If (InStr(1, vTemp(0), asServerBindings(0), vbTextCompare)) Then
                    GetWebSrvNum = oWebSrv.Name '// found desired Web server
                    RaiseEvent Status("Found match on Web server " & oWebSrv.Name & ".", g_bCancel)
                    If (g_bCancel) Then
                        g_sErrInfo = "User cancelled processing."
                        GetWebSrvNum = 0
                        Exit Function
                    End If
                    Exit Function
                End If
            End If
        Next '// oWebSrv
    Else '// use sWebSrvName to find number
        For Each oWebSrv In oWebSvc
            If (oWebSrv.Class = "IIsWebServer") Then '// catches error generated by "IIsFilters" and "IIsInfo"
                If (InStr(1, oWebSrv.ServerComment, sWebSrvName, vbTextCompare)) Then
                    GetWebSrvNum = oWebSrv.Name '// found desired Web server
                    Exit Function
                End If
            End If
        Next '// oWebSrv
    End If
    
    '// if we made it to here then the Web server was not found
    g_sErrInfo = "The specified Web server was not found."
    GetWebSrvNum = 0
    
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    GetWebSrvNum = 0
End Function

Public Function GetWebSrvState(sHost As String, sServerBinding As String, _
                               Optional sWebSrvName As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
  
    Dim oWebSvc As Object, oWebSrv As Object, iWebSrvNum As Integer, _
        asServerBindings(0) As String
    
    asServerBindings(0) = sServerBinding
    If (sHost = "" Or asServerBindings(0) = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        GetWebSrvState = 0
        Exit Function
    End If
        
    Set oWebSvc = GetObject(NS_IIS & sHost & "/w3svc")
    RaiseEvent Status("Connected to " & sHost & ".", g_bCancel)
    
    If (sWebSrvName = "") Then
        iWebSrvNum = GetWebSrvNum(sHost, sServerBinding)
    Else
        iWebSrvNum = GetWebSrvNum(sHost, sServerBinding, sWebSrvName)
    End If
    If (iWebSrvNum = 0) Then
        '// g_sErrInfo = already set by GetWebSrvNum
        GetWebSrvState = 0
        Exit Function
    End If
    
    Set oWebSrv = oWebSvc.GetObject("IIsWebServer", CStr(iWebSrvNum))
    
    GetWebSrvState = oWebSrv.ServerState
      
    Set oWebSrv = Nothing
    Set oWebSvc = Nothing
        
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    GetWebSrvState = 0
End Function

Public Function GetWebVirtDirWPath(sHost As String, sPath As String, caWebVDirsFound As Variant) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
    
    Dim oWebSvc As Object, oWebSrv As Object, oWebRoot As Object, _
        oWebVirtDir As Object, oAdsEntry As Object
        
    If (sHost = "" Or sPath = "" Or IsEmpty(caWebVDirsFound)) Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        GetWebVirtDirWPath = 1
        Exit Function
    End If
    
    Set oWebSvc = GetObject(NS_IIS & sHost & "/w3svc")
    RaiseEvent Status("Connected to " & sHost & ".", g_bCancel)
    
    For Each oWebSrv In oWebSvc
        If (oWebSrv.Class = "IIsWebServer") Then '// catches error generated by "IIsFilters" and "IIsInfo"
            Set oWebRoot = oWebSrv.GetObject("IIsWebVirtualDir", "Root")
            If (InStr(1, oWebRoot.Path, sPath, vbTextCompare)) Then
                Set oAdsEntry = CreateObject("icuIis4.AdsEntry")
                oAdsEntry.AdsPath = oWebRoot.AdsPath
                oAdsEntry.Name = oWebSrv.ServerComment & "_" & oWebRoot.Name
                oAdsEntry.Path = oWebRoot.Path
                oAdsEntry.Comment = "WebRoot with path containing " & sPath
                Call caWebVDirsFound.Add(oAdsEntry)
                Set oAdsEntry = Nothing
                RaiseEvent Status("Found match number " & caWebVDirsFound.Count & ".", g_bCancel)
                If (g_bCancel) Then
                    g_sErrInfo = "User cancelled processing."
                    GetWebVirtDirWPath = 1
                    Exit Function
                End If
            End If
            For Each oWebVirtDir In oWebRoot
                If (oWebVirtDir.Class = "IIsWebVirtualDir") Then
                    If (InStr(1, oWebVirtDir.Path, sPath, vbTextCompare)) Then
                        Set oAdsEntry = CreateObject("icuIis4.AdsEntry")
                        oAdsEntry.AdsPath = oWebVirtDir.AdsPath
                        oAdsEntry.Name = oWebVirtDir.Name
                        oAdsEntry.Path = oWebVirtDir.Path
                        oAdsEntry.Comment = "WebVirtDir with path containing " & sPath
                        Call caWebVDirsFound.Add(oAdsEntry)
                        Set oAdsEntry = Nothing
                        RaiseEvent Status("Found match number " & caWebVDirsFound.Count & ".", g_bCancel)
                        If (g_bCancel) Then
                            g_sErrInfo = "User cancelled processing."
                            GetWebVirtDirWPath = 1
                            Exit Function
                        End If
                    End If
                End If
            Next '// oWebVirtDir
        End If
    Next '// oWebSrv
    
    Set oWebVirtDir = Nothing
    Set oWebSrv = Nothing
    Set oWebSvc = Nothing
    
    GetWebVirtDirWPath = 0
    
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    GetWebVirtDirWPath = 1
End Function

Public Function ModifyWebVirtDir(sHost As String, sServerBinding As String, sWebVirtDirName As String, _
                                 sPath As String, dwAuthFlags As Long, dwAccessFlags As Long, _
                                 Optional sWebSrvName As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
  
    Dim oWebSvc As Object, oWebSrv As Object, oWebRoot As Object, _
        oWebVirtDir As Object, oFs As Object, iWebSrvNum As Integer, _
        asServerBindings(0) As String
        
    asServerBindings(0) = sServerBinding
    If (sHost = "" Or asServerBindings(0) = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        ModifyWebVirtDir = 1
        Exit Function
    End If
        
    Set oWebSvc = GetObject(NS_IIS & sHost & "/w3svc")
    RaiseEvent Status("Connected to " & sHost & ".", g_bCancel)

    If (sWebSrvName = "") Then
        iWebSrvNum = GetWebSrvNum(sHost, sServerBinding)
    Else
        iWebSrvNum = GetWebSrvNum(sHost, sServerBinding, sWebSrvName)
    End If
    If (iWebSrvNum = 0) Then
        '// g_sErrInfo = already set by GetWebSrvNum
        ModifyWebVirtDir = 1
        Exit Function
    End If
    
    Set oWebSrv = oWebSvc.GetObject("IIsWebServer", CStr(iWebSrvNum))
    Set oWebRoot = oWebSrv.GetObject("IIsWebVirtualDir", "Root")
    
    RaiseEvent Status("Modifying requested Web Virtual Directory.", g_bCancel)
    If (g_bCancel) Then
        g_sErrInfo = "User cancelled processing."
        ModifyWebVirtDir = 1
        Exit Function
    End If
    
    If (sWebVirtDirName = "") Then
        Set oWebVirtDir = oWebRoot
    Else
        Set oWebVirtDir = oWebRoot.GetObject("IIsWebVirtualDir", sWebVirtDirName)
    End If

    If Not (sPath = "") Then '// only if sPath > ""
        '// Ensure physical Path exists
        Set oFs = CreateObject("Scripting.FileSystemObject")
        If Not (oFs.FolderExists(sPath)) Then
            Call oFs.CreateFolder(sPath)
        End If
        Set oFs = Nothing
        oWebVirtDir.Path = sPath
    End If
            
    '// Process dwAuthFlags
    If (dwAuthFlags And AUTH_INHERIT) Then
        '// do nothing just inherit parent settings
    Else
        If (dwAuthFlags And AUTH_ANON) Then
            oWebVirtDir.AuthAnonymous = True
        Else
            oWebVirtDir.AuthAnonymous = False
        End If
        If (dwAuthFlags And AUTH_BASIC) Then
            oWebVirtDir.AuthBasic = True
        Else
            oWebVirtDir.AuthBasic = False
        End If
        If (dwAuthFlags And AUTH_SSPI) Then
            oWebVirtDir.AuthNtlm = True
        Else
            oWebVirtDir.AuthNtlm = False
        End If
    End If
    
    '// Process dwAccessFlags
    If (dwAccessFlags And ACCESS_INHERIT) Then
        '// do nothing just inherit parent settings
    Else
        If (dwAccessFlags And ACCESS_READ) Then
            oWebVirtDir.AccessRead = True
        Else
            oWebVirtDir.AccessRead = False
        End If
        If (dwAccessFlags And ACCESS_WRITE) Then
            oWebVirtDir.AccessWrite = True
        Else
            oWebVirtDir.AccessWrite = False
        End If
        If (dwAccessFlags And ACCESS_EXECUTE) Then
            oWebVirtDir.AccessExecute = True
        Else
            oWebVirtDir.AccessExecute = False
        End If
        If (dwAccessFlags And ACCESS_SCRIPT) Then
            oWebVirtDir.AccessScript = True
        Else
            oWebVirtDir.AccessScript = False
        End If
        If (dwAccessFlags And APP_CREATE) Then
            If (dwAccessFlags And APP_INPROC) Then
                oWebVirtDir.AppCreate (True)
            Else '// APP_OUTPROC selected
                oWebVirtDir.AppCreate (False)
            End If
            oWebVirtDir.AppFriendlyName = "Default Application"
        End If
        If (dwAccessFlags And APP_DELETE) Then
            oWebVirtDir.AppDelete
        End If
        If (dwAccessFlags And DIR_BROWSE) Then
            oWebVirtDir.EnableDirBrowsing = True
        Else
            oWebVirtDir.EnableDirBrowsing = False
        End If
        If (sWebVirtDirName = "") Then
            If (dwAccessFlags And FRONTPAGE_WEB) Then
                oWebSrv.FrontPageWeb = True
                oWebSrv.SetInfo
            Else
                oWebSrv.FrontPageWeb = False
                oWebSrv.SetInfo
            End If
        End If
        If (dwAccessFlags And INDEX_DIR) Then
            oWebVirtDir.ContentIndexed = True
        Else
            oWebVirtDir.ContentIndexed = False
        End If
        If (dwAccessFlags And LOG_ACCESS) Then
            oWebVirtDir.DontLog = False
        Else
            oWebVirtDir.DontLog = True
        End If
    End If
    oWebVirtDir.SetInfo
    
    Set oWebVirtDir = Nothing
    Set oWebRoot = Nothing
    Set oWebSrv = Nothing
    Set oWebSvc = Nothing
    
    ModifyWebVirtDir = 0
        
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    ModifyWebVirtDir = 1
End Function

