VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "postProcess"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private g_sErrInfo As String, g_bCancel As Boolean

Private g_sDsn As String, g_sDboId As String, g_sDboPwd As String, _
        g_sDbName As String, g_sDbTable As String, _
        g_iConnTimeout As Integer, g_iCmdTimeout As Integer
    
Public Event Status(sStatusInfo As String, ByRef bCancel As Boolean)

Public Property Get ErrInfo() As String
    ErrInfo = g_sErrInfo
End Property

Public Property Get Dsn() As String
    Dsn = g_sDsn
End Property

Public Property Let Dsn(ByVal sNewValue As String)
    g_sDsn = sNewValue
End Property

Public Property Get DboId() As String
    DboId = g_sDboId
End Property

Public Property Let DboId(ByVal sNewValue As String)
    g_sDboId = sNewValue
End Property

Public Property Get DboPwd() As String
    Dsn = g_sDboPwd
End Property

Public Property Let DboPwd(ByVal sNewValue As String)
    g_sDboPwd = sNewValue
End Property

Public Property Get DbName() As String
    DbName = g_sDbName
End Property

Public Property Let DbName(ByVal sNewValue As String)
    g_sDbName = sNewValue
End Property

Public Property Get DbTable() As String
    DbTable = g_sDbTable
End Property

Public Property Let DbTable(ByVal sNewValue As String)
    g_sDbTable = sNewValue
End Property

Public Property Get ConnTimeout() As Integer
    ConnTimeout = g_iConnTimeout
End Property

Public Property Let ConnTimeout(ByVal iNewValue As Integer)
    g_iConnTimeout = iNewValue
End Property

Public Property Get CmdTimeout() As Integer
    CmdTimeout = g_iCmdTimeout
End Property

Public Property Let CmdTimeout(ByVal iNewValue As Integer)
    g_iCmdTimeout = iNewValue
End Property

Public Function CheckForRecord(sRemoteUser As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
    
    If (g_sDsn = "" Or g_sDboId = "" Or g_sDboPwd = "" Or g_sDbName = "" Or _
        g_sDbTable = "" Or sRemoteUser = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        CheckForRecord = 0
        Exit Function
    End If
    
    Dim oSqlCmd As Object, oDbRs As Object, _
        sSqlCmd As String, lRet As Long
            
    Set oSqlCmd = CreateObject("icuAdo.sqlCmd")
    Set oDbRs = CreateObject("ADODB.Recordset")
    
    sSqlCmd = "select * from " & g_sDbTable & " where sRemoteUser = '" & sRemoteUser & "'"
    oSqlCmd.ConnTimeout = g_iConnTimeout
    oSqlCmd.CmdTimeout = g_iCmdTimeout
    lRet = oSqlCmd.ExecWRs(g_sDsn, g_sDboId, g_sDboPwd, g_sDbName, sSqlCmd, oDbRs)

    If (lRet) Then '// ado connection errors
        g_sErrInfo = "Ado connection errors."
        Set oDbRs = Nothing
        Set oSqlCmd = Nothing
        CheckForRecord = 0
        Exit Function
    End If
    
    If (oDbRs.EOF) Then
        g_sErrInfo = "Record doesn't exist."
        Set oDbRs = Nothing
        Set oSqlCmd = Nothing
        CheckForRecord = 0
        Exit Function
    End If
    
    Set oDbRs = Nothing
    Set oSqlCmd = Nothing
    CheckForRecord = 1
     
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    CheckForRecord = 0
End Function

Public Function CopyFolder(sSource As String, sDestination As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
    
    If (sSource = "" Or sDestination = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        CopyFolder = 1
        Exit Function
    End If
    
    Dim oFs As Object
    Set oFs = CreateObject("Scripting.FileSystemObject")
    If (oFs.FolderExists(sSource)) Then
        Call oFs.CopyFolder(sSource, sDestination, 1) '// 1 = overwrite existing duplicate files
        CopyFolder = 0
    Else
        '// return error since this routine will fail
        g_sErrInfo = "Source or Destination folder problems exist."
        CopyFolder = 1
    End If
    
    Set oFs = Nothing
    
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    Set oFs = Nothing
    CopyFolder = 1
End Function

Public Function CreateFolder(sFolder As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
    
    If (sFolder = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        CreateFolder = 1
        Exit Function
    End If
    
    Dim oFs
    Set oFs = CreateObject("Scripting.FileSystemObject")
    If (oFs.FolderExists(sFolder)) Then
        '// don't worry about creating it and pass back success
        CreateFolder = 0
    Else
        Call oFs.CreateFolder(sFolder)
        CreateFolder = 0
    End If
    
    Set oFs = Nothing
    
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    CreateFolder = 1
End Function

Public Function DeleteFolder(sFolder As String, bForce As Boolean) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
    
    If (sFolder = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        DeleteFolder = 1
        Exit Function
    End If
    
    Dim oFs
    Set oFs = CreateObject("Scripting.FileSystemObject")
    If (oFs.FolderExists(sFolder)) Then
        Call oFs.DeleteFolder(sFolder, bForce)
        DeleteFolder = 0
    Else
        '// do nothing since the folder does not currently exist
        DeleteFolder = 1
    End If
    
    Set oFs = Nothing
    
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    DeleteFolder = 1
End Function


Public Function CalcHashValue(sString As String, lHashMax As Long) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
    
    If (sString = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        CalcHashValue = 0
        Exit Function
    End If
    
    Dim oHashValue As Object, lHashValue As Long
    
    Set oHashValue = CreateObject("icuUtils.HashValue")
    
    lHashValue = oHashValue.CalcHashValue(sString, lHashMax)
  
    If (lHashValue) Then
        CalcHashValue = lHashValue
    Else
        CalcHashValue = 0
    End If
    
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    CalcHashValue = 0
End Function


Public Function GetMaxUploadSize(sRemoteUser As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
    
    If (g_sDsn = "" Or g_sDboId = "" Or g_sDboPwd = "" Or g_sDbName = "" Or _
        g_sDbTable = "" Or sRemoteUser = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        GetMaxUploadSize = 1
        Exit Function
    End If
    
    Dim oSqlCmd As Object, oDbRs As Object, _
        sSqlCmd As String, lRet As Long
            
    Set oSqlCmd = CreateObject("icuAdo.sqlCmd")
    Set oDbRs = CreateObject("ADODB.Recordset")
    
    sSqlCmd = "select lMaxUploadSize from " & g_sDbTable & " where sRemoteUser = '" & sRemoteUser & "'"
    oSqlCmd.ConnTimeout = g_iConnTimeout
    oSqlCmd.CmdTimeout = g_iCmdTimeout
    lRet = oSqlCmd.ExecWRs(g_sDsn, g_sDboId, g_sDboPwd, g_sDbName, sSqlCmd, oDbRs)

    If (lRet) Then '// ado connection errors
        g_sErrInfo = "Ado connection errors."
        Set oDbRs = Nothing
        Set oSqlCmd = Nothing
        GetMaxUploadSize = 1
        Exit Function
    End If
    
    If (oDbRs.EOF) Then
        GetMaxUploadSize = 0
    Else
        GetMaxUploadSize = oDbRs.Fields("lMaxUploadSize").Value
    End If
     
    Set oDbRs = Nothing
    Set oSqlCmd = Nothing
    
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    GetMaxUploadSize = 1
End Function

Public Function GetUploadSize(oRequest As ASPTypeLibrary.Request) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
    
    If (oRequest.Form("FileName").Count = 0) Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        GetUploadSize = 1
        Exit Function
    End If
    
    Dim nItem As Integer, lUploadSize As Long
    
    lUploadSize = 0
    For nItem = 1 To oRequest.Form("FileName").Count
        lUploadSize = lUploadSize + oRequest.Form("FileSize")(nItem)
    Next '// oRequest.Form("FileName")
    GetUploadSize = lUploadSize
    
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    GetUploadSize = 1
End Function

Public Function GetUploadSizeF(sSource As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
    
    If sSource = "" Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        GetUploadSizeF = 1
        Exit Function
    End If
    
    Dim oFs As Object
    Dim oFold As Object
    
    Set oFs = CreateObject("Scripting.FileSystemObject")
    Set oFold = oFs.GetFolder(sSource)
 
    GetUploadSizeF = oFold.Size
        
    Set oFs = Nothing
    Set oFold = Nothing
    
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    GetUploadSizeF = 1
End Function



Public Function MoveFolder(sSource As String, sDestination As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
    
    If (sSource = "" Or sDestination = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        MoveFolder = 1
        Exit Function
    End If
    
    Dim oFs As Object
    Set oFs = CreateObject("Scripting.FileSystemObject")
    If (oFs.FolderExists(sSource) And Not oFs.FolderExists(sDestination)) Then
        Call oFs.MoveFolder(sSource, sDestination)
        MoveFolder = 0
    Else
        '// return error since this routine will fail
        g_sErrInfo = "Source or Destination folder problems exist."
        MoveFolder = 1
    End If
    
    Set oFs = Nothing
    
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    Set oFs = Nothing
    MoveFolder = 1
End Function

Public Function RemoveDomain(sUserid As String) As String
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
    
    If (sUserid = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        RemoveDomain = ""
        Exit Function
    End If
    
    Dim nSlash As Integer
    
    nSlash = InStr(1, sUserid, "\", vbBinaryCompare)
    If (nSlash) Then
        RemoveDomain = Mid(sUserid, nSlash + 1)
        Exit Function
    End If
    
    nSlash = InStr(1, sUserid, "/", vbBinaryCompare)
    If (nSlash) Then
        RemoveDomain = Mid(sUserid, nSlash + 1)
        Exit Function
    End If
        
    RemoveDomain = sUserid
    
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    RemoveDomain = ""
End Function

Public Function RemoveHttpServerFromUrl(sUrl As String) As String
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
    
    If (sUrl = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        RemoveHttpServerFromUrl = 1
        Exit Function
    End If
    
    Dim nForwardSlash As Integer
    
    nForwardSlash = InStr(Len("http://") + 1, sUrl, "/", vbBinaryCompare)
    If (nForwardSlash) Then
        RemoveHttpServerFromUrl = Mid(sUrl, nForwardSlash)
    Else
        RemoveHttpServerFromUrl = ""
    End If
    
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    RemoveHttpServerFromUrl = ""
End Function

Public Function SetMaxUploadSize(sRemoteUser As String, lMaxUploadSize As Long) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
    
    If (g_sDsn = "" Or g_sDboId = "" Or g_sDboPwd = "" Or g_sDbName = "" Or _
        g_sDbTable = "" Or sRemoteUser = "" Or lMaxUploadSize = 0) Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        SetMaxUploadSize = 1
        Exit Function
    End If
    
    Dim oSqlCmd As Object, oDbRs As Object, _
        sSqlCmd As String, lRet As Long
            
    Set oSqlCmd = CreateObject("icuAdo.sqlCmd")
    Set oDbRs = CreateObject("ADODB.Recordset")
    
    sSqlCmd = "select lMaxUploadSize from " & g_sDbTable & " where sRemoteUser = '" & sRemoteUser & "'"
    oSqlCmd.ConnTimeout = g_iConnTimeout
    oSqlCmd.CmdTimeout = g_iCmdTimeout
    lRet = oSqlCmd.ExecWRs(g_sDsn, g_sDboId, g_sDboPwd, g_sDbName, sSqlCmd, oDbRs)

    If (lRet) Then '// ado connection errors
        g_sErrInfo = "Ado connection errors."
        Set oDbRs = Nothing
        Set oSqlCmd = Nothing
        SetMaxUploadSize = 1
        Exit Function
    End If
    
    If (oDbRs.EOF) Then
        g_sErrInfo = "Record doesn't exist."
        Set oDbRs = Nothing
        Set oSqlCmd = Nothing
        SetMaxUploadSize = 1
        Exit Function
    End If
    
    sSqlCmd = "update " & g_sDbTable & " set " & _
              "lMaxUploadSize = " & lMaxUploadSize & " " & _
              "where sRemoteUser = '" & sRemoteUser & "'"
              
    lRet = oSqlCmd.ExecWoRs(g_sDsn, g_sDboId, g_sDboPwd, g_sDbName, sSqlCmd)
    
    If (lRet) Then
        g_sErrInfo = "Ado connection or update record errors."
        Set oDbRs = Nothing
        Set oSqlCmd = Nothing
        SetMaxUploadSize = 1
        Exit Function
    End If
    
    Set oDbRs = Nothing
    Set oSqlCmd = Nothing
    SetMaxUploadSize = 0
     
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    SetMaxUploadSize = 1
End Function

Public Function StringToHtml(sString As String) As String
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
    
    If (sString = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        StringToHtml = 1
        Exit Function
    End If
    
    Dim iIndex As Integer, sHtml As String, iPosCrLf As Integer
    
    iIndex = 1
    iPosCrLf = 1
    sHtml = ""
    
    While (iPosCrLf)
        iPosCrLf = InStr(iIndex, sString, vbCrLf, vbBinaryCompare)
        If (iPosCrLf) Then
            sHtml = sHtml & Mid(sString, iIndex, iPosCrLf - iIndex) & "<br>"
            iIndex = iPosCrLf + 2
        End If
    Wend
    
    If (iIndex < Len(sString)) Then
        sHtml = sHtml & Mid(sString, iIndex, Len(sString) - iIndex + 1)
    End If
        
    StringToHtml = sHtml
    
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    StringToHtml = ""
End Function

Public Function UpdatePublishTable(sRemoteUser As String, sPublishUrl As String, _
                            lUploadSize As Long, Optional sFullName As String, Optional sEmailId As String, _
                            Optional sDate As String) As Long
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False
    
    If (g_sDsn = "" Or g_sDboId = "" Or g_sDboPwd = "" Or g_sDbName = "" Or _
        g_sDbTable = "" Or sRemoteUser = "" Or sPublishUrl = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        UpdatePublishTable = 1
        Exit Function
    End If
    
    Dim oSqlCmd As Object, oDbRs As Object, oDbField As Object, _
        sSqlCmd As String, sColumns As String, sRecord As String, _
        nRecord As Integer, lRet As Long, bFound As Boolean
    
    Set oSqlCmd = CreateObject("icuAdo.sqlCmd")
    Set oDbRs = CreateObject("ADODB.Recordset")
    
    If (sFullName = "") Then
        sFullName = " "
    Else
        lRet = InStr(1, sFullName, "'", vbBinaryCompare)
        If (lRet) Then '// double up the single quotes for ansiSql92 complience
            sFullName = Left(sFullName, lRet) & Mid(sFullName, lRet)
        End If
    End If
    If (sEmailId = "") Then sEmailId = " "
    If (sDate = "") Then sDate = Format(Now, "Medium Date")
    
    sSqlCmd = "select * from " & g_sDbTable & " " & _
              "where sRemoteUser = '" & sRemoteUser & "'"
              
    oSqlCmd.ConnTimeout = g_iConnTimeout
    oSqlCmd.CmdTimeout = g_iCmdTimeout
    lRet = oSqlCmd.ExecWRs(g_sDsn, g_sDboId, g_sDboPwd, g_sDbName, sSqlCmd, oDbRs)

    If (lRet) Then '// ado connection errors
            g_sErrInfo = "Ado connection errors"
            UpdatePublishTable = 1
            Exit Function
    End If
    
    If Not (oDbRs.EOF) Then '// process update
        '// no need to error out but notify users that published user already existed
        g_sErrInfo = "Record already exists, just need to do an update (i.e. publish time)"
        
        sSqlCmd = "update " & g_sDbTable & " set " & _
                  "sRemoteUser = '" & sRemoteUser & "', " & _
                  "sPublishUrl = '" & sPublishUrl & "', " & _
                  "sFullName = '" & sFullName & "', " & _
                  "sEmailId = '" & sEmailId & "', " & _
                  "sDate = '" & sDate & "', " & _
                  "lUploadSize = " & lUploadSize & " " & _
                  "where sRemoteUser = '" & sRemoteUser & "'"
                  
        lRet = oSqlCmd.ExecWoRs(g_sDsn, g_sDboId, g_sDboPwd, g_sDbName, sSqlCmd)
        
        UpdatePublishTable = 0  '// don't need to error in this case
        
        #If (DEBUGMODE) Then
            '// print out Column[a.k.a. Field] headers
            For Each oDbField In oDbRs.Fields
                sColumns = sColumns & ", " & oDbField.Name
            Next '// oDbField
            Debug.Print sColumns
        
            '// print out Records
            nRecord = 0
            While Not oDbRs.EOF
                For Each oDbField In oDbRs.Fields
                    sRecord = sRecord & ", " & oDbField.Value
                Next '// oDbField
                Debug.Print sRecord
                oDbRs.MoveNext
                nRecord = nRecord + 1 '// keep track of the record number
            Wend
        #End If
        
    Else '// process insert
        sSqlCmd = "insert into " & g_sDbTable & _
                  "(sRemoteUser, sPublishUrl, sFullName, sEmailId, sDate, lUploadSize) " & _
                   "values('" & sRemoteUser & "', " & _
                          "'" & sPublishUrl & "', " & _
                          "'" & sFullName & "', " & _
                          "'" & sEmailId & "', " & _
                          "'" & sDate & "', " & _
                                lUploadSize & ")"
        lRet = oSqlCmd.ExecWoRs(g_sDsn, g_sDboId, g_sDboPwd, g_sDbName, sSqlCmd)
        If (lRet) Then
            g_sErrInfo = "Failed to insert record."
            UpdatePublishTable = 1
        Else
            UpdatePublishTable = 0
        End If
    End If
    
    Set oDbField = Nothing
    Set oDbRs = Nothing
    Set oSqlCmd = Nothing
       
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    UpdatePublishTable = 1
End Function

Public Function VbFormatNow(sFormatName) As String
    On Error GoTo ErrorHandler
    g_sErrInfo = ""
    g_bCancel = False

    If (sFormatName = "") Then
        g_sErrInfo = "A required parameter was passed incorrectly."
        VbFormatNow = ""
        Exit Function
    End If
    
    VbFormatNow = Format(Now, sFormatName)
    
    Exit Function
ErrorHandler:
    g_sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    VbFormatNow = ""
End Function

