Attribute VB_Name = "include"
Option Explicit

'// FileTimeToLocaleTime structure
Public Type stFileTime
        dwLowDateTime As Long
        dwHighDateTime As Long
End Type

'// FileTimeToSystemTime structure
Public Type stSystemTime
        wYear As Integer
        wMonth As Integer
        wDayOfWeek As Integer
        wDay As Integer
        wHour As Integer
        wMinute As Integer
        wSecond As Integer
        wMilliseconds As Integer
End Type
 
'// GetDateFormat values
Public Const LOCALE_USER_DEFAULT = &H400
Public Const LOCALE_SYSTEM_DEFAULT = &H800
Public Const DATE_LONGDATE = &H2
Public Const DATE_SHORTDATE = &H1

'// Maximum Size values
Public Const MAX_VALUENAME_LEN = 256
Public Const MAX_REG_STRING_LEN = 256
Public Const MAX_REG_BINARY_LEN = 256
Public Const MAX_REG_DWORD_LEN = 4
Public Const MAX_DATE_LEN = 256

'// Registry hKey values
Public Const HKEY_CLASSES_ROOT = &H80000000
Public Const HKEY_CURRENT_USER = &H80000001
Public Const HKEY_LOCAL_MACHINE = &H80000002
Public Const HKEY_USERS = &H80000003
Public Const HKEY_PERFORMANCE_DATA = &H80000004
Public Const HKEY_CURRENT_CONFIG = &H80000005
Public Const HKEY_DYN_DATA = &H80000006

'// Registry Type values
Public Const REG_NONE = 0                 '// No value type
Public Const REG_SZ = 1                   '// Unicode null terminated string
Public Const REG_EXPAND_SZ = 2            '// Unicode null terminated string with %environment% references
Public Const REG_BINARY = 3               '// Free form binary
Public Const REG_DWORD = 4                '// 32-bit number
Public Const REG_DWORD_LITTLE_ENDIAN = 4  '// 32-bit number (same as REG_DWORD)
Public Const REG_DWORD_BIG_ENDIAN = 5     '// 32-bit number
Public Const REG_LINK = 6                 '// Symbolic Link (unicode)
Public Const REG_MULTI_SZ = 7             '// Multiple Unicode strings
Public Const REG_RESOURCE_LIST = 8        '// Resource list in the resource map
Public Const REG_FULL_RESOURCE_DESCRIPTOR = 9 '// Resource list in the hardware description
Public Const REG_RESOURCE_REQUIREMENTS_LIST = 10 '// Resource requirements list

'// Registry Open/Create values
Public Const REG_OPTION_RESERVED = 0&     '// Parameter is reserved
Public Const REG_OPTION_NON_VOLATILE = 0& '// Key is preserved when system is rebooted
Public Const REG_OPTION_VOLATILE = 1&     '// Key is not preserved when system is rebooted

'// Registry CreateKey return values
Public Const REG_CREATED_NEW_KEY = 1&     '// New Registry Key created
Public Const REG_OPENED_EXISTING_KEY = 2& '// Existing Key opened

'// Registry Error return values
Public Const ERROR_SUCCESS = 0& '// The operation completed successfully.
Public Const ERROR_FILE_NOT_FOUND = 2& '// The system cannot find the file specified.
Public Const ERROR_ACCESS_DENIED = 5& '// Access is denied.
Public Const ERROR_MORE_DATA = 234& '// More data is available.
Public Const ERROR_NO_MORE_ITEMS = 259& '// No more data is available.
Public Const ERROR_BADDB = 1009& '// The configuration registry database is corrupt.
Public Const ERROR_BADKEY = 1010& '// The configuration registry key is invalid.

'// Registry Access values
Public Const DELETE = &H10000
Public Const READ_CONTROL = &H20000
Public Const SYNCHRONIZE = &H100000
Public Const STANDARD_RIGHTS_REQUIRED = &HF0000
Public Const STANDARD_RIGHTS_READ = (READ_CONTROL)
Public Const STANDARD_RIGHTS_WRITE = (READ_CONTROL)
Public Const STANDARD_RIGHTS_EXECUTE = (READ_CONTROL)
Public Const STANDARD_RIGHTS_ALL = &H1F0000
Public Const KEY_QUERY_VALUE = &H1
Public Const KEY_SET_VALUE = &H2
Public Const KEY_CREATE_SUB_KEY = &H4
Public Const KEY_ENUMERATE_SUB_KEYS = &H8
Public Const KEY_NOTIFY = &H10
Public Const KEY_CREATE_LINK = &H20

Public Const KEY_READ = ((STANDARD_RIGHTS_READ Or _
                        KEY_QUERY_VALUE Or _
                        KEY_ENUMERATE_SUB_KEYS Or _
                        KEY_NOTIFY) _
                                And _
                        (Not SYNCHRONIZE))

Public Const KEY_WRITE = ((STANDARD_RIGHTS_WRITE Or _
                         KEY_SET_VALUE Or _
                         KEY_CREATE_SUB_KEY) _
                                And _
                         (Not SYNCHRONIZE))
                         
Public Const KEY_EXECUTE = ((KEY_READ) _
                                And _
                           (Not SYNCHRONIZE))
                           
Public Const KEY_ALL_ACCESS = ((STANDARD_RIGHTS_ALL Or _
                              KEY_QUERY_VALUE Or _
                              KEY_SET_VALUE Or _
                              KEY_CREATE_SUB_KEY Or _
                              KEY_ENUMERATE_SUB_KEYS Or _
                              KEY_NOTIFY Or _
                              KEY_CREATE_LINK) _
                                    And _
                              (Not SYNCHRONIZE))
                              

Public Declare Function _
        ExpandEnvironmentStrings Lib "kernel32" Alias "ExpandEnvironmentStringsA" _
        (ByVal lpSrc As String, ByVal lpDst As String, ByVal nSize As Long) _
        As Long
        
Public Declare Function _
        FileTimeToLocalFileTime Lib "kernel32" _
        (lptFileTime As stFileTime, lptLocalFileTime As stFileTime) _
        As Long
        
Public Declare Function _
        FileTimeToSystemTime Lib "kernel32" _
        (lptFileTime As stFileTime, lptSystemTime As stSystemTime) _
        As Long

Public Declare Function _
        GetDateFormat Lib "kernel32" Alias "GetDateFormatA" _
        (ByVal Locale As Long, ByVal dwFlags As Long, lpDate As stSystemTime, _
        ByVal lpFormat As String, ByVal lpDateStr As String, ByVal cchDate As Long) _
        As Long

Public Declare Function _
        RegCloseKey Lib "advapi32.dll" _
        (ByVal hKey As Long) As Long

Public Declare Function _
        RegConnectRegistry Lib "advapi32.dll" Alias "RegConnectRegistryA" _
        (ByVal lpMachineName As String, _
        ByVal hKey As Long, phkResult As Long) _
        As Long
        
Public Declare Function _
        RegCreateKeyEx Lib "advapi32.dll" Alias "RegCreateKeyExA" _
        (ByVal hKey As Long, ByVal lpSubKey As String, ByVal Reserved As Long, _
        ByVal lpClass As String, ByVal dwOptions As Long, ByVal samDesired As Long, _
        ByVal lpSecurityAttributes As Long, phkResult As Long, lpdwDisposition As Long) _
        As Long

Public Declare Function _
        RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" _
        (ByVal hKey As Long, ByVal lpSubKey As String) _
        As Long
        
Public Declare Function _
        RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" _
        (ByVal hKey As Long, ByVal lpValueName As String) _
        As Long
        
Public Declare Function _
        RegEnumKeyEx Lib "advapi32.dll" Alias "RegEnumKeyExA" _
        (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, _
        lpcbName As Long, ByVal lpReserved As Long, ByVal lpClass As String, _
        lpcbClass As Long, lpftLastWriteTime As stFileTime) _
        As Long

Public Declare Function _
        RegEnumValue Lib "advapi32.dll" Alias "RegEnumValueA" _
        (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpValueName As String, _
        lpcbValueName As Long, ByVal lpReserved As Long, _
        lpType As Long, lpData As Byte, lpcbData As Long) _
        As Long
        
Public Declare Function _
        RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" _
        (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, _
        ByVal samDesired As Long, phKeyResult As Long) _
        As Long
                             
Public Declare Function _
        RegQueryInfoKey Lib "advapi32.dll" Alias "RegQueryInfoKeyA" _
        (ByVal hKey As Long, ByVal lpClass As String, lpcbClass As Long, _
        ByVal lpReserved As Long, lpcSubKeys As Long, lpMaxSubKeyLen As Long, _
        lpMaxClassLen As Long, lpcValues As Long, _
        lpcbMaxValueNameLen As Long, lpcbMaxValueLen As Long, _
        lpcbSecurityDescriptor As Long, lpftLastWriteTime As stFileTime) _
        As Long
       
Public Declare Function _
        RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" _
        (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, _
        lpType As Long, lpData As Byte, lpcbData As Long) As Long

Public Declare Function _
        RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" _
        (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, _
        ByVal dwType As Long, lpData As Byte, ByVal cbData As Long) _
        As Long

Public Declare Function _
        WNetCancelConnection2 Lib "mpr.dll" Alias "WNetCancelConnection2A" _
        (ByVal lpName As String, ByVal dwFlags As Long, ByVal fForce As Boolean) _
        As Long

