// Error.cpp : Implementation of CError
#include "stdafx.h"
#include "IcuUtils.h"
#include "Error.h"

// additions
#include <lmErr.h>  // used by DisplayLastError()


/////////////////////////////////////////////////////////////////////////////
// CError

STDMETHODIMP CError::DisplayLastErrorInfo(BSTR sApiThatFailed)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    HMODULE hModule = NULL; // default to system source
    DWORD dwLastError = GetLastError();
    LPTSTR lpszMessageBuffer;
    DWORD dwBufferLength;
	#define MAX_BUFF sizeof(_TCHAR) * 256
	TCHAR szText[MAX_BUFF] = {_T("\0")},
		  szCaption[MAX_BUFF] = {_T("\0")};

    DWORD dwFormatFlags = FORMAT_MESSAGE_ALLOCATE_BUFFER |
						  FORMAT_MESSAGE_IGNORE_INSERTS |
						  FORMAT_MESSAGE_FROM_SYSTEM ;

    //
    // if dwLastError is in the network range, load the message source
    //
    if (dwLastError >= NERR_BASE && dwLastError <= MAX_NERR) 
	{
        hModule = LoadLibraryEx(TEXT("netmsg.dll"), NULL, LOAD_LIBRARY_AS_DATAFILE);

        if(hModule != NULL)
			dwFormatFlags |= FORMAT_MESSAGE_FROM_HMODULE;
    }

    // printf("%s error! (rc=%lu)\n", m_sApiThatErrored, dwLastError);  // console applications
	wsprintf(szText, TEXT("Calling the \"%s\" Api produced error number\t\t\n\n-> %lu"), sApiThatFailed, dwLastError);
	wsprintf(szCaption, TEXT("Display Last Error"));
	MessageBox(NULL, szText, szCaption,  MB_OK | MB_ICONINFORMATION); // window applications
		
    // call FormatMessage() to allow for message text to be acquired
    // from the system or the supplied module handle
    if (dwBufferLength = FormatMessage(dwFormatFlags, hModule, // module to get message from (NULL == system)
									   dwLastError, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // default language
									   (LPTSTR)&lpszMessageBuffer, 0, NULL))
    {
        // Output message string on stderr
		#ifdef _DEBUG
			DWORD dwBytesWritten;
			WriteFile(GetStdHandle(STD_ERROR_HANDLE), lpszMessageBuffer, dwBufferLength,
					  &dwBytesWritten, NULL);
		#endif

		// Output message string to MessageBox
		wsprintf(szText, TEXT("Calling the \"%s\" Api produced error text\t\t\n\n-> %s"), sApiThatFailed, lpszMessageBuffer);
		wsprintf(szCaption, TEXT("Display Last Error"));
		MessageBox(NULL, szText, szCaption,  MB_OK | MB_ICONINFORMATION); // window applications
        
        // free the buffer allocated by the system
        LocalFree(lpszMessageBuffer);
    }

    // if we loaded a message source, unload it
    if (hModule != NULL)
		FreeLibrary(hModule);

	return S_OK;
}
