// HashValue.cpp : Implementation of CHashValue
#include "stdafx.h"
#include "IcuUtils.h"
#include "HashValue.h"

/////////////////////////////////////////////////////////////////////////////
// CHashValue

STDMETHODIMP CHashValue::CalcHashValue(BSTR sString, long *plHashMax, long *plHashValue)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// unixElf hash algorithm was pulled from the internet
	LPTSTR lpszString = NULL;
	LONG lHashValue = 0, lTemp = 0;

	lpszString = _tcslwr(sString);  
	// convert string to lower case so we always return
	// the same hash value result irregardless of case

	while(*lpszString) // while index into byte array representation of the string
	{					 // parameter passed to function is not at the null terminator
		lHashValue = (lHashValue << 4); // lHashValue = lHashValue * 2^4
		lHashValue += *lpszString++;  // lHashValue = lHashValue + ascii value of next charater
		if (lTemp = lHashValue & 0xF0000000) // = if lHashValue's 4th byte is 11110000
											 // (i.e. = F0) then set lTemp = 0xF0000000 and do if statement
											 // I'm not sure how lHashValue can equal this since
											 // it would imply that it has become a negative
											 // value if its last bit is set to 1 and it is
											 // a LONG versus a ULONG, walk through values
											 // in debug mode and see what causes it to 
											 // go negative
			lHashValue ^= lTemp >> 24;	// lHashValue = lHashValue Or (lTemp \ 2^24)

		lHashValue &= ~lTemp; // lHashValue = lHashValue & (ones compliment of lTemp)
	}
	lHashValue %= *plHashMax; // lHashValue = raw remainder (modulus) of lHashValue \ lHashMax

	*plHashValue = lHashValue; // assign calculated has value to return value

	return S_OK;
}

