// ShortCut.h : Declaration of the CShortCut

#ifndef __SHORTCUT_H_
#define __SHORTCUT_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CShortCut
class ATL_NO_VTABLE CShortCut : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CShortCut, &CLSID_ShortCut>,
	public ISupportErrorInfo,
	public IDispatchImpl<IShortCut, &IID_IShortCut, &LIBID_icuUtils>
{
public:
	CShortCut()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_SHORTCUT)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CShortCut)
	COM_INTERFACE_ENTRY(IShortCut)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IShortCut
public:
	STDMETHOD(get_Description)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_Description)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_WorkingDir)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_WorkingDir)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_Arguments)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_Arguments)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_Path)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_Path)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_Link)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_Link)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_FoundHelpArg)(/*[out, retval]*/ BOOL *pVal);
	STDMETHOD(put_FoundHelpArg)(/*[in]*/ BOOL newVal);
	STDMETHOD(get_FoundCmdLineArg)(/*[out, retval]*/ BOOL *pVal);
	STDMETHOD(put_FoundCmdLineArg)(/*[in]*/ BOOL newVal);
	STDMETHOD(get_CmdLine)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_CmdLine)(/*[in]*/ BSTR newVal);
	STDMETHOD(CreateOrModify)();
	STDMETHOD(ParseCmdLine)();
	CString m_sDescription;
	CString m_sWorkingDir;
	CString m_sArguments;
	CString m_sPath;
	CString m_sLink;
	BOOL m_bFoundHelpArg;
	BOOL m_bFoundCmdLineArg;
	CString m_sCmdLine;
};

#endif //__SHORTCUT_H_
