// Adapters.h: interface for the CAdapters class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ADAPTERS_H__CA3483F0_1965_11D3_B7D6_0080C771AFE4__INCLUDED_)
#define AFX_ADAPTERS_H__CA3483F0_1965_11D3_B7D6_0080C771AFE4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "define.h"
#include <ipHlpApi.h>
#include <winsock2.h>
#include <lmerr.h>  // for used by DumpFormatMessage/FormatMessage calls
#include <math.h>  // used by List/pow calls

class CAdapters  
{
public:
	HRESULT CloseRegKey(LPCTSTR psuHostName, HKEY hKey, HKEY hSubKey);
	HRESULT OpenRegKey(LPCTSTR psuHostName, HKEY hKey, LPCTSTR psuSubKey, DWORD dwSamDesired, PHKEY phSubKey);
	HRESULT SetIfIpRegValue(LPCTSTR psuIfName, LPCTSTR psuValueName, DWORD dwValueType, LPCTSTR psuValue);  // todo - switch to , VARIANT *pvValue)
	HRESULT ChgIfIpMultiValue(LPTSTR psuValue, LPCTSTR psuEntry, BOOL bAdd, BOOL bDupesAllowed, BOOL *pbEntryFound);
	HRESULT GetIfIpRegValue(LPCTSTR psuIfName, LPCTSTR psuValueName, DWORD dwValueType, LPTSTR psuValue);  // todo - switch to , VARIANT *pvValue)

	HRESULT GetIpAddrContext(DWORD dwIfIndex, LPCTSTR psuInet, LPCTSTR psuNetmask, DWORD *pdwIpAddrContext);
	HRESULT GetIfDhcpMac(DWORD dwIfIndex, DWORD *pdwDhcpMac);
	HRESULT GetIfDhcpMode(DWORD dwIfIndex, DWORD *pdwDhcpEnabled);
	HRESULT GetIfName(DWORD dwIfIndex, LPTSTR psuIfName);
	HRESULT GetIfIndex(LPCTSTR psuIf, DWORD *pdwIfIndex);

	HRESULT ChgIfGwAddr(LPCTSTR psuIf, LPCTSTR psuInet, LPCTSTR psuNetmask, LPCTSTR psuGw, BOOL bAdd, BOOL bPersist);
	HRESULT ChgIfIpAddr(LPCTSTR psuIf, LPCTSTR psuInet, LPCTSTR psuNetmask, BOOL bAdd, BOOL bPersist);
	HRESULT ChgIfDhcpMac(LPCTSTR psuIf, DWORD dwDhcpMac);
	HRESULT ChgIfDhcpAddr(LPCTSTR psuIf, DWORD dwDhcpEnabled, BOOL bPersist);
	HRESULT ChgIfDhcpStatus(LPCTSTR psuIf, BOOL bRenew);
	HRESULT ChgIfStatus(LPCTSTR psuIf, BOOL bUp);
	HRESULT List(LPCTSTR psuIfArg);
	
	HRESULT IpHexToString(DWORD dwIpAddr, LPTSTR psuIpAddr);
	HRESULT IpStringToHex(LPCTSTR psuIpAddr, DWORD *pdwIpAddr);

	HRESULT DisplayFormatMessage(DWORD dwMessageId);
	
	CAdapters();
	virtual ~CAdapters();
};

#endif // !defined(AFX_ADAPTERS_H__CA3483F0_1965_11D3_B7D6_0080C771AFE4__INCLUDED_)
