// global defines used throughout classes

using namespace std;  // for use by wcout statements

// miscellaneous defines
#define GET_LAST_ERROR			0x0

// miscellaneous buffer sizes
#define MAX_CB_BUFFER			255
#define MAX_CB_ERRORINFO		255
#define MAX_CB_NBHOSTNAME		15

// ip address length and buffer sizes
#define MAX_CB_OCTET			3
#define MAX_CB_IPADDRESS		16
#define MAX_IPADDRESSES			100  // maximum number of ip addresses we will allow
#define MAX_CB_REG_MULTI_SZ		(MAX_CB_IPADDRESS * MAX_IPADDRESSES)
#define MAX_CB_REG_SZ			(MAX_CB_BUFFER)
#define MAX_CB_IF				4	// ifconfig shortform i.e. "if0"
#define MAX_CB_IFNAME			38  // adapter guid string
#define	MAX_CB_REG_VALUENAME	32

// command line argument switches bit masks
#define ARG_HELP			0X00000001
#define ARG_IF				0X00000002
#define ARG_IF_ALL			0X00000004
#define ARG_IF_ALL_UP		0X00000008
#define ARG_IF_ALL_DOWN		0X00000010
#define ARG_UP				0X00000020
#define ARG_DOWN			0x00000040
#define ARG_RENEW			0X00000080
#define ARG_RELEASE			0x00000100
#define ARG_DHCP			0X00000200
#define ARG_DHCPMAC			0X00000400
#define ARG_INET			0X00000800
#define ARG_NETMASK			0X00001000
#define ARG_GW				0X00002000
#define ARG_ADD				0X00004000
#define ARG_DEL				0x00008000
#define ARG_PERSIST			0x00010000
#define ARG_ALL  (ARG_HELP | \
				  ARG_IF | ARG_IF_ALL | ARG_IF_ALL_UP | ARG_IF_ALL_DOWN | \
				  ARG_UP | ARG_DOWN | ARG_RENEW | ARG_RELEASE | \
				  ARG_DHCP | ARG_DHCPMAC | ARG_INET | ARG_NETMASK | ARG_GW | \
				  ARG_ADD | ARG_DEL | ARG_PERSIST)

