// shortCut.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "shortCut.h"
#include "shortCutDlg.h"

// additions
#include "HelpDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CShortCutApp

BEGIN_MESSAGE_MAP(CShortCutApp, CWinApp)
	//{{AFX_MSG_MAP(CShortCutApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CShortCutApp construction

CShortCutApp::CShortCutApp()
{
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CShortCutApp object

CShortCutApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CShortCutApp initialization

BOOL CShortCutApp::InitInstance()
{
	AfxEnableControlContainer();
	
	// Initialize COM
	CoInitialize(NULL);

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	HRESULT hr = E_FAIL;
	CComPtr<IShortCut> pShortCut;

	hr = pShortCut.CoCreateInstance(__uuidof(ShortCut), NULL, CLSCTX_ALL);
	if(FAILED(hr)) return hr;

	// pass applications command line string to object
	hr = pShortCut->put_CmdLine(::GetCommandLine());

	// parse the command line to extract the arguments
	hr = pShortCut->ParseCmdLine();
	if (FAILED(hr)) return hr;
	
	BOOL bFoundCmdLineArg = FALSE, bFoundHelpArg = FALSE;
	hr = pShortCut->get_FoundCmdLineArg( (long *) &bFoundCmdLineArg );
	hr = pShortCut->get_FoundHelpArg( (long *) &bFoundHelpArg );

	if (bFoundCmdLineArg && (!bFoundHelpArg))
	// run console mode if command lines args found but not the help command line argument
	{
		hr = pShortCut->CreateOrModify();
		if (FAILED(hr)) return hr;
	}
	else // display help | gui mode dialog
	{
		if (bFoundHelpArg)
		{
			/* display help dialog box with the following information
			Use to create create shell links from a command line | gui | script.
			Cmd line usage:  shortcut /l <link path> /p <command path> [/a <arguments>]
			\n\t\t\t[/w <working directory>] [/d <description>]
			Cmd line example:  shortcut /l c:\temp\Text Editor.lnk /p notepad.exe /d my Text Editor shell link!
			Gui usage:  shortcut (with no arguments)
			Script usage:  cscript shortcut.js
			Author:  robertob@microsoft.com
			Version:  31Jan99
			*/
			CHelpDlg oHelpDlg;
			m_pMainWnd = &oHelpDlg;
			int nRet = oHelpDlg.DoModal();
			if (nRet == IDOK)
			{
				// do nothing but exit dialog
			}
		}
		else
		{
			CShortCutDlg oShortCutDlg;
			m_pMainWnd = &oShortCutDlg;
			int nRet = oShortCutDlg.DoModal();
			if (nRet == IDCANCEL)
			{
				// do nothing but exit dialog
			}
		}
	}

	// release the IShortCut interface pointer
	pShortCut.Release();

	// UnInitialize COM
	CoUninitialize();

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}
