// shortCutDlg.cpp : implementation file
//

#include "stdafx.h"
#include "shortCut.h"
#include "shortCutDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CShortCutDlg dialog

CShortCutDlg::CShortCutDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CShortCutDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CShortCutDlg)
	m_sArguments = _T("");
	m_sDescription = _T("");
	m_sLink = _T("");
	m_sPath = _T("");
	m_sWorkingDir = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CShortCutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CShortCutDlg)
	DDX_Text(pDX, IDC_ARGUMENTS, m_sArguments);
	DDX_Text(pDX, IDC_DESCRIPTION, m_sDescription);
	DDX_Text(pDX, IDC_LINK, m_sLink);
	DDX_Text(pDX, IDC_PATH, m_sPath);
	DDX_Text(pDX, IDC_WORKINGDIR, m_sWorkingDir);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CShortCutDlg, CDialog)
	//{{AFX_MSG_MAP(CShortCutDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_DESTROY()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CShortCutDlg message handlers

BOOL CShortCutDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CShortCutDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CShortCutDlg::OnDestroy()
{
	WinHelp(0L, HELP_QUIT);
	CDialog::OnDestroy();
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CShortCutDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CShortCutDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CShortCutDlg::OnOK() 
{
	HRESULT hr = E_FAIL;
	CComPtr<IShortCut> pShortCut;

	hr = pShortCut.CoCreateInstance(__uuidof(ShortCut), NULL, CLSCTX_ALL);
	if (FAILED(hr))
		MessageBox(_T("Internal application error creating CProcess object."), _T("Error!"), (MB_ICONERROR | MB_OK));
	
	CShortCutDlg::UpdateData(TRUE);
	hr = pShortCut->put_Link( m_sLink.GetBuffer( m_sLink.GetLength() ) );
	pShortCut->put_Path( m_sPath.GetBuffer( m_sPath.GetLength() ) );
	pShortCut->put_Arguments( m_sArguments.GetBuffer( m_sArguments.GetLength() ) );
	pShortCut->put_WorkingDir( m_sWorkingDir.GetBuffer( m_sWorkingDir.GetLength() ) );
	pShortCut->put_Description( m_sDescription.GetBuffer( m_sDescription.GetLength() ) );
	// now process shell link request expecting CreateOrModify 
	// routine to validate arguments collected from gui
	hr = pShortCut->CreateOrModify();
	if (FAILED(hr)) 
		MessageBox(_T("Unable to create or modify shell link."), _T("Error!"), (MB_ICONERROR | MB_OK));
	else
		MessageBox(_T("Specified shell link was created or modified."), _T("Success"), (MB_ICONINFORMATION | MB_OK));

	// Commented out following because we don't want application to close
	// CDialog::OnOK();
}
